--
-- Aardvark
-- Version: AR 9.2.8.3
-- Author: walkerbo.saurfang@gmail.com
-- Date: Friday 17 April 2020
--

-- I have tried to name variables, functions, frames, and buttons to be more descriptive

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Metrics, Lists & Variables          ===========================
-- ===================================================================================================
-- ===================================================================================================

local addonName = 'Aardvark'
local versionNumber = 'AR 9.2.8.3'
local playerName = GetUnitName('player')

local ActionBarButtons = {
    AardvarkActionBar,
    AardvarkMagicButton,
    ActionBarAardvarkButton,
    ActionBarDestroyButton,
    ActionBarDestroyCharacterButton,
    ActionBarDestroyGlobalButton,
    ActionBarProtectCharacterButton,
    ActionBarProtectGlobalButton,
    ActionBarSellButton,
    ActionBarSellCharacterButton,
    ActionBarSellGlobalButton
}

-- floating button and action bar buttons - debug
local ActionBarAardvarkButton,
    ActionBarDestroyButton,
    ActionBarDestroyCharacterButton,
    ActionBarDestroyGlobalButton,
    ActionBarProtectCharacterButton,
    ActionBarProtectGlobalButton,
    ActionBarSellButton,
    ActionBarSellCharacterButton,
    ActionBarSellGlobalButton,
    AardvarkActionBar,
    AardvarkMagicButton

-- ===========================         table of variables          ===========================
local VariableList = {
    currentItemID = 0,
    currentItemLink = '',
    currentItemList = '',
    profitCounter = 0,
    repairAmount = 0,
    repairMessageType = '',
    tempCharacterDestroyTable = {},
    tempCharacterProtectTable = {},
    tempCharacterSellTable = {},
    tempGlobalDestroyTable = {},
    tempGlobalProtectTable = {},
    tempGlobalSellTable = {},
    tempItemList = {},
    twelveCounter = 0,
    vendorClosed = true
}

-- ===========================         table of images          ===========================
local ImageList = {
    avkBanner = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkBanner', --  Aardvark Banner
    avkButton = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkButton', --  Aardvark Buttons
    avkButtonHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkButtonHover',
    avkCloseButton = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkCloseButton',
    avkCloseButtonHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkCloseButtonHover',
    destroyButton = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyButton', -- Aardvark Destroy Buttons
    destroyButtonHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyButtonHover',
    destroyCharacter = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyCharacter',
    destroyCharacterHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyCharacterHover',
    destroyFilters = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyFilters',
    destroyFiltersHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyFiltersHover',
    destroyGlobal = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyGlobal',
    destroyGlobalHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyGlobalHover',
    destroyOptions = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyOptions',
    destroyOptionsHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyOptionsHover',
    destroySpecialAdd = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroySpecialAdd',
    destroySpecialAddHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroySpecialAddHover',
    protectButton = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectButton', -- Aardvark Protect Buttons
    protectButtonHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectButtonHover',
    protectCharacter = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectCharacter',
    protectCharacterHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectCharacterHover',
    protectFilters = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectFilters',
    protectFiltersHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectFiltersHover',
    protectGlobal = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectGlobal',
    protectGlobalHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectGlobalHover',
    protectOptions = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectOptions',
    protectOptionsHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectOptionsHover',
    protectSpecialAdd = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectSpecialAdd',
    protectSpecialAddHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectSpecialAddHover',
    repairButton = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\repairButton', -- Aardvark Repair Buttons
    repairButtonHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\repairButtonHover',
    sellButton = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellButton', -- Aardvark Sell Buttons
    sellButtonHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellButtonHover',
    sellCharacter = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellCharacter',
    sellCharacterHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellCharacterHover',
    sellFilters = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellFilters',
    sellFiltersHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellFiltersHover',
    sellGlobal = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellGlobal',
    sellGlobalHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellGlobalHover',
    sellOptions = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOptions',
    sellOptionsHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOptionsHover',
    sellOutOfRange = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOutOfRange',
    sellSpecialAdd = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellSpecialAdd',
    sellSpecialAddHover = 'Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellSpecialAddHover'
}

-- Font objects  - debug
local FontCheckBoxBig = CreateFont('FontCheckBoxBig')
FontCheckBoxBig:SetFont('Interface\\AddOns\\Aardvark\\Files\\Fonts\\neuropol.ttf', 29)
local FontCheckBox = CreateFont('FontCheckBox')
FontCheckBox:SetFont('Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF', 17)
local FontContent = CreateFont('FontContent')
FontContent:SetFont('Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF', 14.7)
local FontFilter = CreateFont('FontFilter')
FontFilter:SetFont('Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF', 15)
local FontTitleScroll = CreateFont('FontTitleScroll')
FontTitleScroll:SetFont('Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF', 20)
local FontButton = CreateFont('FontButton')
FontButton:SetFont('Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF', 15)

-- ===========================         table of font colours          ===========================
local ColourList = {
    rarityArtifact = '|cffe6cc80', --  Artifact rgb(230, 204, 128)
    rarityCommon = '|cffffffff', -- Common rgb(255, 255, 255)
    rarityEpic = '|cffa335ee', -- Epic rgb(163, 53, 238)
    rarityHeirloom = '|cff00ccff', --  Heirloom rgb(0, 204, 255)
    rarityLegendary = '|cffff8000', --  Legendary rgb(255, 128, 0)
    rarityOther = '|cff00ccff', --  Other rgb(100, 0, 0)
    rarityPoor = '|cff9d9d9d', --  Poor rgb(157, 157, 157)
    rarityRare = '|cff0070dd', --  Rare rgb(0, 112, 221)
    rarityUncommon = '|cff1eff00', --  Uncommon rgb(30, 255, 0)
    textBlue = '|cff00ffff', -- rgb(0,255,255)
    textBluePrefix = '|cff00ffff [' .. addonName .. ']: ', -- rgb(0,255,255)
    textBluePrefixSuffix = '|cff00ffff [' .. addonName .. ']: |r', -- rgb(0,255,255)
    textGreen = '|cff00ff00', -- rgb(0,255,0)
    textOrange = '|cffff8c00', -- rgb(255,140,0)
    textPink = '|cffff00ff', -- rgb(255,0,255)
    textRed = '|cffff0000', -- rgb(255,0,0)
    textYellow = '|cfffffff0' -- rgb(255,255,0)
}

-- ===========================         table of strings          ===========================
local TextList = {
    avkLoad = (ColourList.textBlue .. ' *** ' .. addonName .. ' - ' .. versionNumber .. ' Loaded *** \n'), -- Load Message
    avkOptions = ('Slash Commands:\n' ..
        ColourList.textBlue ..
            '/avk |r ~  Show/Hide Aardvark frame\n' ..
                ColourList.textBlue ..
                    '/avkdestroy |r ~  Destroy function\n' ..
                        ColourList.textBlue ..
                            '/avkclear |r ~  Clear all lists\n' ..
                                ColourList.textBlue .. '/avkpos |r ~  Reset Aardvark frame and button positions\n'), -- Options Text
    avkSellOptions = ('The ' ..
        ColourList.textGreen ..
            'Aardvark Sell|r function can sometimes lag depending on the size of your list and the number items you have in your bags.\n\nIf this occurs turn on the  action bar and spam the sell button.\n\nI will continue to tinker with the sell function to try and remove this issue.'), -- Sell Text
    avkDestroyOptions = ('The ' ..
        ColourList.textRed ..
            'Aardvark Destroy|r function will destroy|r the items that you have added to your destroy lists regardless of bind, value, rarity or colour.\n\n' ..
                ColourList.textRed ..
                    "Destroyed items CANNOT be recovered.|r\n\nThere are no take backs, no do-overs, no whoops didn't mean to do that, etc.\n\nThe only way to  recover a destroyed item is to go and farm it again.\n\n" ..
                        ColourList.textRed .. 'You have been warned!'), -- Destroy Text
    avkRepairOptions = ('The ' ..
        ColourList.textPink ..
            'Aardvark Repair|r function operates after the destroy function and prior to the\n sell function.\n\n Damaged items must\n be repaired before\n they can  be sold.'), -- Repair Text
    avkProtectOptions = ('The ' ..
        ColourList.textOrange ..
            'Aardvark Protect|r function was created to protect those special items that you want to ensure are not sold or destroyed even if they are listed in your other sell and/or destroy lists.\n\nThe protect lists have no restrictions which means you can protect any item regardless of colour or value.'), -- Protect Text
    avkMagicButton = ('Drag&Drop/Click&Drop: Add Item to Character List\nDrag&Drop/Click&Drop + Alt: Add Item to Global List\nDrag&Drop/Click&Drop + Ctrl: Add Item to Protect List\nLeft Click: Show/Hide Aardvark Frame\nMiddle Click + Drag: Move Aardvark Button\nMiddle Click + Drag: Move Aardvark Action Bar\nRight Click: Destroy Listed Items'), -- Aardvark Button Tooltip Text
    avkAboutAardvark = ("There once was a little blue Aardvark that grew up in Azeroth.\n\nHe loved to farm, spending all day and half of the night digging up herbs, mining ore, weaving cloth and collecting little treasures.\n\nAfter few years he started to develop RSI in his little paws as he was always clicking to sell items that he didn't want, dragging and dropping items that he couldn't sell and, in a lot of cases, deleting items just to clean out his bags ready to farm again.\n\nOne day after an extremely long day of farming he thought;" ..
        ColourList.textBlue ..
            "\n\"What if I could open my bags and have all the stuff I don't want just magically disappear?\"|r \n\nWith this thought he started to teach his little arthritic paws how to code.\nHis code is very messy, overly long and undoubtedly very inefficient but it does what he wants it to do.\n\nHopefully you can find it useful too."), -- Aardvark Text
    avkDestroyGlobalAddFail = '',
    avkDestroyCharacterAddFail = '',
    avkDestroyGlobalAddSuccess = '',
    avkDestroyCharacterAddSuccess = '',
    avkDestroyedItem = '',
    avkSellGlobalAddFail = '',
    avkSellCharacterAddFail = '',
    avkSellGlobalAddSuccess = '',
    avkSellCharacterAddSuccess = '',
    avkSoldItem = '',
    avkProtectGlobalAddFail = '',
    avkProtectCharacterAddFail = '',
    avkProtectGlobalAddSuccess = '',
    avkProtectCharacterAddSuccess = '',
    avkProtectedItem = '',
    avkProtectCagedPetSuccess = '',
    avkNotAnItem = '',
    avkRepaired = '',
    avkAllListsCleared = ''
}

-- ===========================         table of sizes          ===========================
local SizeList = {
    actionBarButtonGap = 5,
    actionBarContainerLong = 130,
    actionBarSmallButton = 28,
    backdropEdgeSize = 20,
    checkBoxBigSize = 24,
    checkBoxChildGapX = 15,
    checkBoxSize = 22,
    checkboxBigGapY = 38,
    checkboxFilterGapX = 177,
    checkboxFilterGapY = 24,
    checkboxFilterSize = 20,
    checkboxGapY = 32,
    clearButtonHight = 32,
    closeButtonGap = -8,
    closeButtonSize = 20,
    dropBoxSize = 80,
    mainFrameHeight = 580,
    mainFrameMarginGap = 10,
    mainFrameNavigationButtonSize = 40,
    mainFrameNavigationButtonSpace = 76,
    mainFrameNavigationFrameHeight = 60,
    mainFrameSetPoint = 250,
    mainFrameWidth = 610,
    mainPanelElementGap = 20,
    mainPanelHeight = 343,
    mainPanelWidth = 590,
    optionsButtonSize = 20,
    optionsFrameElementGap = 10,
    optionsFrameWidth = 360,
    scaleButtonGap = 50,
    scaleSliderMax = 1.5,
    scaleSliderMin = .5,
    scaleSliderScale = 1.2,
    scrollButtonHeight = 16,
    scrollButtonNumber = 13,
    scrollButtonWidth = 267,
    scrollFrameHeight = 223,
    scrollFrameWidth = 282,
    scrollTitleHeight = 48,
    scrollTitlePointX = 10,
    scrollTitlePointY = -16,
    specialDropboxWidth = 100,
    textBoxWidthShrink = 35,
    toolTipAnchor = -22
}

-- ===========================         table of naughty vendors          ===========================
local VendorBlacklist = {
    98737, -- Holt Thunderhorn -- Hunter class hall
    97111, -- Illanna Dreadmoore -- Death Knight class hall
    91190, -- Sister Elda -- Paladin class hall
    87302, -- Murg -- Horde garrison inn chef
    79828, -- Murg -- Horde garrison inn chef - Yes, this is a second Murg - No, I have no idea why
    -- 77368, -- Madison Clark -- This NPC can now buy items
    63596, -- Audrey Burnhep
    27914, -- Ethereal Soul Trader
    111741, -- Fjornson Stonecarver -- Warrior class hall
    111740, -- Mile Raitheborne -- Warlock class hall
    111739, -- Gorma Windspeaker -- Shaman class hall
    111738, -- Juvess the Duskwhisperer -- Priest class hall
    111737, -- Celadine the Fatekeeper -- Druid class hall
    111736, -- Vahu the Weathered -- Demon Hunter class hall
    110624, -- Edirah -- Mage class hall
    106942, -- Lorewalker Cho -- Monk class hall
    102641 -- Filius Sparkstache -- Rogue class hall
}

-- ===========================         table of filters          ===========================
local FilterList = {
    armourCloth = true,
    armourLeather = true,
    armourMail = true,
    armourPlate = true,
    bindingNone = true,
    bindOnEquip = true,
    bindOnPickup = true,
    bindOnUse = true,
    bindOnQuest = true,
    otherBags = true,
    otherEnchantments = true,
    otherFoodDrink = true,
    otherGems = true,
    otherMounts = true,
    otherOther = true,
    otherPets = true,
    otherReagents = true,
    otherRecipes = true,
    otherToys = true,
    otherTradeskill = true,
    rarityPoor = true,
    rarityCommon = true,
    rarityUncommon = true,
    rarityRare = true,
    rarityEpic = true,
    rarityLegendary = true,
    rarityArtifact = true,
    rarityHeirloom = true,
    rarityOther = true,
    slotChest = true,
    slotCloak = true,
    slotFeet = true,
    slotHands = true,
    slotHead = true,
    slotLegs = true,
    slotMainHand = true,
    slotNeck = true,
    slotOffHand = true,
    slotRings = true,
    slotShirt = true,
    slotShoulders = true,
    slotTabard = true,
    slotTrinkets = true,
    slotWaist = true,
    slotWrists = true,
    valueValuable = true,
    valueWorthless = true,
    weaponOneHanded = true,
    weaponRanged = true,
    weaponTwoHanded = true
}

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Functions          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         start up initialises all tables and settings          ===========================
local function avkInitialise()
    if not AVKGlobalSettings then -- create aardvark options table if it does not already exist
        AVKGlobalSettings = {
            Aardvark = {
                amfb = true, -- Aardvark main floating button
                amfbt = true, -- Aardvark main floating button tooltip
                afab = true, -- Aardvark floating action bar
                afabas = true, -- Aardvark floating action bar always show
                afabv = true -- Aardvark floating action bar vertical
            },
            Destroy = {
                ded = true, -- Destroy enable destroy
                dead = true, -- Destroy enable auto destroy
                dddm = true, -- Destroy detailed destroy messages
                dntdm = true, -- Destroy nothing to destroy messages
                dialsm = true, -- Destroy item added to list success messages
                dialfm = true, -- Destroy item added to list fail messages
                dlit = true -- Destroy show listed item tooltips
            },
            Repair = {
                rer = true, -- Repair enable repair
                rgr = false, -- Repair guild repair
                rcarm = true, -- Repair cannot afford repair messages
                rntrm = true, -- Repair nothing to repair messages
                rvcrm = true -- Repair vendor cannot repair messages
            },
            Sell = {
                ses = true, -- Sell enable sell
                seas = true, -- Sell enable auto sell
                seasg = true, -- Sell enable auto sell greys
                stil = false, -- Sell twelve item limit
                sdsm = true, -- Sell detailed sell messages
                sntsm = true, -- Sell nothing to sell messages
                sialsm = true, -- Sell item added to list success messages
                sialfm = true, -- Sell item added to list fail messages
                slit = true -- Sell show listed item tooltips
            },
            Protect = {
                pialsm = true, -- Protect item added to list success messages
                pdpm = true, -- Protect display protected messages
                pcbp = true, -- Protect caged battle pets
                plit = true -- Protect show listed item tooltips
            },
            FrameScales = {
                amfs = 1, -- Aardvark Main Frame Scale
                ambs = 1, -- Aardvark Magic Button Scale
                aabs = 1 -- Aardvark Action Bar Scale
            }
        }
        AardvarkMainFrame:Show() -- Show Aardvark frame if the settings list did not already exist
    end
    if not AVKGlobalSellTable then -- create empty global sell table if it does not already exist
        AVKGlobalSellTable = {}
    end
    if not AVKGlobalDestroyTable then -- create empty global destroy table if it does not already exist
        AVKGlobalDestroyTable = {}
    end
    if not AVKGlobalProtectTable then -- create empty global protect table if it does not already exist
        AVKGlobalProtectTable = {}
    end
    if not AVKCharacterSellTable then -- create empty character sell table if it does not already exist
        AVKCharacterSellTable = {}
    end
    if not AVKCharacterDestroyTable then -- create empty character destroy table if it does not already exist
        AVKCharacterDestroyTable = {}
    end
    if not AVKCharacterProtectTable then -- create empty character protect table if it does not already exist
        AVKCharacterProtectTable = {}
    end
    for k, v in pairs(AVKGlobalSettings) do -- Set all checkboxes
        for a, b in pairs(v) do
            if k ~= 'FrameScales' then
                checkBoxName = 'CB' .. a
                _G[checkBoxName]:SetChecked(b)
                if k == 'Aardvark' and AVKGlobalSettings.Aardvark.afab == false and (a == 'afabas' or a == 'afabv') then -- Hide option checkboxes if their parent is unchecked
                    _G[checkBoxName]:Hide()
                elseif k == 'Sell' and a ~= 'ses' and AVKGlobalSettings.Sell.ses == false then
                    _G[checkBoxName]:Hide()
                elseif k == 'Destroy' and a ~= 'ded' and AVKGlobalSettings.Destroy.ded == false then
                    _G[checkBoxName]:Hide()
                elseif k == 'Repair' and a ~= 'rer' and AVKGlobalSettings.Repair.rer == false then
                    _G[checkBoxName]:Hide()
                end
            end
        end
    end
    if AVKGlobalSettings.Aardvark.amfb == false then -- Hide magic button if it is set to hide
        AardvarkMagicButton:Hide()
    end
    if AVKGlobalSettings.Aardvark.afab and AVKGlobalSettings.Aardvark.afabas then -- Show action bar if always show is checked
        AardvarkActionBar:Show()
    end
end

-- ===========================         protect all caged pets          ===========================
local function avkProtectCagedPet()
    if AVKGlobalSettings.Protect.pcbp then
        BattlePetCageListed = false
        for k, v in pairs(AVKGlobalProtectTable) do
            if v.itemID == 82800 then
                BattlePetCageListed = true
                break
            end
        end
        if BattlePetCageListed then
            BattlePetCageListed = false
        else
            BattlePetCageListed = false
            VariableList.tempItemList = {
                itemID = 82800,
                itemName = 'Pet Cage',
                itemLink = '|cff0070dd|Hitem:82800::::::::19:256::::::|h[Pet Cage]|h|r',
                itemRarity = 3,
                itemLevel = 20,
                itemMinLevel = 0,
                itemType = 'Battle Pets',
                itemSubType = 'BattlePet',
                itemStackCount = 1,
                itemEquipLoc = '',
                iconFileDataID = 132599,
                itemSellPrice = 0,
                itemClassID = 17,
                itemSubClassID = 0,
                bindType = 0,
                expacID = 0,
                itemSetID = nil,
                isCraftingReagent = false
            }
            table.insert(AVKGlobalProtectTable, 1, VariableList.tempItemList)
        end
        BattlePetCageListed = false
    end
end

-- ===========================         sell filters          ===========================
local function avkCheckSellFilter(itemID)
    for k, v in pairs(AVKGlobalSellTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == 'INVTYPE_HEAD') or
                    (FilterList.slotNeck and v.itemEquipLoc == 'INVTYPE_NECK') or
                    (FilterList.slotShoulders and v.itemEquipLoc == 'INVTYPE_SHOULDER') or
                    (FilterList.slotCloak and v.itemEquipLoc == 'INVTYPE_CLOAK') or
                    (FilterList.slotChest and v.itemEquipLoc == 'INVTYPE_CHEST') or
                    (FilterList.slotShirt and v.itemEquipLoc == 'INVTYPE_BODY') or
                    (FilterList.slotTabard and v.itemEquipLoc == 'INVTYPE_TABARD') or
                    (FilterList.slotWrists and v.itemEquipLoc == 'INVTYPE_WRIST') or
                    (FilterList.slotHands and v.itemEquipLoc == 'INVTYPE_HAND') or
                    (FilterList.slotWaist and v.itemEquipLoc == 'INVTYPE_WAIST') or
                    (FilterList.slotLegs and v.itemEquipLoc == 'INVTYPE_LEGS') or
                    (FilterList.slotFeet and v.itemEquipLoc == 'INVTYPE_FEET') or
                    (FilterList.slotRings and v.itemEquipLoc == 'INVTYPE_FINGER') or
                    (FilterList.slotTrinkets and v.itemEquipLoc == 'INVTYPE_TRINKET') or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == 'INVTYPE_WEAPON') or (v.itemEquipLoc == 'INVTYPE_2HWEAPON') or
                            (v.itemEquipLoc == 'INVTYPE_WEAPONMAINHAND') or
                            (v.itemEquipLoc == 'INVTYPE_RANGED') or
                            (v.itemEquipLoc == 'INVTYPE_THROWN') or
                            (v.itemEquipLoc == 'INVTYPE_RANGEDRIGHT'))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == 'INVTYPE_SHIELD') or (v.itemEquipLoc == 'INVTYPE_WEAPONOFFHAND') or
                            (v.itemEquipLoc == 'INVTYPE_HOLDABLE')))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == 'Mount') or
                    (FilterList.otherMounts and v.itemSubType == 'Mount Equipment')
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == 'BattlePet') or
                    (FilterList.otherPets and v.itemSubType == 'Companion Pets')
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == 'Bag') then
                return true
            end
        end
    end
    for k, v in pairs(AVKCharacterSellTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == 'INVTYPE_HEAD') or
                    (FilterList.slotNeck and v.itemEquipLoc == 'INVTYPE_NECK') or
                    (FilterList.slotShoulders and v.itemEquipLoc == 'INVTYPE_SHOULDER') or
                    (FilterList.slotCloak and v.itemEquipLoc == 'INVTYPE_CLOAK') or
                    (FilterList.slotChest and v.itemEquipLoc == 'INVTYPE_CHEST') or
                    (FilterList.slotShirt and v.itemEquipLoc == 'INVTYPE_BODY') or
                    (FilterList.slotTabard and v.itemEquipLoc == 'INVTYPE_TABARD') or
                    (FilterList.slotWrists and v.itemEquipLoc == 'INVTYPE_WRIST') or
                    (FilterList.slotHands and v.itemEquipLoc == 'INVTYPE_HAND') or
                    (FilterList.slotWaist and v.itemEquipLoc == 'INVTYPE_WAIST') or
                    (FilterList.slotLegs and v.itemEquipLoc == 'INVTYPE_LEGS') or
                    (FilterList.slotFeet and v.itemEquipLoc == 'INVTYPE_FEET') or
                    (FilterList.slotRings and v.itemEquipLoc == 'INVTYPE_FINGER') or
                    (FilterList.slotTrinkets and v.itemEquipLoc == 'INVTYPE_TRINKET') or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == 'INVTYPE_WEAPON') or (v.itemEquipLoc == 'INVTYPE_2HWEAPON') or
                            (v.itemEquipLoc == 'INVTYPE_WEAPONMAINHAND') or
                            (v.itemEquipLoc == 'INVTYPE_RANGED') or
                            (v.itemEquipLoc == 'INVTYPE_THROWN') or
                            (v.itemEquipLoc == 'INVTYPE_RANGEDRIGHT'))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == 'INVTYPE_SHIELD') or (v.itemEquipLoc == 'INVTYPE_WEAPONOFFHAND') or
                            (v.itemEquipLoc == 'INVTYPE_HOLDABLE')))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == 'Mount') or
                    (FilterList.otherMounts and v.itemSubType == 'Mount Equipment')
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == 'BattlePet') or
                    (FilterList.otherPets and v.itemSubType == 'Companion Pets')
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == 'Bag') then
                return true
            end
        end
    end
end

-- ===========================         destroy filters          ===========================
local function avkCheckDestroyFilter(itemID)
    for k, v in pairs(AVKGlobalDestroyTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == 'INVTYPE_HEAD') or
                    (FilterList.slotNeck and v.itemEquipLoc == 'INVTYPE_NECK') or
                    (FilterList.slotShoulders and v.itemEquipLoc == 'INVTYPE_SHOULDER') or
                    (FilterList.slotCloak and v.itemEquipLoc == 'INVTYPE_CLOAK') or
                    (FilterList.slotChest and v.itemEquipLoc == 'INVTYPE_CHEST') or
                    (FilterList.slotShirt and v.itemEquipLoc == 'INVTYPE_BODY') or
                    (FilterList.slotTabard and v.itemEquipLoc == 'INVTYPE_TABARD') or
                    (FilterList.slotWrists and v.itemEquipLoc == 'INVTYPE_WRIST') or
                    (FilterList.slotHands and v.itemEquipLoc == 'INVTYPE_HAND') or
                    (FilterList.slotWaist and v.itemEquipLoc == 'INVTYPE_WAIST') or
                    (FilterList.slotLegs and v.itemEquipLoc == 'INVTYPE_LEGS') or
                    (FilterList.slotFeet and v.itemEquipLoc == 'INVTYPE_FEET') or
                    (FilterList.slotRings and v.itemEquipLoc == 'INVTYPE_FINGER') or
                    (FilterList.slotTrinkets and v.itemEquipLoc == 'INVTYPE_TRINKET') or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == 'INVTYPE_WEAPON') or (v.itemEquipLoc == 'INVTYPE_2HWEAPON') or
                            (v.itemEquipLoc == 'INVTYPE_WEAPONMAINHAND') or
                            (v.itemEquipLoc == 'INVTYPE_RANGED') or
                            (v.itemEquipLoc == 'INVTYPE_THROWN') or
                            (v.itemEquipLoc == 'INVTYPE_RANGEDRIGHT'))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == 'INVTYPE_SHIELD') or (v.itemEquipLoc == 'INVTYPE_WEAPONOFFHAND') or
                            (v.itemEquipLoc == 'INVTYPE_HOLDABLE')))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == 'Mount') or
                    (FilterList.otherMounts and v.itemSubType == 'Mount Equipment')
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == 'BattlePet') or
                    (FilterList.otherPets and v.itemSubType == 'Companion Pets')
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == 'Bag') then
                return true
            end
        end
    end
    for k, v in pairs(AVKCharacterDestroyTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == 'INVTYPE_HEAD') or
                    (FilterList.slotNeck and v.itemEquipLoc == 'INVTYPE_NECK') or
                    (FilterList.slotShoulders and v.itemEquipLoc == 'INVTYPE_SHOULDER') or
                    (FilterList.slotCloak and v.itemEquipLoc == 'INVTYPE_CLOAK') or
                    (FilterList.slotChest and v.itemEquipLoc == 'INVTYPE_CHEST') or
                    (FilterList.slotShirt and v.itemEquipLoc == 'INVTYPE_BODY') or
                    (FilterList.slotTabard and v.itemEquipLoc == 'INVTYPE_TABARD') or
                    (FilterList.slotWrists and v.itemEquipLoc == 'INVTYPE_WRIST') or
                    (FilterList.slotHands and v.itemEquipLoc == 'INVTYPE_HAND') or
                    (FilterList.slotWaist and v.itemEquipLoc == 'INVTYPE_WAIST') or
                    (FilterList.slotLegs and v.itemEquipLoc == 'INVTYPE_LEGS') or
                    (FilterList.slotFeet and v.itemEquipLoc == 'INVTYPE_FEET') or
                    (FilterList.slotRings and v.itemEquipLoc == 'INVTYPE_FINGER') or
                    (FilterList.slotTrinkets and v.itemEquipLoc == 'INVTYPE_TRINKET') or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == 'INVTYPE_WEAPON') or (v.itemEquipLoc == 'INVTYPE_2HWEAPON') or
                            (v.itemEquipLoc == 'INVTYPE_WEAPONMAINHAND') or
                            (v.itemEquipLoc == 'INVTYPE_RANGED') or
                            (v.itemEquipLoc == 'INVTYPE_THROWN') or
                            (v.itemEquipLoc == 'INVTYPE_RANGEDRIGHT'))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == 'INVTYPE_SHIELD') or (v.itemEquipLoc == 'INVTYPE_WEAPONOFFHAND') or
                            (v.itemEquipLoc == 'INVTYPE_HOLDABLE')))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == 'Mount') or
                    (FilterList.otherMounts and v.itemSubType == 'Mount Equipment')
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == 'BattlePet') or
                    (FilterList.otherPets and v.itemSubType == 'Companion Pets')
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == 'Bag') then
                return true
            end
        end
    end
end

-- ===========================         protect filters          ===========================
local function avkCheckProtectFilter(itemID)
    for k, v in pairs(AVKGlobalProtectTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == 'INVTYPE_HEAD') or
                    (FilterList.slotNeck and v.itemEquipLoc == 'INVTYPE_NECK') or
                    (FilterList.slotShoulders and v.itemEquipLoc == 'INVTYPE_SHOULDER') or
                    (FilterList.slotCloak and v.itemEquipLoc == 'INVTYPE_CLOAK') or
                    (FilterList.slotChest and v.itemEquipLoc == 'INVTYPE_CHEST') or
                    (FilterList.slotShirt and v.itemEquipLoc == 'INVTYPE_BODY') or
                    (FilterList.slotTabard and v.itemEquipLoc == 'INVTYPE_TABARD') or
                    (FilterList.slotWrists and v.itemEquipLoc == 'INVTYPE_WRIST') or
                    (FilterList.slotHands and v.itemEquipLoc == 'INVTYPE_HAND') or
                    (FilterList.slotWaist and v.itemEquipLoc == 'INVTYPE_WAIST') or
                    (FilterList.slotLegs and v.itemEquipLoc == 'INVTYPE_LEGS') or
                    (FilterList.slotFeet and v.itemEquipLoc == 'INVTYPE_FEET') or
                    (FilterList.slotRings and v.itemEquipLoc == 'INVTYPE_FINGER') or
                    (FilterList.slotTrinkets and v.itemEquipLoc == 'INVTYPE_TRINKET') or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == 'INVTYPE_WEAPON') or (v.itemEquipLoc == 'INVTYPE_2HWEAPON') or
                            (v.itemEquipLoc == 'INVTYPE_WEAPONMAINHAND') or
                            (v.itemEquipLoc == 'INVTYPE_RANGED') or
                            (v.itemEquipLoc == 'INVTYPE_THROWN') or
                            (v.itemEquipLoc == 'INVTYPE_RANGEDRIGHT'))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == 'INVTYPE_SHIELD') or (v.itemEquipLoc == 'INVTYPE_WEAPONOFFHAND') or
                            (v.itemEquipLoc == 'INVTYPE_HOLDABLE')))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == 'Mount') or
                    (FilterList.otherMounts and v.itemSubType == 'Mount Equipment')
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == 'BattlePet') or
                    (FilterList.otherPets and v.itemSubType == 'Companion Pets')
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == 'Bag') then
                return true
            end
        end
    end
    for k, v in pairs(AVKCharacterProtectTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == 'INVTYPE_HEAD') or
                    (FilterList.slotNeck and v.itemEquipLoc == 'INVTYPE_NECK') or
                    (FilterList.slotShoulders and v.itemEquipLoc == 'INVTYPE_SHOULDER') or
                    (FilterList.slotCloak and v.itemEquipLoc == 'INVTYPE_CLOAK') or
                    (FilterList.slotChest and v.itemEquipLoc == 'INVTYPE_CHEST') or
                    (FilterList.slotShirt and v.itemEquipLoc == 'INVTYPE_BODY') or
                    (FilterList.slotTabard and v.itemEquipLoc == 'INVTYPE_TABARD') or
                    (FilterList.slotWrists and v.itemEquipLoc == 'INVTYPE_WRIST') or
                    (FilterList.slotHands and v.itemEquipLoc == 'INVTYPE_HAND') or
                    (FilterList.slotWaist and v.itemEquipLoc == 'INVTYPE_WAIST') or
                    (FilterList.slotLegs and v.itemEquipLoc == 'INVTYPE_LEGS') or
                    (FilterList.slotFeet and v.itemEquipLoc == 'INVTYPE_FEET') or
                    (FilterList.slotRings and v.itemEquipLoc == 'INVTYPE_FINGER') or
                    (FilterList.slotTrinkets and v.itemEquipLoc == 'INVTYPE_TRINKET') or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == 'INVTYPE_WEAPON') or (v.itemEquipLoc == 'INVTYPE_2HWEAPON') or
                            (v.itemEquipLoc == 'INVTYPE_WEAPONMAINHAND') or
                            (v.itemEquipLoc == 'INVTYPE_RANGED') or
                            (v.itemEquipLoc == 'INVTYPE_THROWN') or
                            (v.itemEquipLoc == 'INVTYPE_RANGEDRIGHT'))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == 'INVTYPE_SHIELD') or (v.itemEquipLoc == 'INVTYPE_WEAPONOFFHAND') or
                            (v.itemEquipLoc == 'INVTYPE_HOLDABLE')))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == 'Mount') or
                    (FilterList.otherMounts and v.itemSubType == 'Mount Equipment')
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == 'BattlePet') or
                    (FilterList.otherPets and v.itemSubType == 'Companion Pets')
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == 'Bag') then
                return true
            end
        end
    end
end

-- ===========================         update global sell list          ===========================
local function avkUpdateGlobalSellList()
    -- Clean temp table
    wipe(VariableList.tempGlobalSellTable)
    -- Populate temp table with the filtered items
    for index = 1, #AVKGlobalSellTable do
        if avkCheckSellFilter(AVKGlobalSellTable[index].itemID) then
            table.insert(VariableList.tempGlobalSellTable, AVKGlobalSellTable[index]['itemLink'])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkSellGlobalScrollFrame,
        #VariableList.tempGlobalSellTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkSellGlobalScrollFrame)
        button = AardvarkSellGlobalScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempGlobalSellTable then
            button:SetText(VariableList.tempGlobalSellTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

-- ===========================         update character sell list          ===========================
local function avkUpdateCharacterSellList()
    -- Clean temp table
    wipe(VariableList.tempCharacterSellTable)
    -- Populate temp table with the filtered items
    for index = 1, #AVKCharacterSellTable do
        if avkCheckSellFilter(AVKCharacterSellTable[index].itemID) then
            table.insert(VariableList.tempCharacterSellTable, AVKCharacterSellTable[index]['itemLink'])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkSellCharacterScrollFrame,
        #VariableList.tempCharacterSellTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkSellCharacterScrollFrame)
        button = AardvarkSellCharacterScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempCharacterSellTable then
            button:SetText(VariableList.tempCharacterSellTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

-- ===========================         update global destroy list          ===========================
local function avkUpdateGlobalDestroyList()
    -- Clean temp table
    wipe(VariableList.tempGlobalDestroyTable)
    -- Populate temp table with the filtered items
    for index = 1, #AVKGlobalDestroyTable do
        if avkCheckDestroyFilter(AVKGlobalDestroyTable[index].itemID) then
            table.insert(VariableList.tempGlobalDestroyTable, AVKGlobalDestroyTable[index]['itemLink'])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkDestroyGlobalScrollFrame,
        #VariableList.tempGlobalDestroyTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkDestroyGlobalScrollFrame)
        button = AardvarkDestroyGlobalScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempGlobalDestroyTable then
            button:SetText(VariableList.tempGlobalDestroyTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

-- ===========================         update character destroy list          ===========================
local function avkUpdateCharacterDestroyList()
    -- Clean destroy temp table
    wipe(VariableList.tempCharacterDestroyTable)
    -- Populate temp table with the filtered items
    for index = 1, #AVKCharacterDestroyTable do
        if avkCheckDestroyFilter(AVKCharacterDestroyTable[index].itemID) then
            table.insert(VariableList.tempCharacterDestroyTable, AVKCharacterDestroyTable[index]['itemLink'])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkDestroyCharacterScrollFrame,
        #VariableList.tempCharacterDestroyTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkDestroyCharacterScrollFrame)
        button = AardvarkDestroyCharacterScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempCharacterDestroyTable then
            button:SetText(VariableList.tempCharacterDestroyTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

-- ===========================         update global protect list          ===========================
local function avkUpdateGlobalProtectList()
    avkProtectCagedPet()
    -- Clean temp table
    wipe(VariableList.tempGlobalProtectTable)
    -- Populate temp table with the filtered items
    for index = 1, #AVKGlobalProtectTable do
        if avkCheckProtectFilter(AVKGlobalProtectTable[index].itemID) then
            table.insert(VariableList.tempGlobalProtectTable, AVKGlobalProtectTable[index]['itemLink'])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkProtectGlobalScrollFrame,
        #VariableList.tempGlobalProtectTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkProtectGlobalScrollFrame)
        button = AardvarkProtectGlobalScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempGlobalProtectTable then
            button:SetText(VariableList.tempGlobalProtectTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    avkProtectCagedPet()
end

-- ===========================         update character protect list          ===========================
local function avkUpdateCharacterProtectList()
    -- Clean all temp table
    wipe(VariableList.tempCharacterProtectTable)
    -- Populate temp table with the filtered items
    for index = 1, #AVKCharacterProtectTable do
        if avkCheckProtectFilter(AVKCharacterProtectTable[index].itemID) then
            table.insert(VariableList.tempCharacterProtectTable, AVKCharacterProtectTable[index]['itemLink'])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkProtectCharacterScrollFrame,
        #VariableList.tempCharacterProtectTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkProtectCharacterScrollFrame)
        button = AardvarkProtectCharacterScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempCharacterProtectTable then
            button:SetText(VariableList.tempCharacterProtectTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

-- ===========================         update list based on panel          ===========================
local function updateListBasedOnPanel()
    if AardvarkDestroyPanel:IsVisible() then
        avkUpdateGlobalDestroyList()
        avkUpdateCharacterDestroyList()
    elseif AardvarkProtectPanel:IsVisible() then
        avkUpdateGlobalProtectList()
        avkUpdateCharacterProtectList()
    elseif AardvarkSellPanel:IsVisible() then
        avkUpdateGlobalSellList()
        avkUpdateCharacterSellList()
    end
end

-- ===========================         multiple button function          ===========================
local function toggleAVKPanels(buttonName)
    if buttonName == AardvarkMainFrameCloseButton then
        AardvarkMainFrame:Hide()
        AardvarkScalePanel:Hide()
        AardvarkSideOptionsFrame:Hide()
    elseif buttonName == AardvarkNavigationAardvarkButton then
        AardvarkSellPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkSideOptionsFrame:Hide()
        AardvarkAardvarkPanel:Show()
    elseif buttonName == AardvarkNavigationSellButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkSellPanel:Show()
        if AardvarkDestroyOptionsPanel:IsVisible() or AardvarkProtectOptionsPanel:IsVisible() then
            AardvarkDestroyOptionsPanel:Hide()
            AardvarkProtectOptionsPanel:Hide()
            AardvarkSellOptionsPanel:Show()
        end
        updateListBasedOnPanel()
    elseif buttonName == AardvarkNavigationDestroyButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkDestroyPanel:Show()
        if AardvarkSellOptionsPanel:IsVisible() or AardvarkProtectOptionsPanel:IsVisible() then
            AardvarkSellOptionsPanel:Hide()
            AardvarkProtectOptionsPanel:Hide()
            AardvarkDestroyOptionsPanel:Show()
        end
        updateListBasedOnPanel()
    elseif buttonName == AardvarkNavigationProtectButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkProtectPanel:Show()
        if AardvarkSellOptionsPanel:IsVisible() or AardvarkDestroyOptionsPanel:IsVisible() then
            AardvarkSellOptionsPanel:Hide()
            AardvarkDestroyOptionsPanel:Hide()
            AardvarkProtectOptionsPanel:Show()
        end
        updateListBasedOnPanel()
    elseif buttonName == AardvarkNavigationRepairButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideOptionsFrame:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Show()
    elseif buttonName == AardvarkNavigationSillyButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideOptionsFrame:Hide()
        AardvarkSillyPanel:Show()
    elseif buttonName == AardvarkScaleFrameButton then
        if AardvarkScalePanel:IsVisible() then
            AardvarkScalePanel:Hide()
            AardvarkScalePanel:ClearAllPoints()
            AardvarkScalePanel:SetPoint('BOTTOMLEFT', AardvarkMainFrame, 'BOTTOMRIGHT', 0, 0)
        else
            AardvarkScalePanel:ClearAllPoints()
            AardvarkScalePanel:SetPoint('BOTTOMLEFT', AardvarkMainFrame, 'BOTTOMRIGHT', 0, 0)
            AardvarkScalePanel:Show()
        end
    elseif buttonName == AardvarkScaleFrameCloseButton then
        AardvarkScalePanel:Hide()
    elseif buttonName == AardvarkFiltersButton then
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkFilterOptionsPanel:Show()
        AardvarkSideOptionsFrame:Show()
        updateListBasedOnPanel()
    elseif buttonName == AardvarkDestroyOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkDestroyOptionsPanel:Show()
        AardvarkSideOptionsFrame:Show()
    elseif buttonName == AardvarkSellOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkSellOptionsPanel:Show()
        AardvarkSideOptionsFrame:Show()
    elseif buttonName == AardvarkProtectOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkProtectOptionsPanel:Show()
        AardvarkSideOptionsFrame:Show()
    elseif buttonName == AardvarkSideFrameCloseButton then
        AardvarkSideOptionsFrame:Hide()
    elseif buttonName == AardvarkMagicButton then
        if AardvarkMainFrame:IsVisible() then
            AardvarkMainFrame:Hide()
        else
            AardvarkMainFrame:Show()
        end
    elseif buttonName == AardvarkFilterCheckAll then
        CB_rarity_poor:SetChecked(true)
        CB_rarity_common:SetChecked(true)
        CB_rarity_uncommon:SetChecked(true)
        CB_rarity_rare:SetChecked(true)
        CB_rarity_epic:SetChecked(true)
        CB_rarity_legendary:SetChecked(true)
        CB_rarity_artifact:SetChecked(true)
        CB_rarity_heirloom:SetChecked(true)
        CB_slot_head:SetChecked(true)
        CB_slot_neck:SetChecked(true)
        CB_slot_shoulders:SetChecked(true)
        CB_slot_cloak:SetChecked(true)
        CB_slot_chest:SetChecked(true)
        CB_slot_shirt:SetChecked(true)
        CB_slot_tabard:SetChecked(true)
        CB_slot_wrists:SetChecked(true)
        CB_slot_hands:SetChecked(true)
        CB_slot_waist:SetChecked(true)
        CB_slot_legs:SetChecked(true)
        CB_slot_feet:SetChecked(true)
        CB_slot_rings:SetChecked(true)
        CB_slot_trinkets:SetChecked(true)
        CB_slot_mainHand:SetChecked(true)
        CB_slot_offHand:SetChecked(true)
        CB_bind_none:SetChecked(true)
        CB_bind_bop:SetChecked(true)
        CB_bind_boe:SetChecked(true)
        CB_bind_use:SetChecked(true)
        CB_bind_quest:SetChecked(true)
        CB_otherMounts:SetChecked(true)
        CB_otherPets:SetChecked(true)
        CB_otherBags:SetChecked(true)

        FilterList.armourCloth = true
        FilterList.armourLeather = true
        FilterList.armourMail = true
        FilterList.armourPlate = true
        FilterList.bindingNone = true
        FilterList.bindOnEquip = true
        FilterList.bindOnPickup = true
        FilterList.bindOnUse = true
        FilterList.bindOnQuest = true
        FilterList.otherBags = true
        FilterList.otherEnchantments = true
        FilterList.otherFoodDrink = true
        FilterList.otherGems = true
        FilterList.otherMounts = true
        FilterList.otherOther = true
        FilterList.otherPets = true
        FilterList.otherReagents = true
        FilterList.otherRecipes = true
        FilterList.otherToys = true
        FilterList.otherTradeskill = true
        FilterList.rarityPoor = true
        FilterList.rarityCommon = true
        FilterList.rarityUncommon = true
        FilterList.rarityRare = true
        FilterList.rarityEpic = true
        FilterList.rarityLegendary = true
        FilterList.rarityArtifact = true
        FilterList.rarityHeirloom = true
        FilterList.rarityOther = true
        FilterList.slotChest = true
        FilterList.slotCloak = true
        FilterList.slotFeet = true
        FilterList.slotHands = true
        FilterList.slotHead = true
        FilterList.slotLegs = true
        FilterList.slotMainHand = true
        FilterList.slotNeck = true
        FilterList.slotOffHand = true
        FilterList.slotRings = true
        FilterList.slotShirt = true
        FilterList.slotShoulders = true
        FilterList.slotTabard = true
        FilterList.slotTrinkets = true
        FilterList.slotWaist = true
        FilterList.slotWrists = true
        FilterList.valueValuable = true
        FilterList.valueWorthless = true
        FilterList.weaponOneHanded = true
        FilterList.weaponRanged = true
        FilterList.weaponTwoHanded = true

        updateListBasedOnPanel()
    elseif buttonName == AardvarkFilterUncheckAll then
        -- debug --
        CB_rarity_poor:SetChecked(false)
        CB_rarity_common:SetChecked(false)
        CB_rarity_uncommon:SetChecked(false)
        CB_rarity_rare:SetChecked(false)
        CB_rarity_epic:SetChecked(false)
        CB_rarity_legendary:SetChecked(false)
        CB_rarity_artifact:SetChecked(false)
        CB_rarity_heirloom:SetChecked(false)
        CB_slot_head:SetChecked(false)
        CB_slot_neck:SetChecked(false)
        CB_slot_shoulders:SetChecked(false)
        CB_slot_cloak:SetChecked(false)
        CB_slot_chest:SetChecked(false)
        CB_slot_shirt:SetChecked(false)
        CB_slot_tabard:SetChecked(false)
        CB_slot_wrists:SetChecked(false)
        CB_slot_hands:SetChecked(false)
        CB_slot_waist:SetChecked(false)
        CB_slot_legs:SetChecked(false)
        CB_slot_feet:SetChecked(false)
        CB_slot_rings:SetChecked(false)
        CB_slot_trinkets:SetChecked(false)
        CB_slot_mainHand:SetChecked(false)
        CB_slot_offHand:SetChecked(false)
        CB_bind_none:SetChecked(false)
        CB_bind_bop:SetChecked(false)
        CB_bind_boe:SetChecked(false)
        CB_bind_use:SetChecked(false)
        CB_bind_quest:SetChecked(false)
        CB_otherMounts:SetChecked(false)
        CB_otherPets:SetChecked(false)
        CB_otherBags:SetChecked(false)

        FilterList.armourCloth = false
        FilterList.armourLeather = false
        FilterList.armourMail = false
        FilterList.armourPlate = false
        FilterList.bindingNone = false
        FilterList.bindOnEquip = false
        FilterList.bindOnPickup = false
        FilterList.bindOnUse = false
        FilterList.bindOnQuest = false
        FilterList.otherBags = false
        FilterList.otherEnchantments = false
        FilterList.otherFoodDrink = false
        FilterList.otherGems = false
        FilterList.otherMounts = false
        FilterList.otherOther = false
        FilterList.otherPets = false
        FilterList.otherReagents = false
        FilterList.otherRecipes = false
        FilterList.otherToys = false
        FilterList.otherTradeskill = false
        FilterList.rarityPoor = false
        FilterList.rarityCommon = false
        FilterList.rarityUncommon = false
        FilterList.rarityRare = false
        FilterList.rarityEpic = false
        FilterList.rarityLegendary = false
        FilterList.rarityArtifact = false
        FilterList.rarityHeirloom = false
        FilterList.rarityOther = false
        FilterList.slotChest = false
        FilterList.slotCloak = false
        FilterList.slotFeet = false
        FilterList.slotHands = false
        FilterList.slotHead = false
        FilterList.slotLegs = false
        FilterList.slotMainHand = false
        FilterList.slotNeck = false
        FilterList.slotOffHand = false
        FilterList.slotRings = false
        FilterList.slotShirt = false
        FilterList.slotShoulders = false
        FilterList.slotTabard = false
        FilterList.slotTrinkets = false
        FilterList.slotWaist = false
        FilterList.slotWrists = false
        FilterList.valueValuable = false
        FilterList.valueWorthless = false
        FilterList.weaponOneHanded = false
        FilterList.weaponRanged = false
        FilterList.weaponTwoHanded = false

        updateListBasedOnPanel()
    else
        print('FAILED', buttonName) -- If button does not exist
    end
end

-- ===========================         special add button function          ===========================
-- I had to split it from the multiple button function as the hierarchy kept breaking
local function specialAddPanel()
    AardvarkDestroyOptionsPanel:Hide()
    AardvarkProtectOptionsPanel:Hide()
    AardvarkSellOptionsPanel:Hide()
    AardvarkFilterOptionsPanel:Hide()
    AardvarkSpecialAddPanel:Show()
    AardvarkSideOptionsFrame:Show()
    updateListBasedOnPanel()
end

-- ===========================         toggle floating action bar          ===========================
local function toggleFloatingActionBar()
    if AVKGlobalSettings.Aardvark.afab and (AVKGlobalSettings.Aardvark.afabas or ActionBarSellButton:IsEnabled()) then
        AardvarkActionBar:Show()
    else
        AardvarkActionBar:Hide()
    end
end

-- ===========================         action bar layout          ===========================
local function toggleVerticleActionBar()
    if AVKGlobalSettings.Aardvark.afabv then
        AardvarkActionBar:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.actionBarContainerLong)
        ActionBarAardvarkButton:ClearAllPoints()
        ActionBarAardvarkButton:SetPoint('TOP')
        ActionBarDestroyButton:SetPoint('CENTER')
        ActionBarSellButton:SetPoint('BOTTOM')
        ActionBarProtectGlobalButton:ClearAllPoints()
        ActionBarProtectGlobalButton:SetPoint('LEFT', ActionBarAardvarkButton, 'RIGHT', SizeList.actionBarButtonGap, 0)
        ActionBarProtectCharacterButton:ClearAllPoints()
        ActionBarProtectCharacterButton:SetPoint(
            'LEFT',
            ActionBarProtectGlobalButton,
            'RIGHT',
            SizeList.actionBarButtonGap,
            0
        )
        ActionBarDestroyGlobalButton:ClearAllPoints()
        ActionBarDestroyGlobalButton:SetPoint('LEFT', ActionBarDestroyButton, 'RIGHT', SizeList.actionBarButtonGap, 0)
        ActionBarDestroyCharacterButton:ClearAllPoints()
        ActionBarDestroyCharacterButton:SetPoint(
            'LEFT',
            ActionBarDestroyGlobalButton,
            'RIGHT',
            SizeList.actionBarButtonGap,
            0
        )
        ActionBarSellGlobalButton:ClearAllPoints()
        ActionBarSellGlobalButton:SetPoint('LEFT', ActionBarSellButton, 'RIGHT', SizeList.actionBarButtonGap, 0)
        ActionBarSellCharacterButton:ClearAllPoints()
        ActionBarSellCharacterButton:SetPoint(
            'LEFT',
            ActionBarSellGlobalButton,
            'RIGHT',
            SizeList.actionBarButtonGap,
            0
        )
    else
        AardvarkActionBar:SetSize(SizeList.actionBarContainerLong, SizeList.mainFrameNavigationButtonSize)
        ActionBarAardvarkButton:ClearAllPoints()
        ActionBarAardvarkButton:SetPoint('LEFT')
        ActionBarDestroyButton:SetPoint('CENTER')
        ActionBarSellButton:SetPoint('RIGHT')
        ActionBarProtectGlobalButton:ClearAllPoints()
        ActionBarProtectGlobalButton:SetPoint('TOP', ActionBarAardvarkButton, 'BOTTOM', 0, -SizeList.actionBarButtonGap)
        ActionBarProtectCharacterButton:ClearAllPoints()
        ActionBarProtectCharacterButton:SetPoint(
            'TOP',
            ActionBarProtectGlobalButton,
            'BOTTOM',
            0,
            -SizeList.actionBarButtonGap
        )
        ActionBarDestroyGlobalButton:ClearAllPoints()
        ActionBarDestroyGlobalButton:SetPoint('TOP', ActionBarDestroyButton, 'BOTTOM', 0, -SizeList.actionBarButtonGap)
        ActionBarDestroyCharacterButton:ClearAllPoints()
        ActionBarDestroyCharacterButton:SetPoint(
            'TOP',
            ActionBarDestroyGlobalButton,
            'BOTTOM',
            0,
            -SizeList.actionBarButtonGap
        )
        ActionBarSellGlobalButton:ClearAllPoints()
        ActionBarSellGlobalButton:SetPoint('TOP', ActionBarSellButton, 'BOTTOM', 0, -SizeList.actionBarButtonGap)
        ActionBarSellCharacterButton:ClearAllPoints()
        ActionBarSellCharacterButton:SetPoint(
            'TOP',
            ActionBarSellGlobalButton,
            'BOTTOM',
            0,
            -SizeList.actionBarButtonGap
        )
    end
end

-- ===================================================================================================
-- check item on list functions - debug
local function checkItemOnGlobalSellList(cursorItemID)
    for k, v in pairs(AVKGlobalSellTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
end
local function checkItemOnCharacterSellList(cursorItemID)
    for k, v in pairs(AVKCharacterSellTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
end
local function checkItemOnGlobalDestroyList(cursorItemID)
    for k, v in pairs(AVKGlobalDestroyTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
end
local function checkItemOnCharacterDestroyList(cursorItemID)
    for k, v in pairs(AVKCharacterDestroyTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
end
local function checkItemOnGlobalProtectList(cursorItemID)
    for k, v in pairs(AVKGlobalProtectTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
end
local function checkItemOnCharacterProtectList(cursorItemID)
    for k, v in pairs(AVKCharacterProtectTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
end

-- ===========================         check item on list          ===========================
local function checkItemOnList(searchList, searchItemID)
    for k, v in pairs(searchList) do
        if v.itemID == searchItemID then
            return true
        end
    end
end
-- ===========================         remove item from list          ===========================
local function removeItemFromList(searchList, searchItemLink)
    for k, v in pairs(searchList) do
        if v.itemLink == searchItemLink then
            table.remove(searchList, k)
        end
    end
end

-- ===========================         add item to list          ===========================
local function addItemToList(tableName, itemID)
    itemName,
        itemLink,
        itemRarity,
        itemLevel,
        itemMinLevel,
        itemType,
        itemSubType,
        itemStackCount,
        itemEquipLoc,
        iconFileDataID,
        itemSellPrice,
        itemClassID,
        itemSubClassID,
        bindType,
        expacID,
        itemSetID,
        isCraftingReagent = GetItemInfo(itemID)

    VariableList.tempItemList = {
        itemID = itemID,
        itemName = itemName,
        itemLink = itemLink,
        itemRarity = itemRarity,
        itemLevel = itemLevel,
        itemMinLevel = itemMinLevel,
        itemType = itemType,
        itemSubType = itemSubType,
        itemStackCount = itemStackCount,
        itemEquipLoc = itemEquipLoc,
        iconFileDataID = iconFileDataID,
        itemSellPrice = itemSellPrice,
        itemClassID = itemClassID,
        itemSubClassID = itemSubClassID,
        bindType = bindType,
        expacID = expacID,
        itemSetID = itemSetID,
        isCraftingReagent = isCraftingReagent
    }
    if not itemLink then
        AardvarkSpecialAddTextBox:SetNumeric(false)
        AardvarkSpecialAddTextBox:SetText('Invalid Item ID')
        AardvarkSpecialAddTextBox:SetNumeric(true)
    else
        table.insert(tableName, 1, VariableList.tempItemList)
        AardvarkSpecialAddTextBox:SetText('')
    end
end

-- ===================================================================================================
-- add item to list functions - debug
local function addItemToGlobalProtectList()
    cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
    if cursorItemType ~= 'item' then -- If not item end
        print(ColourList.textBluePrefixSuffix .. ' That was not an item.') -- Cannot disable this message, because we have to learn
    else
        itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(cursorItemID)
        if checkItemOnGlobalProtectList(cursorItemID) then -- If already on list print item already listed message
            if AVKGlobalSettings.Protect.pialsm then
                print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global protect list.')
            end
        else
            if AVKGlobalSettings.Protect.pialsm then -- Print item added to list message
                print(
                    ColourList.textBluePrefixSuffix ..
                        cursorItemLink .. ColourList.textOrange .. ' added to your global protect list.'
                )
            end
            VariableList.tempItemList = {
                itemID = cursorItemID,
                itemName = itemName,
                itemLink = itemLink,
                itemRarity = itemRarity,
                itemLevel = itemLevel,
                itemMinLevel = itemMinLevel,
                itemType = itemType,
                itemSubType = itemSubType,
                itemStackCount = itemStackCount,
                itemEquipLoc = itemEquipLoc,
                iconFileDataID = iconFileDataID,
                itemSellPrice = itemSellPrice,
                itemClassID = itemClassID,
                itemSubClassID = itemSubClassID,
                bindType = bindType,
                expacID = expacID,
                itemSetID = itemSetID,
                isCraftingReagent = isCraftingReagent
            }
            table.insert(AVKGlobalProtectTable, 1, VariableList.tempItemList)
            if not AardvarkProtectPanel:IsVisible() then
                toggleAVKPanels(AardvarkNavigationProtectButton)
            else
                avkUpdateGlobalProtectList()
            end
        end
    end
    ClearCursor()
end
local function addItemToCharacterProtectList() -- debug
    cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
    if cursorItemType ~= 'item' then -- If not item end
        print(ColourList.textBluePrefixSuffix .. ' That was not an item.') -- Cannot disable this message, because we have to learn
    else
        itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(cursorItemID)
        if checkItemOnGlobalProtectList(cursorItemID) then -- If already on list print item already listed message
            if AVKGlobalSettings.Protect.pialsm then
                print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global protect list.')
            end
        elseif checkItemOnCharacterProtectList(cursorItemID) then -- If already on list print item already listed message
            if AVKGlobalSettings.Protect.pialsm then
                print(
                    ColourList.textBluePrefixSuffix ..
                        cursorItemLink .. ' is already on ' .. playerName .. "'s protect list."
                )
            end
        else
            if AVKGlobalSettings.Protect.pialsm then -- Print item added to list message
                print(
                    ColourList.textBluePrefixSuffix ..
                        cursorItemLink .. ColourList.textOrange .. ' added to ' .. playerName .. "'s protect list."
                )
            end
            VariableList.tempItemList = {
                itemID = cursorItemID,
                itemName = itemName,
                itemLink = itemLink,
                itemRarity = itemRarity,
                itemLevel = itemLevel,
                itemMinLevel = itemMinLevel,
                itemType = itemType,
                itemSubType = itemSubType,
                itemStackCount = itemStackCount,
                itemEquipLoc = itemEquipLoc,
                iconFileDataID = iconFileDataID,
                itemSellPrice = itemSellPrice,
                itemClassID = itemClassID,
                itemSubClassID = itemSubClassID,
                bindType = bindType,
                expacID = expacID,
                itemSetID = itemSetID,
                isCraftingReagent = isCraftingReagent
            }
            table.insert(AVKCharacterProtectTable, 1, VariableList.tempItemList)
            if not AardvarkProtectPanel:IsVisible() then
                toggleAVKPanels(AardvarkNavigationProtectButton)
            else
                avkUpdateCharacterProtectList()
            end
        end
    end
    ClearCursor()
end
local function addItemToGlobalList() -- debug --
    cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
    if cursorItemType ~= 'item' then -- If not item end
        print(ColourList.textBluePrefixSuffix .. ' That was not an item.') -- Cannot disable this message, because we have to learn
    else
        itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(cursorItemID)
        if itemSellPrice ~= 0 then
            if checkItemOnGlobalSellList(cursorItemID) then -- If already on list print item already listed message
                if AVKGlobalSettings.Sell.sialfm then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global sell list.')
                end
            else -- If not already on list add to list
                if AVKGlobalSettings.Sell.sialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textGreen .. ' added to your global sell list.'
                    )
                end
                VariableList.tempItemList = {
                    itemID = cursorItemID,
                    itemName = itemName,
                    itemLink = itemLink,
                    itemRarity = itemRarity,
                    itemLevel = itemLevel,
                    itemMinLevel = itemMinLevel,
                    itemType = itemType,
                    itemSubType = itemSubType,
                    itemStackCount = itemStackCount,
                    itemEquipLoc = itemEquipLoc,
                    iconFileDataID = iconFileDataID,
                    itemSellPrice = itemSellPrice,
                    itemClassID = itemClassID,
                    itemSubClassID = itemSubClassID,
                    bindType = bindType,
                    expacID = expacID,
                    itemSetID = itemSetID,
                    isCraftingReagent = isCraftingReagent
                }
                table.insert(AVKGlobalSellTable, 1, VariableList.tempItemList)
                if not AardvarkSellPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationSellButton)
                else
                    avkUpdateGlobalSellList()
                end
            end
        elseif itemSellPrice == 0 then -- If is item + has no value
            if checkItemOnGlobalDestroyList(cursorItemID) then -- If already on list print item already listed message
                if AVKGlobalSettings.Destroy.dialfm then
                    print(
                        ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global destroy list.'
                    )
                end
            else -- If not already on list add to list end
                if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textRed .. ' added to your global destroy list.'
                    )
                end
                VariableList.tempItemList = {
                    itemID = cursorItemID,
                    itemName = itemName,
                    itemLink = itemLink,
                    itemRarity = itemRarity,
                    itemLevel = itemLevel,
                    itemMinLevel = itemMinLevel,
                    itemType = itemType,
                    itemSubType = itemSubType,
                    itemStackCount = itemStackCount,
                    itemEquipLoc = itemEquipLoc,
                    iconFileDataID = iconFileDataID,
                    itemSellPrice = itemSellPrice,
                    itemClassID = itemClassID,
                    itemSubClassID = itemSubClassID,
                    bindType = bindType,
                    expacID = expacID,
                    itemSetID = itemSetID,
                    isCraftingReagent = isCraftingReagent
                }
                table.insert(AVKGlobalDestroyTable, 1, VariableList.tempItemList)
                if not AardvarkDestroyPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationDestroyButton)
                else
                    avkUpdateGlobalDestroyList()
                end
            end
        end
    end
    ClearCursor()
end
local function addItemToCharacterList() -- debug --
    cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
    if cursorItemType ~= 'item' then -- f not item end
        print(ColourList.textBluePrefixSuffix .. ' That was not an item.') -- Cannot disable this message, because we have to learn
    else
        itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(cursorItemID)
        if itemSellPrice ~= 0 then
            if checkItemOnGlobalSellList(cursorItemID) then -- If already on list print item already listed message
                if AVKGlobalSettings.Sell.sialfm then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global sell list.')
                end
            elseif checkItemOnCharacterSellList(cursorItemID) then -- If already on list print item already listed message
                if AVKGlobalSettings.Sell.sialfm then
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ' is already on ' .. playerName .. "'s sell list."
                    )
                end
            else -- If not already on list add to list
                if AVKGlobalSettings.Sell.sialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textGreen .. ' added to ' .. playerName .. "'s sell list."
                    )
                end
                VariableList.tempItemList = {
                    itemID = cursorItemID,
                    itemName = itemName,
                    itemLink = itemLink,
                    itemRarity = itemRarity,
                    itemLevel = itemLevel,
                    itemMinLevel = itemMinLevel,
                    itemType = itemType,
                    itemSubType = itemSubType,
                    itemStackCount = itemStackCount,
                    itemEquipLoc = itemEquipLoc,
                    iconFileDataID = iconFileDataID,
                    itemSellPrice = itemSellPrice,
                    itemClassID = itemClassID,
                    itemSubClassID = itemSubClassID,
                    bindType = bindType,
                    expacID = expacID,
                    itemSetID = itemSetID,
                    isCraftingReagent = isCraftingReagent
                }
                table.insert(AVKCharacterSellTable, 1, VariableList.tempItemList)
                if not AardvarkSellPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationSellButton)
                else
                    avkUpdateCharacterSellList()
                end
            end
        elseif itemSellPrice == 0 then -- If is item + has no value
            if checkItemOnGlobalDestroyList(cursorItemID) then -- If already on list print item already listed message
                if AVKGlobalSettings.Destroy.dialfm then
                    print(
                        ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global destroy list.'
                    )
                end
            elseif checkItemOnCharacterDestroyList(cursorItemID) then -- If already on list print item already listed message
                if AVKGlobalSettings.Destroy.dialfm then
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ' is already on ' .. playerName .. "'s destroy list."
                    )
                end
            else -- If not already on list add to list end
                if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textRed .. ' added to ' .. playerName .. "'s destroy list."
                    )
                end
                VariableList.tempItemList = {
                    itemID = cursorItemID,
                    itemName = itemName,
                    itemLink = itemLink,
                    itemRarity = itemRarity,
                    itemLevel = itemLevel,
                    itemMinLevel = itemMinLevel,
                    itemType = itemType,
                    itemSubType = itemSubType,
                    itemStackCount = itemStackCount,
                    itemEquipLoc = itemEquipLoc,
                    iconFileDataID = iconFileDataID,
                    itemSellPrice = itemSellPrice,
                    itemClassID = itemClassID,
                    itemSubClassID = itemSubClassID,
                    bindType = bindType,
                    expacID = expacID,
                    itemSetID = itemSetID,
                    isCraftingReagent = isCraftingReagent
                }
                table.insert(AVKCharacterDestroyTable, 1, VariableList.tempItemList)
                if not AardvarkDestroyPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationDestroyButton)
                else
                    avkUpdateCharacterDestroyList()
                end
            end
        end
    end
    ClearCursor()
end

--[[
    local function consolidateLists
--]]
-- ===========================         validate vendor          ===========================
local function checkVendorBlacklist(currentVendor)
    for k, v in pairs(VendorBlacklist) do
        if (v == currentVendor) then
            return true
        end
    end
    return false
end

-- ===========================         multiple printer          ===========================
local function avkPrinter()
    -- Repair print chunk
    if VariableList.repairMessageType == 1 then
        print(
            ColourList.textBluePrefixSuffix ..
                ColourList.textPink ..
                    'Repairs paid with guild funds :- |r' .. GetCoinTextureString(VariableList.repairAmount)
        ) -- Repair message 1
    elseif VariableList.repairMessageType == 2 then
        print(
            ColourList.textBluePrefixSuffix ..
                ColourList.textPink ..
                    'Repairs funded by you :- |r' .. GetCoinTextureString(VariableList.repairAmount)
        ) -- Repair message 2
    elseif VariableList.repairMessageType == 3 then
        if AVKGlobalSettings.Repair.rcarm then
            print(
                ColourList.textBluePrefixSuffix ..
                    ColourList.textPink .. "Guild won't pay and you can't afford it!"
            ) -- Repair message 3
        end
    elseif VariableList.repairMessageType == 4 then
        if AVKGlobalSettings.Repair.rntrm then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. 'Nothing to repair.') -- Repair message 4
        end
    elseif VariableList.repairMessageType == 5 then
        if AVKGlobalSettings.Repair.rvcrm then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. 'This vendor cannot repair.') -- Repair message 5
        end
    end
    -- Reset the repair values to 0
    VariableList.repairAmount = 0
    VariableList.repairMessageType = 0
end

-- ===========================         sell function          ===========================
-- thanks to Vrul https://www.wowinterface.com/forums/member.php?u=74185
local avkSell
do
    local profitCounter = 0 -- Cash counting variable
    local sellList = {}    -- Array with entries: { bag, slot, itemLink, itemValue, itemCount }

    local function avkSellList()
        for index = #sellList, 1, -1 do -- Process backwards so we can remove items from list safely
            local bag, slot, itemLink, itemValue, itemCount = unpack(sellList[index])
            local itemID = GetContainerItemID(bag, slot)
            if itemID and itemValue~=0 then -- Item still needs to be sold
                UseContainerItem(bag, slot)
            else -- Item has been sold
                table.remove(sellList, index)
                local value = itemValue * itemCount
                if AVKGlobalSettings.Sell.sdsm then -- If messages are on
                    print((" - Sold: %s %s for %s"):format(itemCount, itemLink, GetCoinTextureString(value)))
                end
                profitCounter = profitCounter + value -- Add sale value to profit counter
            end
        end
        if #sellList == 0 or VariableList.vendorClosed then -- All items sold
            if profitCounter ~= 0 then -- If items were sold print out total -- this message cannot be disabled
                print(("%s%sTotal Profit :-|r %s"):format(ColourList.textBluePrefixSuffix, ColourList.textGreen, GetCoinTextureString(profitCounter)))
                avkPrinter()
            elseif AVKGlobalSettings.Sell.sntsm then -- If no items sell print out grind message
                print(("%s%sNothing to sell. Better grind some more."):format(ColourList.textBluePrefixSuffix, ColourList.textGreen))
                avkPrinter()
            end
        else -- Try to sell remaining items in half a second
            C_Timer.After(.5, avkSellList)
        end
    end

    function avkSell()
        local vendorGUID = UnitGUID('target')
        if not vendorGUID then -- Catches engineer repair anvils -- debug
            return
        end
        local _, _, _, _, _, npcID, _ = strsplit('-', vendorGUID)
        local vendorID = tonumber(npcID)
        if checkVendorBlacklist(vendorID) then -- Check if vendor ID is on blacklist
            print(ColourList.textBluePrefixSuffix .. ColourList.textGreen .. UnitName('target') .. ' refuses to buy your items.')
        else
            wipe(sellList)
            profitCounter = 0
            local numListed = 0
            for bag = 0, 4 do -- Check each bag
                for slot = 0, GetContainerNumSlots(bag) do -- Check each bag slot
                    local itemID = GetContainerItemID(bag, slot)
                    if itemID then -- If current bag slot has an item then get the item info
                        local _, itemLink, itemQuality, _, _, _, _, _, _, _, itemValue = GetItemInfo(itemID)
                        if
                            (checkItemOnGlobalProtectList(itemID) or checkItemOnCharacterProtectList(itemID)) and
                                itemValue > 0
                         then
                            if AVKGlobalSettings.Sell.sdsm and AVKGlobalSettings.Protect.pdpm then
                                print(' - Protected: ' .. itemLink .. ' not sold.')
                            end
                        elseif
                            checkItemOnGlobalSellList(itemID) or checkItemOnCharacterSellList(itemID) or
                                (AVKGlobalSettings.Sell.seasg and itemQuality == 0)
                         then
                            local _, itemCount = GetContainerItemInfo(bag, slot)
                            numListed = numListed + 1
                            sellList[numListed] = { bag, slot, itemLink, itemValue, itemCount }
                            if numListed == 12 and AVKGlobalSettings.Sell.stil then -- If twelve item limit
                                break
                            end
                        end
                    end
                end
            end
            avkSellList()
        end
    end
end

-- ===========================         destroy function         ===========================
local function avkDestroy()
    local destroyedItemCount = 0 -- Destroyed items counting variable
    local destroyedSlotCount = 0
    -- Destroyed slots counting variable
    for destroyBag = 0, 4 do -- Check each bag
        destroyBagSlot = GetContainerNumSlots(destroyBag)
        for destroySlot = 0, destroyBagSlot do -- Check each bag slot
            currentItemID = GetContainerItemID(destroyBag, destroySlot)
            if currentItemID then -- If current bag slot has an item then get the item info
                local _, itemLink, _, _, _, _, _, _, _, _, itemValue = GetItemInfo(currentItemID)
                local _, itemCount, _, _, _, _, _, _ = GetContainerItemInfo(destroyBag, destroySlot)
                if
                    checkItemOnGlobalProtectList(currentItemID) or
                        checkItemOnCharacterProtectList(currentItemID) and itemValue == 0
                 then
                    if AVKGlobalSettings.Destroy.dddm and AVKGlobalSettings.Protect.pdpm then -- Print each item destroyed
                        print(' - Protected: ' .. itemLink .. ' not destroyed.')
                    end
                elseif checkItemOnGlobalDestroyList(currentItemID) or checkItemOnCharacterDestroyList(currentItemID) then
                    destroyedItemCount = destroyedItemCount + itemCount
                    destroyedSlotCount = destroyedSlotCount + 1
                    -- If item Destroy messages are on print
                    if AVKGlobalSettings.Destroy.dddm then -- Print each item destroyed
                        print(' - Destroyed: ' .. itemCount .. ' ' .. itemLink)
                    end
                    PickupContainerItem(destroyBag, destroySlot)
                    DeleteCursorItem() -- Destroy current item --  Comment out to debug
                end
            end
        end
    end
    if destroyedSlotCount ~= 0 then -- If items were destroyed print out total -- If no items destroyed print out bag space message
        print(
            ColourList.textBluePrefixSuffix ..
                ColourList.textRed ..
                    'Items destroyed :-|r ' ..
                        destroyedItemCount .. ColourList.textRed .. '  ~  Bagslots cleared :-|r ' .. destroyedSlotCount
        )
    elseif AVKGlobalSettings.Destroy.dntdm then
        print(ColourList.textBluePrefixSuffix .. ColourList.textRed .. 'Nothing destroyed. No bag space saved.')
    end
end

-- ===========================         repair function          ===========================
local function avkRepair()
    if CanMerchantRepair() then
        local repairAllCost, _ = GetRepairAllCost()
        if repairAllCost ~= 0 then
            if CanGuildBankRepair() and AVKGlobalSettings.Repair.rgr then
                RepairAllItems(1) --  Comment out to debug
                -- Set the repair variables
                VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 1
            elseif GetMoney() >= repairAllCost then
                RepairAllItems() --  Comment out to debug
                VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 2
            elseif GetMoney() < repairAllCost then
                RepairAllItems() --  Comment out to debug
                if AVKGlobalSettings.Repair.rcarm then
                    VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 3
                end
            end
        else
            if AVKGlobalSettings.Repair.rntrm then
                VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 4
            end
        end
    else
        if AVKGlobalSettings.Repair.rvcrm then
            VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 5
        end
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         slash commands          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         show aardvark frame          ===========================
SLASH_AARDVARK1 = '/avk'
function SlashCmdList.AARDVARK(msg, editbox)
    AardvarkMainFrame:Show()
    updateListBasedOnPanel()
end

-- ===========================         reset frame scales and layouts          ===========================
SLASH_AARDVARKRFP1 = '/avkpos'
function SlashCmdList.AARDVARKRFP(msg, editbox)
    AardvarkMainFrame:ClearAllPoints()
    AardvarkMainFrame:SetPoint('LEFT', SizeList.mainFrameSetPoint, 0)
    AVKGlobalSettings.FrameScales.amfs = 1
    AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
    AardvarkMainFrame:Show()
    AardvarkMagicButton:ClearAllPoints()
    AardvarkMagicButton:SetPoint('BOTTOMRIGHT', AardvarkMainFrame, 'TOPRIGHT', 0, 20)
    AVKGlobalSettings.FrameScales.ambs = 1
    AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
    AardvarkMagicButton:Show()
    AardvarkActionBar:ClearAllPoints()
    AardvarkActionBar:SetPoint('TOPLEFT', AardvarkMainFrame, 'TOPRIGHT', 0, 0)
    AVKGlobalSettings.FrameScales.aabs = 1
    AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    AardvarkActionBar:Show()
end

-- ===========================         run destroy function          ===========================
SLASH_AARDVARKD1 = '/avkdestroy'
function SlashCmdList.AARDVARKD(msg, editbox)
    avkDestroy()
end

-- ===========================         clear all item lists          ===========================
SLASH_AARDVARKCB1 = '/avkclear'
function SlashCmdList.AARDVARKCB(msg, editbox)
    wipe(AVKGlobalSellTable)
    wipe(AVKGlobalDestroyTable)
    wipe(AVKGlobalProtectTable)
    wipe(AVKCharacterSellTable)
    wipe(AVKCharacterDestroyTable)
    wipe(AVKCharacterProtectTable)
    updateListBasedOnPanel()
    print(ColourList.textBluePrefix .. 'All Lists Cleared')
end

SLASH_AARDVARKSG1 = '/avksg' -- Special add item to global destroy ignoring value check - debug
function SlashCmdList.AARDVARKSG(msg, editbox)
    local itemID = tonumber(string.match(msg, 'item:(%d+):'))
    if checkItemOnGlobalDestroyList(itemID) then -- If already on list print item already listed message
        if AVKGlobalSettings.Destroy.dialfm then
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on your global destroy list.')
        end
    else -- If not already on list add to list end
        if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
            print(ColourList.textBluePrefixSuffix .. msg .. ColourList.textRed .. ' added to your global destroy list.')
        end
        local itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(itemID)

        VariableList.tempItemList = {
            itemID = cursorItemID,
            itemName = itemName,
            itemLink = itemLink,
            itemRarity = itemRarity,
            itemLevel = itemLevel,
            itemMinLevel = itemMinLevel,
            itemType = itemType,
            itemSubType = itemSubType,
            itemStackCount = itemStackCount,
            itemEquipLoc = itemEquipLoc,
            iconFileDataID = iconFileDataID,
            itemSellPrice = itemSellPrice,
            itemClassID = itemClassID,
            itemSubClassID = itemSubClassID,
            bindType = bindType,
            expacID = expacID,
            itemSetID = itemSetID,
            isCraftingReagent = isCraftingReagent
        }

        table.insert(AVKGlobalDestroyTable, 1, VariableList.tempItemList)
        toggleAVKPanels(AardvarkNavigationDestroyButton)
    end
end

SLASH_AARDVARKSC1 = '/avksc' -- Special add item to character destroy ignoring value check - debug
function SlashCmdList.AARDVARKSC(msg, editbox)
    local itemID = tonumber(string.match(msg, 'item:(%d+):'))
    if checkItemOnGlobalDestroyList(itemID) then -- If already on list print item already listed message
        if AVKGlobalSettings.Destroy.dialfm then
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on your global destroy list.')
        end
    elseif checkItemOnCharacterDestroyList(itemID) then
        if AVKGlobalSettings.Destroy.dialfm then -- If already on list print item already listed message
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on ' .. playerName .. "'s destroy list.")
        end
    else -- If not already on list add to list end
        if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
            print(
                ColourList.textBluePrefixSuffix ..
                    msg .. ColourList.textRed .. ' added to ' .. playerName .. "'s destroy list."
            )
        end
        local itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(itemID)

        VariableList.tempItemList = {
            itemID = cursorItemID,
            itemName = itemName,
            itemLink = itemLink,
            itemRarity = itemRarity,
            itemLevel = itemLevel,
            itemMinLevel = itemMinLevel,
            itemType = itemType,
            itemSubType = itemSubType,
            itemStackCount = itemStackCount,
            itemEquipLoc = itemEquipLoc,
            iconFileDataID = iconFileDataID,
            itemSellPrice = itemSellPrice,
            itemClassID = itemClassID,
            itemSubClassID = itemSubClassID,
            bindType = bindType,
            expacID = expacID,
            itemSetID = itemSetID,
            isCraftingReagent = isCraftingReagent
        }

        table.insert(AVKCharacterDestroyTable, 1, VariableList.tempItemList)
        toggleAVKPanels(AardvarkNavigationDestroyButton)
    end
end

SLASH_AARDVARKISG1 = '/avkisg' -- Special add item to global sell using item ID - debug
function SlashCmdList.AARDVARKISG(msg, editbox)
    local itemID = tonumber(string.match(msg, 'item:(%d+):'))
    if checkItemOnGlobalSellList(itemID) then -- If already on list print item already listed message
        if AVKGlobalSettings.Sell.sialfm then
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on your global sell list.')
        end
    else -- If not already on list add to list end
        if AVKGlobalSettings.Sell.sialsm then -- Print item added to list message
            print(ColourList.textBluePrefixSuffix .. msg .. ColourList.textGreen .. ' added to your global sell list.')
        end
        local itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(itemID)

        VariableList.tempItemList = {
            itemID = cursorItemID,
            itemName = itemName,
            itemLink = itemLink,
            itemRarity = itemRarity,
            itemLevel = itemLevel,
            itemMinLevel = itemMinLevel,
            itemType = itemType,
            itemSubType = itemSubType,
            itemStackCount = itemStackCount,
            itemEquipLoc = itemEquipLoc,
            iconFileDataID = iconFileDataID,
            itemSellPrice = itemSellPrice,
            itemClassID = itemClassID,
            itemSubClassID = itemSubClassID,
            bindType = bindType,
            expacID = expacID,
            itemSetID = itemSetID,
            isCraftingReagent = isCraftingReagent
        }

        table.insert(AVKGlobalSellTable, 1, VariableList.tempItemList)
        toggleAVKPanels(AardvarkNavigationSellButton)
    end
end

SLASH_AARDVARKISC1 = '/avkisc' -- Special add item to character sell using item ID - debug
function SlashCmdList.AARDVARKISC(msg, editbox)
    local itemID = tonumber(string.match(msg, 'item:(%d+):'))
    if checkItemOnGlobalSellList(itemID) then -- If already on list print item already listed message
        if AVKGlobalSettings.Sell.sialfm then
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on your global sell list.')
        end
    elseif checkItemOnCharacterSellList(itemID) then
        if AVKGlobalSettings.Sell.sialfm then -- If already on list print item already listed message
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on ' .. playerName .. "'s sell list.")
        end
    else -- If not already on list add to list end
        if AVKGlobalSettings.Sell.sialsm then -- Print item added to list message
            print(
                ColourList.textBluePrefixSuffix ..
                    msg .. ColourList.textGreen .. ' added to ' .. playerName .. "'s sell list."
            )
        end
        local itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(itemID)

        VariableList.tempItemList = {
            itemID = cursorItemID,
            itemName = itemName,
            itemLink = itemLink,
            itemRarity = itemRarity,
            itemLevel = itemLevel,
            itemMinLevel = itemMinLevel,
            itemType = itemType,
            itemSubType = itemSubType,
            itemStackCount = itemStackCount,
            itemEquipLoc = itemEquipLoc,
            iconFileDataID = iconFileDataID,
            itemSellPrice = itemSellPrice,
            itemClassID = itemClassID,
            itemSubClassID = itemSubClassID,
            bindType = bindType,
            expacID = expacID,
            itemSetID = itemSetID,
            isCraftingReagent = isCraftingReagent
        }

        table.insert(AVKCharacterSellTable, 1, VariableList.tempItemList)
        toggleAVKPanels(AardvarkNavigationSellButton)
    end
end

SLASH_AARDVARKIDG1 = '/avkidg' -- Special add item to global destroy using item ID - debug
function SlashCmdList.AARDVARKIDG(msg, editbox)
    local itemID = tonumber(string.match(msg, 'item:(%d+):'))
    if checkItemOnGlobalDestroyList(itemID) then -- If already on list print item already listed message
        if AVKGlobalSettings.Destroy.dialfm then
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on your global destroy list.')
        end
    elseif checkItemOnCharacterDestroyList(itemID) then
        if AVKGlobalSettings.Destroy.dialfm then -- If already on list print item already listed message
            print(ColourList.textBluePrefixSuffix .. msg .. ' is already on ' .. playerName .. "'s destroy list.")
        end
    else -- If not already on list add to list end
        if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
            print(
                ColourList.textBluePrefixSuffix ..
                    msg .. ColourList.textRed .. ' added to ' .. playerName .. "'s destroy list."
            )
        end
        local itemName,
            itemLink,
            itemRarity,
            itemLevel,
            itemMinLevel,
            itemType,
            itemSubType,
            itemStackCount,
            itemEquipLoc,
            iconFileDataID,
            itemSellPrice,
            itemClassID,
            itemSubClassID,
            bindType,
            expacID,
            itemSetID,
            isCraftingReagent = GetItemInfo(itemID)

        VariableList.tempItemList = {
            itemID = cursorItemID,
            itemName = itemName,
            itemLink = itemLink,
            itemRarity = itemRarity,
            itemLevel = itemLevel,
            itemMinLevel = itemMinLevel,
            itemType = itemType,
            itemSubType = itemSubType,
            itemStackCount = itemStackCount,
            itemEquipLoc = itemEquipLoc,
            iconFileDataID = iconFileDataID,
            itemSellPrice = itemSellPrice,
            itemClassID = itemClassID,
            itemSubClassID = itemSubClassID,
            bindType = bindType,
            expacID = expacID,
            itemSetID = itemSetID,
            isCraftingReagent = isCraftingReagent
        }

        table.insert(AVKCharacterDestroyTable, 1, VariableList.tempItemList)
        toggleAVKPanels(AardvarkNavigationDestroyButton)
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         aardvark frames          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         main frame          ===========================
local AardvarkMainFrame = CreateFrame('Frame', 'AardvarkMainFrame', UIParent, 'TooltipBorderedFrameTemplate')
AardvarkMainFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkMainFrame:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkMainFrame:SetSize(SizeList.mainFrameWidth, SizeList.mainFrameHeight)
AardvarkMainFrame:ClearAllPoints()
AardvarkMainFrame:SetPoint('LEFT', SizeList.mainFrameSetPoint, 0)
AardvarkMainFrame:EnableMouse(true)
AardvarkMainFrame:SetMovable(true)
AardvarkMainFrame:RegisterForDrag('RightButton', 'LeftButton')
AardvarkMainFrame:SetScript('OnDragStart', AardvarkMainFrame.StartMoving)
AardvarkMainFrame:SetScript('OnDragStop', AardvarkMainFrame.StopMovingOrSizing)
AardvarkMainFrame:SetToplevel(true)
AardvarkMainFrame:SetScript(
    'OnEvent',
    function(self, event, ...) -- Triggers when a registered event fires
        if event == 'PLAYER_LOGIN' then
            print(TextList.avkLoad)
            avkInitialise()
            toggleVerticleActionBar()
        elseif event == 'MERCHANT_SHOW' then
            VariableList.vendorClosed = false
            if AVKGlobalSettings.Destroy.ded and AVKGlobalSettings.Destroy.dead then
                avkDestroy()
            end
            if AVKGlobalSettings.Repair.rer then
                avkRepair()
            end
            if AVKGlobalSettings.Sell.ses and AVKGlobalSettings.Sell.seas then
                avkSell()
            end
            if AVKGlobalSettings.Aardvark.afab then
                ActionBarSellButton:Enable()
                AardvarkActionBar:Show()
            else
                AardvarkActionBar:Hide()
            end
        elseif event == 'MERCHANT_CLOSED' then
            ActionBarSellButton:Disable()
            if AVKGlobalSettings.Aardvark.afabas == false then
                AardvarkActionBar:Hide()
            end
            VariableList.vendorClosed = true
        end
        AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
        AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
        AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    end
)
AardvarkMainFrame:RegisterEvent('PLAYER_LOGIN') -- Register events to track
AardvarkMainFrame:RegisterEvent('MERCHANT_SHOW')
AardvarkMainFrame:RegisterEvent('MERCHANT_CLOSED')
AardvarkMainFrame:RegisterEvent('BAG_OPEN')
AardvarkMainFrame:RegisterEvent('BAG_CLOSED')
AardvarkMainFrame:Hide()

local AardvarkMainFrameCloseButton = CreateFrame('Button', 'AardvarkMainFrameCloseButton', AardvarkMainFrame)
AardvarkMainFrameCloseButton:SetPoint('TOPRIGHT', SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkMainFrameCloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkMainFrameCloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkMainFrameCloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkMainFrameCloseButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkMainFrameCloseButton)
    end
)

local AardvarkMainFrameBanner = CreateFrame('Frame', 'AardvarkOptionsFrameBanner', AardvarkMainFrame)
AardvarkMainFrameBanner:SetSize(590, 90)
AardvarkMainFrameBanner:SetPoint('TOP', 0, -29)
AardvarkMainFrameBanner.Texture = AardvarkMainFrameBanner:CreateTexture(nil, 'BACKGROUND')
AardvarkMainFrameBanner.Texture:SetPoint('TOP', 0, 0)
AardvarkMainFrameBanner.Texture:SetTexture(ImageList.avkBanner)

-- ===========================         navigation buttons panel          ===========================
local AardvarkNavigationPanel = CreateFrame('Frame', 'AardvarkNavigationPanel', AardvarkMainFrame)
AardvarkNavigationPanel:SetSize(SizeList.mainFrameWidth, SizeList.mainFrameNavigationFrameHeight)
AardvarkNavigationPanel:SetPoint('TOP', 0, -140)

local AardvarkNavigationDestroyButton =
    CreateFrame('Button', 'AardvarkNavigationDestroyButton', AardvarkNavigationPanel)
AardvarkNavigationDestroyButton:SetPoint('CENTER', -SizeList.mainFrameNavigationButtonSpace * .5, 0)
AardvarkNavigationDestroyButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationDestroyButton:SetNormalTexture(ImageList.destroyButton)
AardvarkNavigationDestroyButton:SetHighlightTexture(ImageList.destroyButtonHover, 'BLEND')
AardvarkNavigationDestroyButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkNavigationDestroyButton)
    end
)

local AardvarkNavigationSellButton = CreateFrame('Button', 'AardvarkNavigationSellButton', AardvarkNavigationPanel)
AardvarkNavigationSellButton:SetPoint(
    'CENTER',
    AardvarkNavigationDestroyButton,
    -SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationSellButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationSellButton:SetNormalTexture(ImageList.sellButton)
AardvarkNavigationSellButton:SetHighlightTexture(ImageList.sellButtonHover, 'BLEND')
AardvarkNavigationSellButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkNavigationSellButton)
    end
)

local AardvarkNavigationAardvarkButton =
    CreateFrame('Button', 'AardvarkNavigationAardvarkButton', AardvarkNavigationPanel)
AardvarkNavigationAardvarkButton:SetPoint(
    'CENTER',
    AardvarkNavigationSellButton,
    -SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationAardvarkButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationAardvarkButton:SetNormalTexture(ImageList.avkButton)
AardvarkNavigationAardvarkButton:SetHighlightTexture(ImageList.avkButtonHover, 'BLEND')
AardvarkNavigationAardvarkButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkNavigationAardvarkButton)
    end
)

local AardvarkNavigationProtectButton =
    CreateFrame('Button', 'AardvarkNavigationProtectButton', AardvarkNavigationPanel)
AardvarkNavigationProtectButton:SetPoint(
    'LEFT',
    AardvarkNavigationDestroyButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationProtectButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationProtectButton:SetNormalTexture(ImageList.protectButton)
AardvarkNavigationProtectButton:SetHighlightTexture(ImageList.protectButtonHover, 'BLEND')
AardvarkNavigationProtectButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkNavigationProtectButton)
    end
)

local AardvarkNavigationRepairButton = CreateFrame('Button', 'AardvarkNavigationRepairButton', AardvarkNavigationPanel)
AardvarkNavigationRepairButton:SetPoint(
    'CENTER',
    AardvarkNavigationProtectButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationRepairButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationRepairButton:SetNormalTexture(ImageList.repairButton)
AardvarkNavigationRepairButton:SetHighlightTexture(ImageList.repairButtonHover, 'BLEND')
AardvarkNavigationRepairButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkNavigationRepairButton)
    end
)

local AardvarkNavigationSillyButton = CreateFrame('Button', 'AardvarkNavigationSillyButton', AardvarkNavigationPanel)
AardvarkNavigationSillyButton:SetPoint(
    'CENTER',
    AardvarkNavigationRepairButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationSillyButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationSillyButton:SetNormalTexture(ImageList.avkButton)
AardvarkNavigationSillyButton:SetHighlightTexture(ImageList.avkButtonHover, 'BLEND')
AardvarkNavigationSillyButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkNavigationSillyButton)
    end
)

-- ===========================         aardvark options panel          ===========================
local AardvarkAardvarkPanel =
    CreateFrame('Frame', 'AardvarkAardvarkPanel', AardvarkMainFrame, 'TooltipBorderedFrameTemplate')
AardvarkAardvarkPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkAardvarkPanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkAardvarkPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkAardvarkPanel:SetPoint('BOTTOM', 0, SizeList.mainFrameMarginGap)
AardvarkAardvarkPanel:Show()

local CBamfb = CreateFrame('CheckButton', 'CBamfb', AardvarkAardvarkPanel, 'UICheckButtonTemplate')
CBamfb:ClearAllPoints()
CBamfb:SetPoint('TOPLEFT', SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
CBamfb:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBamfb.text:SetText(ColourList.textBlue .. ' Aardvark Button')
CBamfb.text:SetFontObject(FontCheckBoxBig)
CBamfb:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Aardvark.amfb then
            AVKGlobalSettings.Aardvark.amfb = false
            AardvarkMagicButton:Hide()
        else
            AVKGlobalSettings.Aardvark.amfb = true
            AardvarkMagicButton:Show()
        end
    end
)

local CBamfbt = CreateFrame('CheckButton', 'CBamfbt', AardvarkAardvarkPanel, 'UICheckButtonTemplate')
CBamfbt:ClearAllPoints()
CBamfbt:SetPoint('TOPLEFT', CBamfb, 0, -SizeList.checkboxBigGapY)
CBamfbt:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBamfbt.text:SetText(ColourList.textBlue .. ' Aardvark Button Tooltip')
CBamfbt.text:SetFontObject(FontCheckBoxBig)
CBamfbt:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Aardvark.amfbt then
            AVKGlobalSettings.Aardvark.amfbt = false
        else
            AVKGlobalSettings.Aardvark.amfbt = true
        end
    end
)

local CBafab = CreateFrame('CheckButton', 'CBafab', AardvarkAardvarkPanel, 'UICheckButtonTemplate')
CBafab:ClearAllPoints()
CBafab:SetPoint('TOPLEFT', CBamfbt, 0, -SizeList.checkboxBigGapY)
CBafab:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBafab.text:SetText(ColourList.textBlue .. ' Aardvark Action Bar')
CBafab.text:SetFontObject(FontCheckBoxBig)
CBafab:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Aardvark.afab then
            AVKGlobalSettings.Aardvark.afab = false
            CBafabas:Hide()
            CBafabv:Hide()
            AardvarkActionBar:Hide()
        else
            AVKGlobalSettings.Aardvark.afab = true
            if not AardvarkActionBar:IsVisible() then
                CBafabas:Show()
                CBafabv:Show()
                AardvarkActionBar:Show()
            end
        end
    end
)

local CBafabas = CreateFrame('CheckButton', 'CBafabas', AardvarkAardvarkPanel, 'UICheckButtonTemplate')
CBafabas:ClearAllPoints()
CBafabas:SetPoint('TOPLEFT', CBafab, SizeList.checkBoxChildGapX, -SizeList.checkboxBigGapY)
CBafabas:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBafabas.text:SetText(' Always Show Action Bar')
CBafabas.text:SetFontObject(FontCheckBox)
CBafabas:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Aardvark.afabas then
            AVKGlobalSettings.Aardvark.afabas = false
            toggleFloatingActionBar()
        else
            AVKGlobalSettings.Aardvark.afabas = true
            AardvarkActionBar:Show()
        end
    end
)

local CBafabv = CreateFrame('CheckButton', 'CBafabv', AardvarkAardvarkPanel, 'UICheckButtonTemplate')
CBafabv:ClearAllPoints()
CBafabv:SetPoint('TOPLEFT', CBafabas, 0, -SizeList.checkboxGapY)
CBafabv:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBafabv.text:SetText(' Verticle Align Action Bar')
CBafabv.text:SetFontObject(FontCheckBox)
CBafabv:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Aardvark.afabv then
            AVKGlobalSettings.Aardvark.afabv = false
            toggleVerticleActionBar()
        else
            AVKGlobalSettings.Aardvark.afabv = true
            toggleVerticleActionBar()
        end
    end
)

local AardvarkAardvarkPanelTextBox = CreateFrame('Frame', 'AardvarkAardvarkPanelTextBox', AardvarkAardvarkPanel)
AardvarkAardvarkPanelTextBox:SetSize(
    SizeList.mainPanelWidth - SizeList.textBoxWidthShrink,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkAardvarkPanelTextBox:SetPoint('BOTTOMLEFT', SizeList.mainPanelElementGap, SizeList.mainPanelElementGap)
AardvarkAardvarkPanelText = AardvarkAardvarkPanelTextBox:CreateFontString('AardvarkAardvarkPanelText')
AardvarkAardvarkPanelText:SetJustifyH('LEFT')
AardvarkAardvarkPanelText:SetJustifyV('BOTTOM')
AardvarkAardvarkPanelText:SetAllPoints(AardvarkAardvarkPanelTextBox)
AardvarkAardvarkPanelText:SetFontObject(FontContent)
AardvarkAardvarkPanelText:SetText(TextList.avkOptions)

local AardvarkScaleFrameButton =
    CreateFrame('Button', 'AardvarkScaleFrameButton', AardvarkAardvarkPanel, 'UIMenuButtonStretchTemplate')
AardvarkScaleFrameButton:SetSize(SizeList.scrollFrameWidth * .25, SizeList.clearButtonHight)
AardvarkScaleFrameButton:SetPoint('BOTTOMRIGHT', -10, 10)
AardvarkScaleFrameButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkScaleFrameButton:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkScaleFrameButton:SetNormalFontObject(FontButton)
AardvarkScaleFrameButton:SetHighlightFontObject(FontButton)
AardvarkScaleFrameButton:SetFormattedText('Scale')
AardvarkScaleFrameButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkScaleFrameButton)
    end
)

-- ===========================         side frame          ===========================
local AardvarkSideOptionsFrame =
    CreateFrame('Frame', 'AardvarkSideOptionsFrame', AardvarkMainFrame, 'TooltipBorderedFrameTemplate')
AardvarkSideOptionsFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSideOptionsFrame:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkSideOptionsFrame:SetPoint('TOPLEFT', AardvarkMainFrame, 'TOPRIGHT', SizeList.mainFrameMarginGap)
AardvarkSideOptionsFrame:SetSize(SizeList.optionsFrameWidth, SizeList.mainFrameHeight)
AardvarkSideOptionsFrame:SetParent(AardvarkMainFrame)
AardvarkSideOptionsFrame:SetToplevel(true)
AardvarkSideOptionsFrame:Hide()

local AardvarkSideFrameCloseButton = CreateFrame('Button', 'AardvarkSideFrameCloseButton', AardvarkSideOptionsFrame)
AardvarkSideFrameCloseButton:SetPoint('TOPRIGHT', SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkSideFrameCloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkSideFrameCloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkSideFrameCloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkSideFrameCloseButton:SetScript(
    'OnClick',
    function(self)
        AardvarkSideOptionsFrame:Hide()
    end
)

-- ===========================         sell options panel          ===========================
local AardvarkSellOptionsPanel = CreateFrame('Frame', 'AardvarkSellOptionsPanel', AardvarkSideOptionsFrame)
AardvarkSellOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkSellOptionsPanel:SetPoint('TOP', AardvarkSideOptionsFrame, 'TOP', SizeList.mainFrameMarginGap)
AardvarkSellOptionsPanel:Hide()

local CBses = CreateFrame('CheckButton', 'CBses', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBses:ClearAllPoints()
CBses:SetPoint('TOPLEFT', SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
CBses:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBses.text:SetText(ColourList.textGreen .. ' Aardvark Sell')
CBses.text:SetFontObject(FontCheckBoxBig)
CBses:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.ses then
            AVKGlobalSettings.Sell.ses = false
            CBseas:Hide()
            CBseasg:Hide()
            CBstil:Hide()
            CBsdsm:Hide()
            CBsntsm:Hide()
            CBsialsm:Hide()
            CBsialfm:Hide()
            CBslit:Hide()
        else
            AVKGlobalSettings.Sell.ses = true
            CBseas:Show()
            CBseasg:Show()
            CBstil:Show()
            CBsdsm:Show()
            CBsntsm:Show()
            CBsialsm:Show()
            CBsialfm:Show()
            CBslit:Show()
        end
    end
)

local CBseas = CreateFrame('CheckButton', 'CBseas', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBseas:ClearAllPoints()
CBseas:SetPoint('TOPLEFT', CBses, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
CBseas:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBseas.text:SetText(' Auto Sell')
CBseas.text:SetFontObject(FontCheckBox)
CBseas:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.seas then
            AVKGlobalSettings.Sell.seas = false
        else
            AVKGlobalSettings.Sell.seas = true
        end
    end
)

local CBseasg = CreateFrame('CheckButton', 'CBseasg', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBseasg:ClearAllPoints()
CBseasg:SetPoint('TOPLEFT', CBseas, 0, -SizeList.checkboxGapY)
CBseasg:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBseasg.text:SetText(' Auto Sell Greys')
CBseasg.text:SetFontObject(FontCheckBox)
CBseasg:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.seasg then
            AVKGlobalSettings.Sell.seasg = false
        else
            AVKGlobalSettings.Sell.seasg = true
        end
    end
)

local CBstil = CreateFrame('CheckButton', 'CBstil', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBstil:ClearAllPoints()
CBstil:SetPoint('TOPLEFT', CBseasg, 0, -SizeList.checkboxGapY)
CBstil:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBstil.text:SetText(' Sell 12 Items At A Time')
CBstil.text:SetFontObject(FontCheckBox)
CBstil:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.stil then
            AVKGlobalSettings.Sell.stil = false
        else
            AVKGlobalSettings.Sell.stil = true
        end
    end
)

local CBsdsm = CreateFrame('CheckButton', 'CBsdsm', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBsdsm:ClearAllPoints()
CBsdsm:SetPoint('TOPLEFT', CBstil, 0, -SizeList.checkboxGapY)
CBsdsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsdsm.text:SetText(' Detailed Sell Messages')
CBsdsm.text:SetFontObject(FontCheckBox)
CBsdsm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.sdsm then
            AVKGlobalSettings.Sell.sdsm = false
        else
            AVKGlobalSettings.Sell.sdsm = true
        end
    end
)

local CBsntsm = CreateFrame('CheckButton', 'CBsntsm', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBsntsm:ClearAllPoints()
CBsntsm:SetPoint('TOPLEFT', CBsdsm, 0, -SizeList.checkboxGapY)
CBsntsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsntsm.text:SetText(' Nothing To Sell Messages')
CBsntsm.text:SetFontObject(FontCheckBox)
CBsntsm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.sntsm then
            AVKGlobalSettings.Sell.sntsm = false
        else
            AVKGlobalSettings.Sell.sntsm = true
        end
    end
)

local CBsialsm = CreateFrame('CheckButton', 'CBsialsm', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBsialsm:ClearAllPoints()
CBsialsm:SetPoint('TOPLEFT', CBsntsm, 0, -SizeList.checkboxGapY)
CBsialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsialsm.text:SetText(' Item Added Messages')
CBsialsm.text:SetFontObject(FontCheckBox)
CBsialsm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.sialsm then
            AVKGlobalSettings.Sell.sialsm = false
        else
            AVKGlobalSettings.Sell.sialsm = true
        end
    end
)

local CBsialfm = CreateFrame('CheckButton', 'CBsialfm', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBsialfm:ClearAllPoints()
CBsialfm:SetPoint('TOPLEFT', CBsialsm, 0, -SizeList.checkboxGapY)
CBsialfm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsialfm.text:SetText(' Item Not Added Messages')
CBsialfm.text:SetFontObject(FontCheckBox)
CBsialfm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.sialfm then
            AVKGlobalSettings.Sell.sialfm = false
        else
            AVKGlobalSettings.Sell.sialfm = true
        end
    end
)

local CBslit = CreateFrame('CheckButton', 'CBslit', AardvarkSellOptionsPanel, 'UICheckButtonTemplate')
CBslit:ClearAllPoints()
CBslit:SetPoint('TOPLEFT', CBsialfm, 0, -SizeList.checkboxGapY)
CBslit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBslit.text:SetText(' Show Listed Item Tooltips')
CBslit.text:SetFontObject(FontCheckBox)
CBslit:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Sell.slit then
            AVKGlobalSettings.Sell.slit = false
        else
            AVKGlobalSettings.Sell.slit = true
        end
    end
)

local AardvarkSellOptionsPanelTextBox =
    CreateFrame('Frame', 'AardvarkSellOptionsPanelTextBox', AardvarkSellOptionsPanel)
AardvarkSellOptionsPanelTextBox:SetSize(
    SizeList.mainFrameWidth / 2,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkSellOptionsPanelTextBox:SetPoint('BOTTOM', AardvarkSideOptionsFrame, 'BOTTOM', 0, SizeList.checkBoxChildGapX)
AardvarkSellOptionsPanelText = AardvarkSellOptionsPanelTextBox:CreateFontString('AardvarkSellOptionsPanelText')
AardvarkSellOptionsPanelText:SetJustifyH('BOTTOM')
AardvarkSellOptionsPanelText:SetJustifyV('BOTTOM')
AardvarkSellOptionsPanelText:SetAllPoints(AardvarkSellOptionsPanelTextBox)
AardvarkSellOptionsPanelText:SetFontObject(FontContent)
AardvarkSellOptionsPanelText:SetText(TextList.avkSellOptions)

--===================         main sell panel         ============================
local AardvarkSellPanel = CreateFrame('Frame', 'AardvarkSellPanel', AardvarkMainFrame, 'TooltipBorderedFrameTemplate')
AardvarkSellPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellPanel:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkSellPanel:SetPoint('BOTTOM', 0, SizeList.mainFrameMarginGap)
AardvarkSellPanel:Hide()

local AardvarkSellOptionsButton = CreateFrame('Button', 'AardvarkSellOptionsButton', AardvarkSellPanel)
AardvarkSellOptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellOptionsButton:SetPoint(
    'CENTER',
    AardvarkNavigationSillyButton,
    'CENTER',
    SizeList.mainFrameNavigationButtonSpace * .6 + SizeList.optionsButtonSize,
    0
)
AardvarkSellOptionsButton:SetNormalTexture(ImageList.sellOptions)
AardvarkSellOptionsButton:SetHighlightTexture(ImageList.sellOptionsHover)
AardvarkSellOptionsButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkSellOptionsButton)
    end
)

local AardvarkSellFiltersButton = CreateFrame('Button', 'AardvarkSellFiltersButton', AardvarkSellPanel)
AardvarkSellFiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellFiltersButton:SetPoint('CENTER', AardvarkSellOptionsButton, 'TOP', 0, 15)
AardvarkSellFiltersButton:SetNormalTexture(ImageList.sellFilters)
AardvarkSellFiltersButton:SetHighlightTexture(ImageList.sellFiltersHover)
AardvarkSellFiltersButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkFiltersButton)
    end
)
local AardvarkSellSpecialAddButton = CreateFrame('Button', 'AardvarkSellSpecialAddButton', AardvarkSellPanel)
AardvarkSellSpecialAddButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellSpecialAddButton:SetPoint('CENTER', AardvarkSellOptionsButton, 'BOTTOM', 0, -15)
AardvarkSellSpecialAddButton:SetNormalTexture(ImageList.sellSpecialAdd)
AardvarkSellSpecialAddButton:SetHighlightTexture(ImageList.sellSpecialAddHover)
AardvarkSellSpecialAddButton:SetScript(
    'OnClick',
    function()
        specialAddPanel()
    end
)

-- ===========================         global sell list panel          ===========================
local AardvarkSellGlobalTitle = CreateFrame('Frame', 'AardvarkSellGlobalTitle', AardvarkSellPanel)
AardvarkSellGlobalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSellGlobalTitle:SetPoint('TOPLEFT', AardvarkSellPanel, SizeList.scrollTitlePointX, SizeList.scrollTitlePointY)
AardvarkSellGlobalTitleText = AardvarkSellGlobalTitle:CreateFontString('AardvarkSellGlobalTitleText')
AardvarkSellGlobalTitleText:SetPoint('CENTER', 0, 0)
AardvarkSellGlobalTitleText:SetJustifyH('CENTER')
AardvarkSellGlobalTitleText:SetJustifyV('CENTER')
AardvarkSellGlobalTitleText:SetAllPoints(AardvarkSellGlobalTitle)
AardvarkSellGlobalTitleText:SetFontObject(FontTitleScroll)
AardvarkSellGlobalTitleText:SetText('Global Sell List')

local AardvarkSellGlobalScrollParent =
    CreateFrame('Button', 'AardvarkSellGlobalScrollParent', AardvarkSellPanel, 'TooltipBorderedFrameTemplate')
AardvarkSellGlobalScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellGlobalScrollParent:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellGlobalScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkSellGlobalScrollParent:SetPoint('TOP', AardvarkSellGlobalTitle, 'BOTTOM', 0, -8)
AardvarkSellGlobalScrollParent:SetScript(
    'OnReceiveDrag',
    function()
        addItemToGlobalList()
    end
)
AardvarkSellGlobalScrollParent:SetScript(
    'OnClick',
    function()
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)
local AardvarkSellGlobalScrollFrame =
    CreateFrame(
    'ScrollFrame',
    'AardvarkSellGlobalScrollFrame',
    AardvarkSellGlobalScrollParent,
    'FauxScrollFrameTemplate'
)
AardvarkSellGlobalScrollFrame:SetPoint('TOPLEFT', 0, -8)
AardvarkSellGlobalScrollFrame:SetPoint('BOTTOMRIGHT', -30, 8)
AardvarkSellGlobalScrollFrame:SetScript(
    'OnVerticalScroll',
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateGlobalSellList)
    end
)

AardvarkSellGlobalScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkSellGlobalScrollFrame.buttons[i] = CreateFrame('Button', 'sglb' .. i, AardvarkSellGlobalScrollParent)
    local button = AardvarkSellGlobalScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject('GameFontHighlightLeft')
    button:SetPoint('TOPLEFT', 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture('Interface\\BUTTONS\\UI-Listbox-Highlight2')
    button:SetScript(
        'OnEnter',
        function(self)
            local itemLink = VariableList.tempGlobalSellTable[self.index]
            GameTooltip:SetOwner(self, 'ANCHOR_LEFT', SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Sell.slit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                'OnClick',
                function(self)
                    if GetCursorInfo() then
                        addItemToGlobalList()
                    else
                        -- table.remove(AVKGlobalSellTable, self.index)
                        removeItemFromList(AVKGlobalSellTable, itemLink)
                        GameTooltip:Hide()
                        avkUpdateGlobalSellList()
                    end
                end
            )
            button:SetScript(
                'OnReceiveDrag',
                function()
                    GameTooltip:Hide()
                    addItemToGlobalList()
                end
            )
        end
    )
    button:SetScript(
        'OnLeave',
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkSellGlobalClearListButton =
    CreateFrame('Button', 'AardvarkSellGlobalClearListButton', AardvarkSellPanel, 'UIMenuButtonStretchTemplate')
AardvarkSellGlobalClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkSellGlobalClearListButton:SetPoint('TOP', AardvarkSellGlobalScrollParent, 'BOTTOM', 0, -5)
AardvarkSellGlobalClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellGlobalClearListButton:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellGlobalClearListButton:SetNormalFontObject(FontButton)
AardvarkSellGlobalClearListButton:SetHighlightFontObject(FontButton)
AardvarkSellGlobalClearListButton:SetFormattedText('Clear Global Sell List')
AardvarkSellGlobalClearListButton:RegisterForClicks('RightButtonUp')
AardvarkSellGlobalClearListButton:SetScript(
    'OnClick',
    function()
        wipe(AVKGlobalSellTable)
        avkUpdateGlobalSellList()
    end
)

-- ===========================         character sell list panel          ===========================
local AardvarkSellLocalTitle = CreateFrame('Frame', 'AardvarkSellLocalTitle', AardvarkSellPanel)
AardvarkSellLocalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSellLocalTitle:SetPoint('TOPRIGHT', AardvarkSellPanel, -SizeList.scrollTitlePointX, SizeList.scrollTitlePointY)
AardvarkSellLocalTitleText = AardvarkSellLocalTitle:CreateFontString('AardvarkSellLocalTitleText')
AardvarkSellLocalTitleText:SetPoint('CENTER', 0, 0)
AardvarkSellLocalTitleText:SetJustifyH('CENTER')
AardvarkSellLocalTitleText:SetJustifyV('CENTER')
AardvarkSellLocalTitleText:SetAllPoints(AardvarkSellLocalTitle)
AardvarkSellLocalTitleText:SetFontObject(FontTitleScroll)
AardvarkSellLocalTitleText:SetText(playerName .. "'s\nSell List")

local AardvarkSellCharacterScrollParent =
    CreateFrame('Button', 'AardvarkSellCharacterScrollParent', AardvarkSellPanel, 'TooltipBorderedFrameTemplate')
AardvarkSellCharacterScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellCharacterScrollParent:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellCharacterScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkSellCharacterScrollParent:SetPoint('TOP', AardvarkSellLocalTitle, 'BOTTOM', 0, -8)
AardvarkSellCharacterScrollParent:SetScript(
    'OnReceiveDrag',
    function()
        addItemToCharacterList()
    end
)
AardvarkSellCharacterScrollParent:SetScript(
    'OnClick',
    function()
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

local AardvarkSellCharacterScrollFrame =
    CreateFrame(
    'ScrollFrame',
    'AardvarkSellCharacterScrollFrame',
    AardvarkSellCharacterScrollParent,
    'FauxScrollFrameTemplate'
)
AardvarkSellCharacterScrollFrame:SetPoint('TOPLEFT', 0, -8)
AardvarkSellCharacterScrollFrame:SetPoint('BOTTOMRIGHT', -30, 8)
AardvarkSellCharacterScrollFrame:SetScript(
    'OnVerticalScroll',
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateCharacterSellList)
    end
)

AardvarkSellCharacterScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkSellCharacterScrollFrame.buttons[i] = CreateFrame('Button', 'sclb' .. i, AardvarkSellCharacterScrollParent)
    local button = AardvarkSellCharacterScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject('GameFontHighlightLeft')
    button:SetPoint('TOPLEFT', 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture('Interface\\BUTTONS\\UI-Listbox-Highlight2')
    button:SetScript(
        'OnEnter',
        function(self)
            local itemLink = VariableList.tempCharacterSellTable[self.index]
            GameTooltip:SetOwner(self, 'ANCHOR_LEFT', SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Sell.slit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                'OnClick',
                function(self)
                    if GetCursorInfo() then
                        addItemToCharacterList()
                    else
                        --  table.remove(AVKCharacterSellTable, self.index)
                        removeItemFromList(AVKCharacterSellTable, itemLink)
                        GameTooltip:Hide()
                        avkUpdateCharacterSellList()
                    end
                end
            )
            button:SetScript(
                'OnReceiveDrag',
                function()
                    GameTooltip:Hide()
                    addItemToCharacterList()
                end
            )
        end
    )
    button:SetScript(
        'OnLeave',
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkSellCharacterClearListButton =
    CreateFrame('Button', 'AardvarkSellCharacterClearListButton', AardvarkSellPanel, 'UIMenuButtonStretchTemplate')
AardvarkSellCharacterClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkSellCharacterClearListButton:SetPoint('TOP', AardvarkSellCharacterScrollParent, 'BOTTOM', 0, -5)
AardvarkSellCharacterClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellCharacterClearListButton:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellCharacterClearListButton:SetNormalFontObject(FontButton)
AardvarkSellCharacterClearListButton:SetHighlightFontObject(FontButton)
AardvarkSellCharacterClearListButton:SetFormattedText('Clear ' .. playerName .. "'s Sell List")
AardvarkSellCharacterClearListButton:RegisterForClicks('RightButtonUp')
AardvarkSellCharacterClearListButton:SetScript(
    'OnClick',
    function()
        wipe(AVKCharacterSellTable)
        avkUpdateCharacterSellList()
    end
)

--===================         destroy options panel         ============================
local AardvarkDestroyOptionsPanel = CreateFrame('Frame', 'AardvarkDestroyOptionsPanel', AardvarkSideOptionsFrame)
AardvarkDestroyOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkDestroyOptionsPanel:SetPoint('TOP', AardvarkSideOptionsFrame, 'TOP', SizeList.mainFrameMarginGap)
AardvarkDestroyOptionsPanel:Hide()

local CBded = CreateFrame('CheckButton', 'CBded', AardvarkDestroyOptionsPanel, 'UICheckButtonTemplate')
CBded:ClearAllPoints()
CBded:SetPoint('TOPLEFT', SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
CBded:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBded.text:SetText(ColourList.textRed .. ' Aardvark Destroy')
CBded.text:SetFontObject(FontCheckBoxBig)
CBded:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Destroy.ded then
            AVKGlobalSettings.Destroy.ded = false
            CBdead:Hide()
            CBdddm:Hide()
            CBdntdm:Hide()
            CBdialsm:Hide()
            CBdialfm:Hide()
            CBdlit:Hide()
        else
            AVKGlobalSettings.Destroy.ded = true
            CBdead:Show()
            CBdddm:Show()
            CBdntdm:Show()
            CBdialsm:Show()
            CBdialfm:Show()
            CBdlit:Show()
        end
    end
)

local CBdead = CreateFrame('CheckButton', 'CBdead', AardvarkDestroyOptionsPanel, 'UICheckButtonTemplate')
CBdead:ClearAllPoints()
CBdead:SetPoint('TOPLEFT', CBded, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
CBdead:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdead.text:SetText(' Auto Destroy')
CBdead.text:SetFontObject(FontCheckBox)
CBdead:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Destroy.dead then
            AVKGlobalSettings.Destroy.dead = false
        else
            AVKGlobalSettings.Destroy.dead = true
        end
    end
)

local CBdddm = CreateFrame('CheckButton', 'CBdddm', AardvarkDestroyOptionsPanel, 'UICheckButtonTemplate')
CBdddm:ClearAllPoints()
CBdddm:SetPoint('TOPLEFT', CBdead, 0, -SizeList.checkboxGapY)
CBdddm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdddm.text:SetText(' Detailed Destroy Messages')
CBdddm.text:SetFontObject(FontCheckBox)
CBdddm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Destroy.dddm then
            AVKGlobalSettings.Destroy.dddm = false
        else
            AVKGlobalSettings.Destroy.dddm = true
        end
    end
)

local CBdntdm = CreateFrame('CheckButton', 'CBdntdm', AardvarkDestroyOptionsPanel, 'UICheckButtonTemplate')
CBdntdm:ClearAllPoints()
CBdntdm:SetPoint('TOPLEFT', CBdddm, 0, -SizeList.checkboxGapY)
CBdntdm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdntdm.text:SetText(' Nothing To Destroy Messages')
CBdntdm.text:SetFontObject(FontCheckBox)
CBdntdm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Destroy.dntdm then
            AVKGlobalSettings.Destroy.dntdm = false
        else
            AVKGlobalSettings.Destroy.dntdm = true
        end
    end
)

local CBdialsm = CreateFrame('CheckButton', 'CBdialsm', AardvarkDestroyOptionsPanel, 'UICheckButtonTemplate')
CBdialsm:ClearAllPoints()
CBdialsm:SetPoint('TOPLEFT', CBdntdm, 0, -SizeList.checkboxGapY)
CBdialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdialsm.text:SetText(' Item Added Messages')
CBdialsm.text:SetFontObject(FontCheckBox)
CBdialsm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Destroy.dialsm then
            AVKGlobalSettings.Destroy.dialsm = false
        else
            AVKGlobalSettings.Destroy.dialsm = true
        end
    end
)

local CBdialfm = CreateFrame('CheckButton', 'CBdialfm', AardvarkDestroyOptionsPanel, 'UICheckButtonTemplate')
CBdialfm:ClearAllPoints()
CBdialfm:SetPoint('TOPLEFT', CBdialsm, 0, -SizeList.checkboxGapY)
CBdialfm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdialfm.text:SetText(' Item Not Added Messages')
CBdialfm.text:SetFontObject(FontCheckBox)
CBdialfm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Destroy.dialfm then
            AVKGlobalSettings.Destroy.dialfm = false
        else
            AVKGlobalSettings.Destroy.dialfm = true
        end
    end
)

local CBdlit = CreateFrame('CheckButton', 'CBdlit', AardvarkDestroyOptionsPanel, 'UICheckButtonTemplate')
CBdlit:ClearAllPoints()
CBdlit:SetPoint('TOPLEFT', CBdialfm, 0, -SizeList.checkboxGapY)
CBdlit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdlit.text:SetText(' Show Listed Item Tooltips')
CBdlit.text:SetFontObject(FontCheckBox)
CBdlit:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Destroy.dlit then
            AVKGlobalSettings.Destroy.dlit = false
        else
            AVKGlobalSettings.Destroy.dlit = true
        end
    end
)

local AardvarkDestroyOptionsPanelTextBox =
    CreateFrame('Frame', 'AardvarkDestroyOptionsPanelTextBox', AardvarkDestroyOptionsPanel)
AardvarkDestroyOptionsPanelTextBox:SetSize(
    SizeList.optionsFrameWidth - SizeList.optionsFrameElementGap * 4,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkDestroyOptionsPanelTextBox:SetPoint('BOTTOM', AardvarkSideOptionsFrame, 'BOTTOM', 0, SizeList.checkBoxChildGapX)
AardvarkDestroyOptionsPanelText = AardvarkDestroyOptionsPanelTextBox:CreateFontString('AardvarkDestroyOptionsPanelText')
AardvarkDestroyOptionsPanelText:SetJustifyH('BOTTOM')
AardvarkDestroyOptionsPanelText:SetJustifyV('BOTTOM')
AardvarkDestroyOptionsPanelText:SetAllPoints(AardvarkDestroyOptionsPanelTextBox)
AardvarkDestroyOptionsPanelText:SetFontObject(FontContent)
AardvarkDestroyOptionsPanelText:SetText(TextList.avkDestroyOptions)

--===================          main destroy list panel         ============================
local AardvarkDestroyPanel =
    CreateFrame('Frame', 'AardvarkDestroyPanel', AardvarkMainFrame, 'TooltipBorderedFrameTemplate')
AardvarkDestroyPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyPanel:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkDestroyPanel:SetPoint('BOTTOM', 0, SizeList.mainFrameMarginGap)
AardvarkDestroyPanel:Hide()

local AardvarkDestroyOptionsButton = CreateFrame('Button', 'AardvarkDestroyOptionsButton', AardvarkDestroyPanel)
AardvarkDestroyOptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroyOptionsButton:SetPoint(
    'CENTER',
    AardvarkNavigationSillyButton,
    'CENTER',
    SizeList.mainFrameNavigationButtonSpace * .6 + SizeList.optionsButtonSize,
    0
)
AardvarkDestroyOptionsButton:SetNormalTexture(ImageList.destroyOptions)
AardvarkDestroyOptionsButton:SetHighlightTexture(ImageList.destroyOptionsHover)
AardvarkDestroyOptionsButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkDestroyOptionsButton)
    end
)

local AardvarkDestroyFiltersButton = CreateFrame('Button', 'AardvarkDestroyFiltersButton', AardvarkDestroyPanel)
AardvarkDestroyFiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroyFiltersButton:SetPoint('CENTER', AardvarkDestroyOptionsButton, 'TOP', 0, 15)
AardvarkDestroyFiltersButton:SetNormalTexture(ImageList.destroyFilters)
AardvarkDestroyFiltersButton:SetHighlightTexture(ImageList.destroyFiltersHover)
AardvarkDestroyFiltersButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkFiltersButton)
    end
)

local AardvarkDestroySpecialAddButton = CreateFrame('Button', 'AardvarkDestroySpecialAddButton', AardvarkDestroyPanel)
AardvarkDestroySpecialAddButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroySpecialAddButton:SetPoint('CENTER', AardvarkDestroyOptionsButton, 'BOTTOM', 0, -15)
AardvarkDestroySpecialAddButton:SetNormalTexture(ImageList.destroySpecialAdd)
AardvarkDestroySpecialAddButton:SetHighlightTexture(ImageList.destroySpecialAddHover)
AardvarkDestroySpecialAddButton:SetScript(
    'OnClick',
    function()
        specialAddPanel()
    end
)

--===================          global destroy list panel         ============================
local AardvarkDestroyGlobalTitle = CreateFrame('Frame', 'AardvarkDestroyGlobalTitle', AardvarkDestroyPanel)
AardvarkDestroyGlobalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkDestroyGlobalTitle:SetPoint(
    'TOPLEFT',
    AardvarkDestroyPanel,
    SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkDestroyGlobalTitleText = AardvarkDestroyGlobalTitle:CreateFontString('AardvarkDestroyGlobalTitleText')
AardvarkDestroyGlobalTitleText:SetPoint('CENTER', 0, 0)
AardvarkDestroyGlobalTitleText:SetJustifyH('CENTER')
AardvarkDestroyGlobalTitleText:SetJustifyV('CENTER')
AardvarkDestroyGlobalTitleText:SetAllPoints(AardvarkDestroyGlobalTitle)
AardvarkDestroyGlobalTitleText:SetFontObject(FontTitleScroll)
AardvarkDestroyGlobalTitleText:SetText('Global Destroy List')

local AardvarkDestroyGlobalScrollParent =
    CreateFrame('Button', 'AardvarkDestroyGlobalScrollParent', AardvarkDestroyPanel, 'TooltipBorderedFrameTemplate')
AardvarkDestroyGlobalScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyGlobalScrollParent:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyGlobalScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkDestroyGlobalScrollParent:SetPoint('TOP', AardvarkDestroyGlobalTitle, 'BOTTOM', 0, -8)
AardvarkDestroyGlobalScrollParent:SetScript(
    'OnReceiveDrag',
    function()
        addItemToGlobalList()
    end
)
AardvarkDestroyGlobalScrollParent:SetScript(
    'OnClick',
    function()
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)

local AardvarkDestroyGlobalScrollFrame =
    CreateFrame(
    'ScrollFrame',
    'AardvarkDestroyGlobalScrollFrame',
    AardvarkDestroyGlobalScrollParent,
    'FauxScrollFrameTemplate'
)
AardvarkDestroyGlobalScrollFrame:SetPoint('TOPLEFT', 0, -8)
AardvarkDestroyGlobalScrollFrame:SetPoint('BOTTOMRIGHT', -30, 8)
AardvarkDestroyGlobalScrollFrame:SetScript(
    'OnVerticalScroll',
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateGlobalDestroyList)
    end
)

AardvarkDestroyGlobalScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkDestroyGlobalScrollFrame.buttons[i] = CreateFrame('Button', 'dglb' .. i, AardvarkDestroyGlobalScrollParent)
    local button = AardvarkDestroyGlobalScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject('GameFontHighlightLeft')
    button:SetPoint('TOPLEFT', 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture('Interface\\BUTTONS\\UI-Listbox-Highlight2')
    button:SetScript(
        'OnEnter',
        function(self)
            local itemLink = VariableList.tempGlobalDestroyTable[self.index]
            GameTooltip:SetOwner(self, 'ANCHOR_LEFT', SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Destroy.dlit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                'OnClick',
                function(self)
                    if GetCursorInfo() then
                        addItemToGlobalList()
                    else
                        --table.remove(AVKGlobalDestroyTable, self.index)
                        removeItemFromList(AVKGlobalDestroyTable, itemLink)
                        GameTooltip:Hide()
                        avkUpdateGlobalDestroyList()
                    end
                end
            )
            button:SetScript(
                'OnReceiveDrag',
                function()
                    GameTooltip:Hide()
                    addItemToGlobalList()
                end
            )
        end
    )
    button:SetScript(
        'OnLeave',
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkDestroyGlobalClearListButton =
    CreateFrame('Button', 'AardvarkDestroyGlobalClearListButton', AardvarkDestroyPanel, 'UIMenuButtonStretchTemplate')
AardvarkDestroyGlobalClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkDestroyGlobalClearListButton:SetPoint('TOP', AardvarkDestroyGlobalScrollParent, 'BOTTOM', 0, -5)
AardvarkDestroyGlobalClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyGlobalClearListButton:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyGlobalClearListButton:SetNormalFontObject(FontButton)
AardvarkDestroyGlobalClearListButton:SetHighlightFontObject(FontButton)
AardvarkDestroyGlobalClearListButton:SetFormattedText('Clear Global Destroy List')
AardvarkDestroyGlobalClearListButton:RegisterForClicks('RightButtonUp')
AardvarkDestroyGlobalClearListButton:SetScript(
    'OnClick',
    function()
        wipe(AVKGlobalDestroyTable)
        avkUpdateGlobalDestroyList()
    end
)

--===================          character destroy list panel         ============================
local AardvarkDestroyCharacterTitle = CreateFrame('Frame', 'AardvarkDestroyCharacterTitle', AardvarkDestroyPanel)
AardvarkDestroyCharacterTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkDestroyCharacterTitle:SetPoint(
    'TOPRIGHT',
    AardvarkDestroyPanel,
    -SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkDestroyCharacterTitleText = AardvarkDestroyCharacterTitle:CreateFontString('AardvarkDestroyCharacterTitleText')
AardvarkDestroyCharacterTitleText:SetPoint('CENTER', 0, 0)
AardvarkDestroyCharacterTitleText:SetJustifyH('CENTER')
AardvarkDestroyCharacterTitleText:SetJustifyV('CENTER')
AardvarkDestroyCharacterTitleText:SetAllPoints(AardvarkDestroyCharacterTitle)
AardvarkDestroyCharacterTitleText:SetFontObject(FontTitleScroll)
AardvarkDestroyCharacterTitleText:SetText(playerName .. "'s\nDestroy List")

local AardvarkDestroyCharacterScrollParent =
    CreateFrame('Button', 'AardvarkDestroyCharacterScrollParent', AardvarkDestroyPanel, 'TooltipBorderedFrameTemplate')
AardvarkDestroyCharacterScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyCharacterScrollParent:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyCharacterScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkDestroyCharacterScrollParent:SetPoint('TOP', AardvarkDestroyCharacterTitle, 'BOTTOM', 0, -8)
AardvarkDestroyCharacterScrollParent:SetScript(
    'OnReceiveDrag',
    function()
        addItemToCharacterList()
    end
)
AardvarkDestroyCharacterScrollParent:SetScript(
    'OnClick',
    function()
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

local AardvarkDestroyCharacterScrollFrame =
    CreateFrame(
    'ScrollFrame',
    'AardvarkDestroyCharacterScrollFrame',
    AardvarkDestroyCharacterScrollParent,
    'FauxScrollFrameTemplate'
)
AardvarkDestroyCharacterScrollFrame:SetPoint('TOPLEFT', 0, -8)
AardvarkDestroyCharacterScrollFrame:SetPoint('BOTTOMRIGHT', -30, 8)
AardvarkDestroyCharacterScrollFrame:SetScript(
    'OnVerticalScroll',
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateCharacterDestroyList)
    end
)

AardvarkDestroyCharacterScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkDestroyCharacterScrollFrame.buttons[i] =
        CreateFrame('Button', 'dclb' .. i, AardvarkDestroyCharacterScrollParent)
    local button = AardvarkDestroyCharacterScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject('GameFontHighlightLeft')
    button:SetPoint('TOPLEFT', 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture('Interface\\BUTTONS\\UI-Listbox-Highlight2')
    button:SetScript(
        'OnEnter',
        function(self)
            local itemLink = VariableList.tempCharacterDestroyTable[self.index]
            GameTooltip:SetOwner(self, 'ANCHOR_LEFT', SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Destroy.dlit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                'OnClick',
                function(self)
                    if GetCursorInfo() then
                        addItemToCharacterList()
                    else
                        -- table.remove(AVKCharacterDestroyTable, self.index)
                        removeItemFromList(AVKCharacterDestroyTable, itemLink)
                        GameTooltip:Hide()
                        avkUpdateCharacterDestroyList()
                    end
                end
            )
            button:SetScript(
                'OnReceiveDrag',
                function()
                    GameTooltip:Hide()
                    addItemToCharacterList()
                end
            )
        end
    )
    button:SetScript(
        'OnLeave',
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkDestroyCharacterClearListButton =
    CreateFrame(
    'Button',
    'AardvarkDestroyCharacterClearListButton',
    AardvarkDestroyPanel,
    'UIMenuButtonStretchTemplate'
)
AardvarkDestroyCharacterClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkDestroyCharacterClearListButton:SetPoint('TOP', AardvarkDestroyCharacterScrollParent, 'BOTTOM', 0, -5)
AardvarkDestroyCharacterClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyCharacterClearListButton:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyCharacterClearListButton:SetNormalFontObject(FontButton)
AardvarkDestroyCharacterClearListButton:SetHighlightFontObject(FontButton)
AardvarkDestroyCharacterClearListButton:SetFormattedText('Clear ' .. playerName .. "'s Destroy List")
AardvarkDestroyCharacterClearListButton:RegisterForClicks('RightButtonUp')
AardvarkDestroyCharacterClearListButton:SetScript(
    'OnClick',
    function()
        wipe(AVKCharacterDestroyTable)
        avkUpdateCharacterDestroyList()
    end
)

--===================         protect options panel         ============================
local AardvarkProtectOptionsPanel = CreateFrame('Frame', 'AardvarkProtectOptionsPanel', AardvarkSideOptionsFrame)
AardvarkProtectOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkProtectOptionsPanel:SetPoint('TOP', AardvarkSideOptionsFrame, 'TOP', SizeList.mainFrameMarginGap)
AardvarkProtectOptionsPanel:Hide()

local CBpep = CreateFrame('CheckButton', 'CBpep', AardvarkProtectOptionsPanel, 'UICheckButtonTemplate')
CBpep:ClearAllPoints()
CBpep:SetPoint('TOPLEFT', SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
CBpep:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpep.text:SetText(ColourList.textOrange .. ' Aardvark Protect')
CBpep.text:SetFontObject(FontCheckBoxBig)
CBpep:SetChecked(true)
CBpep:EnableMouse(false)

local CBpialsm = CreateFrame('CheckButton', 'CBpialsm', AardvarkProtectOptionsPanel, 'UICheckButtonTemplate')
CBpialsm:ClearAllPoints()
CBpialsm:SetPoint('TOPLEFT', CBpep, SizeList.checkBoxChildGapX * 1.5, -SizeList.checkboxGapY * 1.2)
CBpialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpialsm.text:SetText(' Item Added Messages')
CBpialsm.text:SetFontObject(FontCheckBox)
CBpialsm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Protect.pialsm then
            AVKGlobalSettings.Protect.pialsm = false
        else
            AVKGlobalSettings.Protect.pialsm = true
        end
    end
)

local CBpdpm = CreateFrame('CheckButton', 'CBpdpm', AardvarkProtectOptionsPanel, 'UICheckButtonTemplate')
CBpdpm:ClearAllPoints()
CBpdpm:SetPoint('TOPLEFT', CBpialsm, 0, -SizeList.checkboxGapY)
CBpdpm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpdpm.text:SetText(' Protected Item Messages')
CBpdpm.text:SetFontObject(FontCheckBox)
CBpdpm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Protect.pdpm then
            AVKGlobalSettings.Protect.pdpm = false
        else
            AVKGlobalSettings.Protect.pdpm = true
        end
    end
)

local CBpcbp = CreateFrame('CheckButton', 'CBpcbp', AardvarkProtectOptionsPanel, 'UICheckButtonTemplate')
CBpcbp:ClearAllPoints()
CBpcbp:SetPoint('TOPLEFT', CBpdpm, 0, -SizeList.checkboxGapY)
CBpcbp:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpcbp.text:SetText(' Protect Caged Battle Pets')
CBpcbp.text:SetFontObject(FontCheckBox)
CBpcbp:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Protect.pcbp then
            AVKGlobalSettings.Protect.pcbp = false
        else
            AVKGlobalSettings.Protect.pcbp = true
        end
        avkUpdateGlobalProtectList()
    end
)

local CBplit = CreateFrame('CheckButton', 'CBplit', AardvarkProtectOptionsPanel, 'UICheckButtonTemplate')
CBplit:ClearAllPoints()
CBplit:SetPoint('TOPLEFT', CBpcbp, 0, -SizeList.checkboxGapY)
CBplit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBplit.text:SetText(' Show Listed Item Tooltips')
CBplit.text:SetFontObject(FontCheckBox)
CBplit:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Protect.plit then
            AVKGlobalSettings.Protect.plit = false
        else
            AVKGlobalSettings.Protect.plit = true
        end
    end
)

local AardvarkProtectOptionsPanelTextBox =
    CreateFrame('Frame', 'AardvarkProtectOptionsPanelTextBox', AardvarkProtectOptionsPanel)
AardvarkProtectOptionsPanelTextBox:SetSize(
    SizeList.mainFrameWidth / 2,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkProtectOptionsPanelTextBox:SetPoint('BOTTOM', AardvarkSideOptionsFrame, 'BOTTOM', 0, SizeList.checkBoxChildGapX)
AardvarkProtectOptionsPanelText = AardvarkProtectOptionsPanelTextBox:CreateFontString('AardvarkProtectOptionsPanelText')
AardvarkProtectOptionsPanelText:SetJustifyH('BOTTOM')
AardvarkProtectOptionsPanelText:SetJustifyV('BOTTOM')
AardvarkProtectOptionsPanelText:SetAllPoints(AardvarkProtectOptionsPanelTextBox)
AardvarkProtectOptionsPanelText:SetFontObject(FontContent)
AardvarkProtectOptionsPanelText:SetText(TextList.avkProtectOptions)

--===================          main protect panel         ============================
local AardvarkProtectPanel =
    CreateFrame('Frame', 'AardvarkProtectPanel', AardvarkMainFrame, 'TooltipBorderedFrameTemplate')
AardvarkProtectPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectPanel:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkProtectPanel:SetPoint('BOTTOM', 0, SizeList.mainFrameMarginGap)
AardvarkProtectPanel:Hide()

local AardvarkProtectOptionsButton = CreateFrame('Button', 'AardvarkProtectOptionsButton', AardvarkProtectPanel)
AardvarkProtectOptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectOptionsButton:SetPoint(
    'CENTER',
    AardvarkNavigationSillyButton,
    'CENTER',
    SizeList.mainFrameNavigationButtonSpace * .6 + SizeList.optionsButtonSize,
    0
)
AardvarkProtectOptionsButton:SetNormalTexture(ImageList.protectOptions)
AardvarkProtectOptionsButton:SetHighlightTexture(ImageList.protectOptionsHover)
AardvarkProtectOptionsButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkProtectOptionsButton)
    end
)

local AardvarkProtectFiltersButton = CreateFrame('Button', 'AardvarkProtectFiltersButton', AardvarkProtectPanel)
AardvarkProtectFiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectFiltersButton:SetPoint('CENTER', AardvarkProtectOptionsButton, 'TOP', 0, 15)
AardvarkProtectFiltersButton:SetNormalTexture(ImageList.protectFilters)
AardvarkProtectFiltersButton:SetHighlightTexture(ImageList.protectFiltersHover)
AardvarkProtectFiltersButton:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkFiltersButton)
    end
)

local AardvarkProtectSpecialAddButton = CreateFrame('Button', 'AardvarkProtectSpecialAddButton', AardvarkProtectPanel)
AardvarkProtectSpecialAddButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectSpecialAddButton:SetPoint('CENTER', AardvarkProtectOptionsButton, 'BOTTOM', 0, -15)
AardvarkProtectSpecialAddButton:SetNormalTexture(ImageList.protectSpecialAdd)
AardvarkProtectSpecialAddButton:SetHighlightTexture(ImageList.protectSpecialAddHover)
AardvarkProtectSpecialAddButton:SetScript(
    'OnClick',
    function()
        specialAddPanel()
    end
)

--===================          global protect list panel         ============================
local AardvarkProtectGlobalTitle = CreateFrame('Frame', 'AardvarkProtectGlobalTitle', AardvarkProtectPanel)
AardvarkProtectGlobalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkProtectGlobalTitle:SetPoint(
    'TOPLEFT',
    AardvarkProtectPanel,
    SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkProtectPanelTitleText = AardvarkProtectGlobalTitle:CreateFontString('AardvarkProtectPanelTitleText')
AardvarkProtectPanelTitleText:SetPoint('CENTER', 0, 0)
AardvarkProtectPanelTitleText:SetJustifyH('CENTER')
AardvarkProtectPanelTitleText:SetJustifyV('CENTER')
AardvarkProtectPanelTitleText:SetAllPoints(AardvarkProtectGlobalTitle)
AardvarkProtectPanelTitleText:SetFontObject(FontTitleScroll)
AardvarkProtectPanelTitleText:SetText('Global Protect List')

local AardvarkProtectGlobalScrollParent =
    CreateFrame('Button', 'AardvarkProtectGlobalScrollParent', AardvarkProtectPanel, 'TooltipBorderedFrameTemplate')
AardvarkProtectGlobalScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectGlobalScrollParent:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectGlobalScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkProtectGlobalScrollParent:SetPoint('TOP', AardvarkProtectGlobalTitle, 'BOTTOM', 0, -8)
AardvarkProtectGlobalScrollParent:SetScript(
    'OnReceiveDrag',
    function()
        addItemToGlobalProtectList()
    end
)
AardvarkProtectGlobalScrollParent:SetScript(
    'OnClick',
    function()
        if GetCursorInfo() then
            addItemToGlobalProtectList()
        end
    end
)

local AardvarkProtectGlobalScrollFrame =
    CreateFrame(
    'ScrollFrame',
    'AardvarkProtectGlobalScrollFrame',
    AardvarkProtectGlobalScrollParent,
    'FauxScrollFrameTemplate'
)
AardvarkProtectGlobalScrollFrame:SetPoint('TOPLEFT', 0, -8)
AardvarkProtectGlobalScrollFrame:SetPoint('BOTTOMRIGHT', -30, 8)
AardvarkProtectGlobalScrollFrame:SetScript(
    'OnVerticalScroll',
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateGlobalProtectList)
    end
)

AardvarkProtectGlobalScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkProtectGlobalScrollFrame.buttons[i] = CreateFrame('Button', 'pglb' .. i, AardvarkProtectGlobalScrollParent)
    local button = AardvarkProtectGlobalScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject('GameFontHighlightLeft')
    button:SetPoint('TOPLEFT', 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture('Interface\\BUTTONS\\UI-Listbox-Highlight2')
    button:SetScript(
        'OnEnter',
        function(self)
            local itemLink = VariableList.tempGlobalProtectTable[self.index]
            GameTooltip:SetOwner(self, 'ANCHOR_LEFT', SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                'OnClick',
                function(self)
                    if GetCursorInfo() then
                        addItemToGlobalProtectList()
                    else
                        removeItemFromList(AVKGlobalProtectTable, itemLink)
                        GameTooltip:Hide()
                        avkUpdateGlobalProtectList()
                    end
                end
            )
            button:SetScript(
                'OnReceiveDrag',
                function()
                    GameTooltip:Hide()
                    addItemToGlobalProtectList()
                end
            )
        end
    )
    button:SetScript(
        'OnLeave',
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkProtectGlobalClearListButton =
    CreateFrame('Button', 'AardvarkProtectGlobalClearListButton', AardvarkProtectPanel, 'UIMenuButtonStretchTemplate')
AardvarkProtectGlobalClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkProtectGlobalClearListButton:SetPoint('TOP', AardvarkProtectGlobalScrollParent, 'BOTTOM', 0, -5)
AardvarkProtectGlobalClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectGlobalClearListButton:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectGlobalClearListButton:SetNormalFontObject(FontButton)
AardvarkProtectGlobalClearListButton:SetHighlightFontObject(FontButton)
AardvarkProtectGlobalClearListButton:SetFormattedText('Clear Global Protect List')
AardvarkProtectGlobalClearListButton:RegisterForClicks('RightButtonUp')
AardvarkProtectGlobalClearListButton:SetScript(
    'OnClick',
    function()
        wipe(AVKGlobalProtectTable)
        avkUpdateGlobalProtectList()
    end
)

--===================          character protect list panel         ============================
local AardvarkProtectCharacterTitle = CreateFrame('Frame', 'AardvarkProtectCharacterTitle', AardvarkProtectPanel)
AardvarkProtectCharacterTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkProtectCharacterTitle:SetPoint(
    'TOPRIGHT',
    AardvarkProtectPanel,
    -SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkProtectCharacterTitleText = AardvarkProtectCharacterTitle:CreateFontString('AardvarkProtectCharacterTitleText')
AardvarkProtectCharacterTitleText:SetPoint('CENTER', 0, 0)
AardvarkProtectCharacterTitleText:SetJustifyH('CENTER')
AardvarkProtectCharacterTitleText:SetJustifyV('CENTER')
AardvarkProtectCharacterTitleText:SetAllPoints(AardvarkProtectCharacterTitle)
AardvarkProtectCharacterTitleText:SetFontObject(FontTitleScroll)
AardvarkProtectCharacterTitleText:SetText(playerName .. "'s\nProtect List")

local AardvarkProtectCharacterScrollParent =
    CreateFrame('Button', 'AardvarkProtectCharacterScrollParent', AardvarkProtectPanel, 'TooltipBorderedFrameTemplate')
AardvarkProtectCharacterScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectCharacterScrollParent:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectCharacterScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkProtectCharacterScrollParent:SetPoint('TOP', AardvarkProtectCharacterTitle, 'BOTTOM', 0, -8)
AardvarkProtectCharacterScrollParent:SetScript(
    'OnReceiveDrag',
    function()
        addItemToCharacterProtectList()
    end
)
AardvarkProtectCharacterScrollParent:SetScript(
    'OnClick',
    function()
        if GetCursorInfo() then
            addItemToCharacterProtectList()
        end
    end
)

local AardvarkProtectCharacterScrollFrame =
    CreateFrame(
    'ScrollFrame',
    'AardvarkProtectCharacterScrollFrame',
    AardvarkProtectCharacterScrollParent,
    'FauxScrollFrameTemplate'
)
AardvarkProtectCharacterScrollFrame:SetPoint('TOPLEFT', 0, -8)
AardvarkProtectCharacterScrollFrame:SetPoint('BOTTOMRIGHT', -30, 8)
AardvarkProtectCharacterScrollFrame:SetScript(
    'OnVerticalScroll',
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateCharacterProtectList)
    end
)

AardvarkProtectCharacterScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkProtectCharacterScrollFrame.buttons[i] =
        CreateFrame('Button', 'pclb' .. i, AardvarkProtectCharacterScrollParent)
    local button = AardvarkProtectCharacterScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject('GameFontHighlightLeft')
    button:SetPoint('TOPLEFT', 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture('Interface\\BUTTONS\\UI-Listbox-Highlight2')
    button:SetScript(
        'OnEnter',
        function(self)
            local itemLink = VariableList.tempCharacterProtectTable[self.index]
            GameTooltip:SetOwner(self, 'ANCHOR_LEFT', SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                'OnClick',
                function(self)
                    if GetCursorInfo() then
                        addItemToCharacterProtectList()
                    else
                        -- table.remove(AVKCharacterProtectTable, self.index)
                        removeItemFromList(AVKCharacterProtectTable, itemLink)
                        GameTooltip:Hide()
                        avkUpdateCharacterProtectList()
                    end
                end
            )
            button:SetScript(
                'OnReceiveDrag',
                function()
                    GameTooltip:Hide()
                    addItemToCharacterProtectList()
                end
            )
        end
    )
    button:SetScript(
        'OnLeave',
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkProtectCharacterClearListButton =
    CreateFrame(
    'Button',
    'AardvarkProtectCharacterClearListButton',
    AardvarkProtectPanel,
    'UIMenuButtonStretchTemplate'
)
AardvarkProtectCharacterClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkProtectCharacterClearListButton:SetPoint('TOP', AardvarkProtectCharacterScrollParent, 'BOTTOM', 0, -5)
AardvarkProtectCharacterClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectCharacterClearListButton:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectCharacterClearListButton:SetNormalFontObject(FontButton)
AardvarkProtectCharacterClearListButton:SetHighlightFontObject(FontButton)
AardvarkProtectCharacterClearListButton:SetFormattedText('Clear ' .. playerName .. "'s Protect List")
AardvarkProtectCharacterClearListButton:RegisterForClicks('RightButtonUp')
AardvarkProtectCharacterClearListButton:SetScript(
    'OnClick',
    function()
        wipe(AVKCharacterProtectTable)
        avkUpdateCharacterProtectList()
    end
)

-- ===========================         repair options panel          ===========================
local AardvarkRepairPanel =
    CreateFrame('Frame', 'AardvarkRepairPanel', AardvarkMainFrame, 'TooltipBorderedFrameTemplate')
AardvarkRepairPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkRepairPanel:SetBackdropBorderColor(1, 0, 1, 1)
AardvarkRepairPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkRepairPanel:SetPoint('BOTTOM', 0, SizeList.mainFrameMarginGap)
AardvarkRepairPanel:Hide()

local CBrer = CreateFrame('CheckButton', 'CBrer', AardvarkRepairPanel, 'UICheckButtonTemplate')
CBrer:ClearAllPoints()
CBrer:SetPoint('TOPLEFT', SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
CBrer:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrer.text:SetText(ColourList.textPink .. ' Aardvark Repair')
CBrer.text:SetFontObject(FontCheckBoxBig)
CBrer:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Repair.rer then
            AVKGlobalSettings.Repair.rer = false
            CBrgr:Hide()
            CBrcarm:Hide()
            CBrntrm:Hide()
            CBrvcrm:Hide()
        else
            AVKGlobalSettings.Repair.rer = true
            CBrgr:Show()
            CBrcarm:Show()
            CBrntrm:Show()
            CBrvcrm:Show()
        end
    end
)

local CBrgr = CreateFrame('CheckButton', 'CBrgr', AardvarkRepairPanel, 'UICheckButtonTemplate')
CBrgr:ClearAllPoints()
CBrgr:SetPoint('TOPLEFT', CBrer, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
CBrgr:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrgr.text:SetText(' Guild Repair')
CBrgr.text:SetFontObject(FontCheckBox)
CBrgr:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Repair.rgr then
            AVKGlobalSettings.Repair.rgr = false
        else
            AVKGlobalSettings.Repair.rgr = true
        end
    end
)

local CBrcarm = CreateFrame('CheckButton', 'CBrcarm', AardvarkRepairPanel, 'UICheckButtonTemplate')
CBrcarm:ClearAllPoints()
CBrcarm:SetPoint('TOPLEFT', CBrgr, 0, -SizeList.checkboxGapY)
CBrcarm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrcarm.text:SetText(' Cannot Afford Repair Messages')
CBrcarm.text:SetFontObject(FontCheckBox)
CBrcarm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Repair.rcarm then
            AVKGlobalSettings.Repair.rcarm = false
        else
            AVKGlobalSettings.Repair.rcarm = true
        end
    end
)

local CBrntrm = CreateFrame('CheckButton', 'CBrntrm', AardvarkRepairPanel, 'UICheckButtonTemplate')
CBrntrm:ClearAllPoints()
CBrntrm:SetPoint('TOPLEFT', CBrcarm, 0, -SizeList.checkboxGapY)
CBrntrm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrntrm.text:SetText(' Nothing To Repair Messages')
CBrntrm.text:SetFontObject(FontCheckBox)
CBrntrm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Repair.rntrm then
            AVKGlobalSettings.Repair.rntrm = false
        else
            AVKGlobalSettings.Repair.rntrm = true
        end
    end
)

local CBrvcrm = CreateFrame('CheckButton', 'CBrvcrm', AardvarkRepairPanel, 'UICheckButtonTemplate')
CBrvcrm:ClearAllPoints()
CBrvcrm:SetPoint('TOPLEFT', CBrntrm, 0, -SizeList.checkboxGapY)
CBrvcrm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrvcrm.text:SetText(' Vendor Cannot Repair Messages')
CBrvcrm.text:SetFontObject(FontCheckBox)
CBrvcrm:SetScript(
    'OnClick',
    function()
        if AVKGlobalSettings.Repair.rvcrm then
            AVKGlobalSettings.Repair.rvcrm = false
        else
            AVKGlobalSettings.Repair.rvcrm = true
        end
    end
)

local AardvarkRepairPanelTextBox = CreateFrame('Frame', 'AardvarkRepairPanelTextBox', AardvarkRepairPanel)
AardvarkRepairPanelTextBox:SetSize(
    SizeList.scrollFrameWidth - SizeList.textBoxWidthShrink,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkRepairPanelTextBox:SetPoint('TOPRIGHT', -SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
AardvarkRepairPanelText = AardvarkRepairPanelTextBox:CreateFontString('AardvarkRepairPanelText')
AardvarkRepairPanelText:SetJustifyH('CENTER')
AardvarkRepairPanelText:SetJustifyV('TOP')
AardvarkRepairPanelText:SetAllPoints(AardvarkRepairPanelTextBox)
AardvarkRepairPanelText:SetFontObject(FontContent)
AardvarkRepairPanelText:SetText(TextList.avkRepairOptions)

-- ===========================         aardvark silly panel          ===========================
local AardvarkSillyPanel = CreateFrame('Frame', 'AardvarkSillyPanel', AardvarkMainFrame, 'TooltipBorderedFrameTemplate')
AardvarkSillyPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSillyPanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkSillyPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkSillyPanel:SetPoint('BOTTOM', 0, SizeList.mainFrameMarginGap)
AardvarkSillyPanel:Hide()

local AardvarkSillyPanelTextBox = CreateFrame('Frame', 'AardvarkSillyPanelTextBox', AardvarkSillyPanel)
AardvarkSillyPanelTextBox:SetSize(
    SizeList.mainPanelWidth - SizeList.mainPanelElementGap,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkSillyPanelTextBox:SetPoint('TOP', AardvarkSillyPanel, 0, -11)
AardvarkSillyText = AardvarkSillyPanelTextBox:CreateFontString('AardvarkSillyText')
AardvarkSillyText:SetAllPoints(AardvarkSillyPanelTextBox)
AardvarkSillyText:SetFontObject(FontContent)
AardvarkSillyText:SetText(TextList.avkAboutAardvark)

-- ===========================         scale panel          ===========================
local AardvarkScalePanel = CreateFrame('Frame', 'AardvarkScalePanel', UIParent, 'TooltipBorderedFrameTemplate')
AardvarkScalePanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkScalePanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkScalePanel:ClearAllPoints()
AardvarkScalePanel:SetPoint('BOTTOMRIGHT', AardvarkMainFrame, 'BOTTOMLEFT', SizeList.mainFrameSetPoint, 0)
AardvarkScalePanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
-- AardvarkScalePanel:SetParent(AardvarkMainFrame)
-- AardvarkScalePanel:SetScale(1)
AardvarkScalePanel:SetClampedToScreen(true)
AardvarkScalePanel:EnableMouse(true)
AardvarkScalePanel:SetMovable(true)
AardvarkScalePanel:RegisterForDrag('RightButton', 'LeftButton')
AardvarkScalePanel:SetScript('OnDragStart', AardvarkScalePanel.StartMoving)
AardvarkScalePanel:SetScript('OnDragStop', AardvarkScalePanel.StopMovingOrSizing)
AardvarkScalePanel:SetToplevel(true)
AardvarkScalePanel:Hide()

local AardvarkScaleFrameCloseButton = CreateFrame('Button', 'AardvarkScaleFrameCloseButton', AardvarkScalePanel)
AardvarkScaleFrameCloseButton:SetPoint('TOPRIGHT', SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkScaleFrameCloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkScaleFrameCloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkScaleFrameCloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkScaleFrameCloseButton:SetScript(
    'OnClick',
    function(self)
        AardvarkScalePanel:Hide()
    end
)

local AardvarkMagicButtonScaler =
    CreateFrame('Slider', 'AardvarkMagicButtonScaler', AardvarkScalePanel, 'OptionsSliderTemplate')
AardvarkMagicButtonScaler:SetPoint('CENTER', 0, 0)
AardvarkMagicButtonScaler:SetScale(SizeList.scaleSliderScale)
AardvarkMagicButtonScaler.textLow = _G['AardvarkMagicButtonScaler' .. 'Low']
AardvarkMagicButtonScaler.textHigh = _G['AardvarkMagicButtonScaler' .. 'High']
AardvarkMagicButtonScaler.text = _G['AardvarkMagicButtonScaler' .. 'Text']
AardvarkMagicButtonScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkMagicButtonScaler.minValue, AardvarkMagicButtonScaler.maxValue = AardvarkMagicButtonScaler:GetMinMaxValues()
AardvarkMagicButtonScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ('%'))
AardvarkMagicButtonScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ('%'))
AardvarkMagicButtonScalerText:SetFontObject(FontButton)
AardvarkMagicButtonScalerText:SetText(ColourList.textBlue .. 'Aardvark Button')
AardvarkMagicButtonScaler:SetValue(.5)
AardvarkMagicButtonScaler:SetValueStep(1)
AardvarkMagicButtonScaler:SetScript(
    'OnValueChanged',
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.ambs = tonumber(event)
        AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
    end
)

local AardvarkMainFrameScaler =
    CreateFrame('Slider', 'AardvarkMainFrameScaler', AardvarkScalePanel, 'OptionsSliderTemplate')
AardvarkMainFrameScaler:SetPoint('CENTER', AardvarkMagicButtonScaler, 0, SizeList.scaleButtonGap)
AardvarkMainFrameScaler:SetScale(SizeList.scaleSliderScale)
AardvarkMainFrameScaler.textLow = _G['AardvarkMainFrameScaler' .. 'Low']
AardvarkMainFrameScaler.textHigh = _G['AardvarkMainFrameScaler' .. 'High']
AardvarkMainFrameScaler.text = _G['AardvarkMainFrameScaler' .. 'Text']
AardvarkMainFrameScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkMainFrameScaler.minValue, AardvarkMainFrameScaler.maxValue = AardvarkMainFrameScaler:GetMinMaxValues()
AardvarkMainFrameScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ('%'))
AardvarkMainFrameScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ('%'))
AardvarkMainFrameScalerText:SetFontObject(FontButton)
AardvarkMainFrameScalerText:SetText(ColourList.textBlue .. 'Aardvark Frame')
AardvarkMainFrameScaler:SetValue(.5)
AardvarkMainFrameScaler:SetValueStep(1)
AardvarkMainFrameScaler:SetScript(
    'OnValueChanged',
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.amfs = tonumber(event)
        AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
    end
)

local AardvarkActionBarScaler =
    CreateFrame('Slider', 'AardvarkActionBarScaler', AardvarkScalePanel, 'OptionsSliderTemplate')
AardvarkActionBarScaler:SetPoint('CENTER', AardvarkMagicButtonScaler, 0, -SizeList.scaleButtonGap)
AardvarkActionBarScaler:SetScale(SizeList.scaleSliderScale)
AardvarkActionBarScaler.textLow = _G['AardvarkActionBarScaler' .. 'Low']
AardvarkActionBarScaler.textHigh = _G['AardvarkActionBarScaler' .. 'High']
AardvarkActionBarScaler.text = _G['AardvarkActionBarScaler' .. 'Text']
AardvarkActionBarScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkActionBarScaler.minValue, AardvarkActionBarScaler.maxValue = AardvarkActionBarScaler:GetMinMaxValues()
AardvarkActionBarScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ('%'))
AardvarkActionBarScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ('%'))
AardvarkActionBarScalerText:SetFontObject(FontButton)
AardvarkActionBarScalerText:SetText(ColourList.textBlue .. 'Aardvark Action Bar')
AardvarkActionBarScaler:SetValue(1)
AardvarkActionBarScaler:SetValueStep(1)
AardvarkActionBarScaler:SetScript(
    'OnValueChanged',
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.aabs = tonumber(event)
        AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         aardvark magic button          ===========================
-- ===================================================================================================
-- ===================================================================================================

AardvarkMagicButton = CreateFrame('Button', 'AardvarkMagicButton', UIParent)
AardvarkMagicButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkMagicButton:ClearAllPoints()
AardvarkMagicButton:SetPoint('BOTTOMRIGHT', AardvarkMainFrame, 'TOPRIGHT', 0, 20)
AardvarkMagicButton:SetNormalTexture(ImageList.avkButton)
AardvarkMagicButton:SetHighlightTexture(ImageList.avkButtonHover, 'BLEND')
AardvarkMagicButton:SetMovable(true)
AardvarkMagicButton:SetClampedToScreen(true)
AardvarkMagicButton:RegisterForDrag('MiddleButton')
AardvarkMagicButton:SetScript('OnDragStart', AardvarkMagicButton.StartMoving)
AardvarkMagicButton:SetScript('OnDragStop', AardvarkMagicButton.StopMovingOrSizing)
AardvarkMagicButton:SetToplevel(true)
AardvarkMagicButton:SetScript(
    'OnEnter',
    function(self)
        GameTooltip:SetOwner(self, 'ANCHOR_TOP', 5, 5)
        GameTooltip:AddDoubleLine(addonName, versionNumber, 0, 1, 1, 0, 1, 1)
        GameTooltip:AddLine(TextList.avkMagicButton)
        if AVKGlobalSettings.Aardvark.amfbt then
            GameTooltip:Show()
        else
            GameTooltip:Hide()
        end
        AardvarkMagicButton:SetScript(
            'OnReceiveDrag',
            function()
                if GetCursorInfo() then
                    if IsAltKeyDown() then
                        addItemToGlobalList()
                        updateListBasedOnPanel()
                    else
                        addItemToCharacterList()
                        updateListBasedOnPanel()
                    end
                end
            end
        )
        AardvarkMagicButton:RegisterForClicks('RightButtonUp', 'LeftButtonUp')
        AardvarkMagicButton:SetScript(
            'OnClick',
            function(self, button)
                if button == 'RightButton' then
                    avkDestroy()
                elseif button == 'LeftButton' then
                    if GetCursorInfo() then
                        if IsControlKeyDown() then
                            addItemToGlobalProtectList()
                            updateListBasedOnPanel()
                        elseif IsAltKeyDown() then
                            addItemToGlobalList()
                            updateListBasedOnPanel()
                        else
                            addItemToCharacterList()
                            updateListBasedOnPanel()
                        end
                    else
                        if AardvarkMainFrame:IsVisible() then
                            AardvarkMainFrame:Hide()
                        else
                            AardvarkMainFrame:Show()
                            updateListBasedOnPanel()
                        end
                    end
                end
            end
        )
    end
)
AardvarkMagicButton:SetScript(
    'OnLeave',
    function(self)
        GameTooltip:Hide()
        GameTooltip:SetScale(1)
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         aardvark action bar          ===========================
-- ===================================================================================================
-- ===================================================================================================

AardvarkActionBar = CreateFrame('Frame', 'AardvarkActionBar', UIParent)
AardvarkActionBar:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkActionBar:SetMovable(true)
AardvarkActionBar:SetClampedToScreen(true)
AardvarkActionBar:SetToplevel(true)
AardvarkActionBar:Hide()

ActionBarAardvarkButton = CreateFrame('Button', 'ActionBarAardvarkButton', AardvarkActionBar)
ActionBarAardvarkButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarAardvarkButton:SetNormalTexture(ImageList.avkButton)
ActionBarAardvarkButton:SetHighlightTexture(ImageList.avkButtonHover, 'BLEND')
ActionBarAardvarkButton:EnableMouse(true)
ActionBarAardvarkButton:SetMovable(true)
ActionBarAardvarkButton:SetClampedToScreen(true)
ActionBarAardvarkButton:RegisterForDrag('MiddleButton')
ActionBarAardvarkButton:SetScript(
    'OnDragStart',
    function()
        ActionBarAardvarkButton:GetParent():StartMoving()
    end
)
ActionBarAardvarkButton:SetScript(
    'OnDragStop',
    function()
        ActionBarAardvarkButton:GetParent():StopMovingOrSizing()
    end
)
ActionBarAardvarkButton:SetScript(
    'OnClick',
    function()
        if AardvarkMainFrame:IsVisible() then
            AardvarkMainFrame:Hide()
        else
            AardvarkMainFrame:Show()
            updateListBasedOnPanel()
        end
    end
)

ActionBarDestroyButton = CreateFrame('Button', 'ActionBarDestroyButton', AardvarkActionBar)
ActionBarDestroyButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarDestroyButton:SetNormalTexture(ImageList.destroyButton)
ActionBarDestroyButton:SetHighlightTexture(ImageList.destroyButtonHover, 'BLEND')
ActionBarDestroyButton:RegisterForClicks('RightButtonUp')
ActionBarDestroyButton:SetScript(
    'OnClick',
    function(self, button)
        if button == 'RightButton' then
            avkDestroy()
        end
    end
)

ActionBarSellButton = CreateFrame('Button', 'ActionBarSellButton', AardvarkActionBar)
ActionBarSellButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarSellButton:SetNormalTexture(ImageList.sellButton)
ActionBarSellButton:SetHighlightTexture(ImageList.sellButtonHover, 'BLEND')
ActionBarSellButton:SetDisabledTexture(ImageList.sellOutOfRange)
ActionBarSellButton:Disable()
ActionBarSellButton:SetScript(
    'OnClick',
    function(self, button)
        avkSell()
    end
)

ActionBarProtectGlobalButton = CreateFrame('Button', 'ActionBarProtectGlobalButton', AardvarkActionBar)
ActionBarProtectGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarProtectGlobalButton:SetNormalTexture(ImageList.protectGlobal)
ActionBarProtectGlobalButton:SetHighlightTexture(ImageList.protectGlobalHover, 'BLEND')
ActionBarProtectGlobalButton:SetScript('OnReceiveDrag', addItemToGlobalProtectList)
ActionBarProtectGlobalButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            addItemToGlobalProtectList()
        end
    end
)

ActionBarProtectCharacterButton = CreateFrame('Button', 'ActionBarProtectCharacterButton', AardvarkActionBar)
ActionBarProtectCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarProtectCharacterButton:SetNormalTexture(ImageList.protectCharacter)
ActionBarProtectCharacterButton:SetHighlightTexture(ImageList.protectCharacterHover, 'BLEND')
ActionBarProtectCharacterButton:SetScript('OnReceiveDrag', addItemToCharacterProtectList)
ActionBarProtectCharacterButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            addItemToCharacterProtectList()
        end
    end
)

ActionBarDestroyGlobalButton = CreateFrame('Button', 'ActionBarDestroyGlobalButton', AardvarkActionBar)
ActionBarDestroyGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarDestroyGlobalButton:SetNormalTexture(ImageList.destroyGlobal)
ActionBarDestroyGlobalButton:SetHighlightTexture(ImageList.destroyGlobalHover, 'BLEND')
ActionBarDestroyGlobalButton:SetScript('OnReceiveDrag', addItemToGlobalList)
ActionBarDestroyGlobalButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)

ActionBarDestroyCharacterButton = CreateFrame('Button', 'ActionBarDestroyCharacterButton', AardvarkActionBar)
ActionBarDestroyCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarDestroyCharacterButton:SetNormalTexture(ImageList.destroyCharacter)
ActionBarDestroyCharacterButton:SetHighlightTexture(ImageList.destroyCharacterHover, 'BLEND')
ActionBarDestroyCharacterButton:SetScript('OnReceiveDrag', addItemToCharacterList)
ActionBarDestroyCharacterButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

ActionBarSellGlobalButton = CreateFrame('Button', 'ActionBarSellGlobalButton', AardvarkActionBar)
ActionBarSellGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarSellGlobalButton:SetNormalTexture(ImageList.sellGlobal)
ActionBarSellGlobalButton:SetHighlightTexture(ImageList.sellGlobalHover, 'BLEND')
ActionBarSellGlobalButton:SetScript('OnReceiveDrag', addItemToGlobalList)
ActionBarSellGlobalButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)

ActionBarSellCharacterButton = CreateFrame('Button', 'ActionBarSellCharacterButton', AardvarkActionBar)
ActionBarSellCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarSellCharacterButton:SetNormalTexture(ImageList.sellCharacter)
ActionBarSellCharacterButton:SetHighlightTexture(ImageList.sellCharacterHover, 'BLEND')
ActionBarSellCharacterButton:SetScript('OnReceiveDrag', addItemToCharacterList)
ActionBarSellCharacterButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         filter list panel          ===========================
-- ===================================================================================================
-- ===================================================================================================

local AardvarkFilterOptionsPanel = CreateFrame('Frame', 'AardvarkFilterOptionsPanel', AardvarkSideOptionsFrame)
AardvarkFilterOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkFilterOptionsPanel:SetPoint('TOP', AardvarkSideOptionsFrame, 'TOP', SizeList.mainFrameMarginGap)
AardvarkFilterOptionsPanel:Hide()

-- ===========================         Check & Uncheck Buttons          ===========================
local AardvarkFilterCheckAll =
    CreateFrame('Button', 'AardvarkFilterCheckAll', AardvarkFilterOptionsPanel, 'UIMenuButtonStretchTemplate')
AardvarkFilterCheckAll:SetSize(SizeList.scrollFrameWidth * .4, SizeList.clearButtonHight)
AardvarkFilterCheckAll:SetPoint('TOPLEFT', AardvarkFilterOptionsPanel, 13, -SizeList.checkboxFilterGapY * 1.1)
AardvarkFilterCheckAll:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkFilterCheckAll:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkFilterCheckAll:SetNormalFontObject(FontButton)
AardvarkFilterCheckAll:SetHighlightFontObject(FontButton)
AardvarkFilterCheckAll:SetFormattedText('Check All')
AardvarkFilterCheckAll:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkFilterCheckAll)
        updateListBasedOnPanel()
    end
)

local AardvarkFilterUncheckAll =
    CreateFrame('Button', 'AardvarkFilterUncheckAll', AardvarkFilterOptionsPanel, 'UIMenuButtonStretchTemplate')
AardvarkFilterUncheckAll:SetSize(SizeList.scrollFrameWidth * .4, SizeList.clearButtonHight)
AardvarkFilterUncheckAll:SetPoint('RIGHT', AardvarkFilterCheckAll, SizeList.checkboxFilterGapX, 0)
AardvarkFilterUncheckAll:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkFilterUncheckAll:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkFilterUncheckAll:SetNormalFontObject(FontButton)
AardvarkFilterUncheckAll:SetHighlightFontObject(FontButton)
AardvarkFilterUncheckAll:SetFormattedText('Uncheck All')
AardvarkFilterUncheckAll:SetScript(
    'OnClick',
    function()
        toggleAVKPanels(AardvarkFilterUncheckAll)
        updateListBasedOnPanel()
    end
)

-- ===========================         item rarity          ===========================
local CB_rarity_poor = CreateFrame('CheckButton', 'CB_rarity_poor', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_poor:ClearAllPoints()
CB_rarity_poor:SetPoint('TOPLEFT', AardvarkFilterCheckAll, 0, -SizeList.checkboxFilterGapY * 2)
CB_rarity_poor:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_poor.text:SetText(ColourList.rarityPoor .. '  Poor')
CB_rarity_poor.text:SetFontObject(FontFilter)
CB_rarity_poor:SetChecked(true)
CB_rarity_poor:SetScript(
    'OnClick',
    function()
        if FilterList.rarityPoor then
            FilterList.rarityPoor = false
        else
            FilterList.rarityPoor = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_common =
    CreateFrame('CheckButton', 'CB_rarity_common', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_common:ClearAllPoints()
CB_rarity_common:SetPoint('BOTTOM', CB_rarity_poor, 0, -SizeList.checkboxFilterGapY)
CB_rarity_common:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_common.text:SetText(ColourList.rarityCommon .. '  Common')
CB_rarity_common.text:SetFontObject(FontFilter)
CB_rarity_common:SetChecked(true)
CB_rarity_common:SetScript(
    'OnClick',
    function()
        if FilterList.rarityCommon then
            FilterList.rarityCommon = false
        else
            FilterList.rarityCommon = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_uncommon =
    CreateFrame('CheckButton', 'CB_rarity_uncommon', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_uncommon:ClearAllPoints()
CB_rarity_uncommon:SetPoint('BOTTOM', CB_rarity_common, 0, -SizeList.checkboxFilterGapY)
CB_rarity_uncommon:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_uncommon.text:SetText(ColourList.rarityUncommon .. '  Uncommon')
CB_rarity_uncommon.text:SetFontObject(FontFilter)
CB_rarity_uncommon:SetChecked(true)
CB_rarity_uncommon:SetScript(
    'OnClick',
    function()
        if FilterList.rarityUncommon then
            FilterList.rarityUncommon = false
        else
            FilterList.rarityUncommon = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_rare = CreateFrame('CheckButton', 'CB_rarity_rare', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_rare:ClearAllPoints()
CB_rarity_rare:SetPoint('BOTTOM', CB_rarity_uncommon, 0, -SizeList.checkboxFilterGapY)
CB_rarity_rare:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_rare.text:SetText(ColourList.rarityRare .. '  Rare')
CB_rarity_rare.text:SetFontObject(FontFilter)
CB_rarity_rare:SetChecked(true)
CB_rarity_rare:SetScript(
    'OnClick',
    function()
        if FilterList.rarityRare then
            FilterList.rarityRare = false
        else
            FilterList.rarityRare = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_epic = CreateFrame('CheckButton', 'CB_rarity_epic', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_epic:ClearAllPoints()
CB_rarity_epic:SetPoint('TOPLEFT', AardvarkFilterUncheckAll, 0, -SizeList.checkboxFilterGapY * 2)
CB_rarity_epic:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_epic.text:SetText(ColourList.rarityEpic .. '  Epic')
CB_rarity_epic.text:SetFontObject(FontFilter)
CB_rarity_epic:SetChecked(true)
CB_rarity_epic:SetScript(
    'OnClick',
    function()
        if FilterList.rarityEpic then
            FilterList.rarityEpic = false
        else
            FilterList.rarityEpic = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_legendary =
    CreateFrame('CheckButton', 'CB_rarity_legendary', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_legendary:ClearAllPoints()
CB_rarity_legendary:SetPoint('BOTTOM', CB_rarity_epic, 0, -SizeList.checkboxFilterGapY)
CB_rarity_legendary:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_legendary.text:SetText(ColourList.rarityLegendary .. '  Legendary')
CB_rarity_legendary.text:SetFontObject(FontFilter)
CB_rarity_legendary:SetChecked(true)
CB_rarity_legendary:SetScript(
    'OnClick',
    function()
        if FilterList.rarityLegendary then
            FilterList.rarityLegendary = false
        else
            FilterList.rarityLegendary = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_artifact =
    CreateFrame('CheckButton', 'CB_rarity_artifact', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_artifact:ClearAllPoints()
CB_rarity_artifact:SetPoint('BOTTOM', CB_rarity_legendary, 0, -SizeList.checkboxFilterGapY)
CB_rarity_artifact:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_artifact.text:SetText(ColourList.rarityArtifact .. '  Artifact')
CB_rarity_artifact.text:SetFontObject(FontFilter)
CB_rarity_artifact:SetChecked(true)
CB_rarity_artifact:SetScript(
    'OnClick',
    function()
        if FilterList.rarityArtifact then
            FilterList.rarityArtifact = false
        else
            FilterList.rarityArtifact = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_heirloom =
    CreateFrame('CheckButton', 'CB_rarity_heirloom', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_rarity_heirloom:ClearAllPoints()
CB_rarity_heirloom:SetPoint('BOTTOM', CB_rarity_artifact, 0, -SizeList.checkboxFilterGapY)
CB_rarity_heirloom:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_heirloom.text:SetText(ColourList.rarityHeirloom .. '  Heirloom')
CB_rarity_heirloom.text:SetFontObject(FontFilter)
CB_rarity_heirloom:SetChecked(true)
CB_rarity_heirloom:SetScript(
    'OnClick',
    function()
        if FilterList.rarityHeirloom then
            FilterList.rarityHeirloom = false
        else
            FilterList.rarityHeirloom = true
        end
        updateListBasedOnPanel()
    end
)

-- ===========================         item equip slot          ===========================
local CB_slot_head = CreateFrame('CheckButton', 'CB_slot_head', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_head:ClearAllPoints()
CB_slot_head:SetPoint('BOTTOM', CB_rarity_rare, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_slot_head:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_head.text:SetText('  Head')
CB_slot_head.text:SetFontObject(FontFilter)
CB_slot_head:SetChecked(true)
CB_slot_head:SetScript(
    'OnClick',
    function()
        if FilterList.slotHead then
            FilterList.slotHead = false
        else
            FilterList.slotHead = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_neck = CreateFrame('CheckButton', 'CB_slot_neck', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_neck:ClearAllPoints()
CB_slot_neck:SetPoint('BOTTOM', CB_slot_head, 0, -SizeList.checkboxFilterGapY)
CB_slot_neck:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_neck.text:SetText('  Neck')
CB_slot_neck.text:SetFontObject(FontFilter)
CB_slot_neck:SetChecked(true)
CB_slot_neck:SetScript(
    'OnClick',
    function()
        if FilterList.slotNeck then
            FilterList.slotNeck = false
        else
            FilterList.slotNeck = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_shoulders =
    CreateFrame('CheckButton', 'CB_slot_shoulders', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_shoulders:ClearAllPoints()
CB_slot_shoulders:SetPoint('BOTTOM', CB_slot_neck, 0, -SizeList.checkboxFilterGapY)
CB_slot_shoulders:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_shoulders.text:SetText('  Shoulders')
CB_slot_shoulders.text:SetFontObject(FontFilter)
CB_slot_shoulders:SetChecked(true)
CB_slot_shoulders:SetScript(
    'OnClick',
    function()
        if FilterList.slotShoulders then
            FilterList.slotShoulders = false
        else
            FilterList.slotShoulders = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_cloak = CreateFrame('CheckButton', 'CB_slot_cloak', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_cloak:ClearAllPoints()
CB_slot_cloak:SetPoint('BOTTOM', CB_slot_shoulders, 0, -SizeList.checkboxFilterGapY)
CB_slot_cloak:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_cloak.text:SetText('  Cloak')
CB_slot_cloak.text:SetFontObject(FontFilter)
CB_slot_cloak:SetChecked(true)
CB_slot_cloak:SetScript(
    'OnClick',
    function()
        if FilterList.slotCloak then
            FilterList.slotCloak = false
        else
            FilterList.slotCloak = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_chest = CreateFrame('CheckButton', 'CB_slot_chest', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_chest:ClearAllPoints()
CB_slot_chest:SetPoint('BOTTOM', CB_slot_cloak, 0, -SizeList.checkboxFilterGapY)
CB_slot_chest:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_chest.text:SetText('  Chest')
CB_slot_chest.text:SetFontObject(FontFilter)
CB_slot_chest:SetChecked(true)
CB_slot_chest:SetScript(
    'OnClick',
    function()
        if FilterList.slotChest then
            FilterList.slotChest = false
        else
            FilterList.slotChest = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_shirt = CreateFrame('CheckButton', 'CB_slot_shirt', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_shirt:ClearAllPoints()
CB_slot_shirt:SetPoint('BOTTOM', CB_slot_chest, 0, -SizeList.checkboxFilterGapY)
CB_slot_shirt:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_shirt.text:SetText('  Shirt')
CB_slot_shirt.text:SetFontObject(FontFilter)
CB_slot_shirt:SetChecked(true)
CB_slot_shirt:SetScript(
    'OnClick',
    function()
        if FilterList.slotShirt then
            FilterList.slotShirt = false
        else
            FilterList.slotShirt = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_tabard = CreateFrame('CheckButton', 'CB_slot_tabard', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_tabard:ClearAllPoints()
CB_slot_tabard:SetPoint('BOTTOM', CB_slot_shirt, 0, -SizeList.checkboxFilterGapY)
CB_slot_tabard:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_tabard.text:SetText('  Tabard')
CB_slot_tabard.text:SetFontObject(FontFilter)
CB_slot_tabard:SetChecked(true)
CB_slot_tabard:SetScript(
    'OnClick',
    function()
        if FilterList.slotTabard then
            FilterList.slotTabard = false
        else
            FilterList.slotTabard = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_wrists = CreateFrame('CheckButton', 'CB_slot_wrists', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_wrists:ClearAllPoints()
CB_slot_wrists:SetPoint('BOTTOM', CB_slot_tabard, 0, -SizeList.checkboxFilterGapY)
CB_slot_wrists:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_wrists.text:SetText('  Wrists')
CB_slot_wrists.text:SetFontObject(FontFilter)
CB_slot_wrists:SetChecked(true)
CB_slot_wrists:SetScript(
    'OnClick',
    function()
        if FilterList.slotWrists then
            FilterList.slotWrists = false
        else
            FilterList.slotWrists = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_hands = CreateFrame('CheckButton', 'CB_slot_hands', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_hands:ClearAllPoints()
CB_slot_hands:SetPoint('BOTTOM', CB_rarity_heirloom, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_slot_hands:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_hands.text:SetText('  Gloves')
CB_slot_hands.text:SetFontObject(FontFilter)
CB_slot_hands:SetChecked(true)
CB_slot_hands:SetScript(
    'OnClick',
    function()
        if FilterList.slotHands then
            FilterList.slotHands = false
        else
            FilterList.slotHands = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_waist = CreateFrame('CheckButton', 'CB_slot_waist', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_waist:ClearAllPoints()
CB_slot_waist:SetPoint('BOTTOM', CB_slot_hands, 0, -SizeList.checkboxFilterGapY)
CB_slot_waist:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_waist.text:SetText('  Belt')
CB_slot_waist.text:SetFontObject(FontFilter)
CB_slot_waist:SetChecked(true)
CB_slot_waist:SetScript(
    'OnClick',
    function()
        if FilterList.slotWaist then
            FilterList.slotWaist = false
        else
            FilterList.slotWaist = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_legs = CreateFrame('CheckButton', 'CB_slot_legs', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_legs:ClearAllPoints()
CB_slot_legs:SetPoint('BOTTOM', CB_slot_waist, 0, -SizeList.checkboxFilterGapY)
CB_slot_legs:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_legs.text:SetText('  Legs')
CB_slot_legs.text:SetFontObject(FontFilter)
CB_slot_legs:SetChecked(true)
CB_slot_legs:SetScript(
    'OnClick',
    function()
        if FilterList.slotLegs then
            FilterList.slotLegs = false
        else
            FilterList.slotLegs = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_feet = CreateFrame('CheckButton', 'CB_slot_feet', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_feet:ClearAllPoints()
CB_slot_feet:SetPoint('BOTTOM', CB_slot_legs, 0, -SizeList.checkboxFilterGapY)
CB_slot_feet:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_feet.text:SetText('  Feet')
CB_slot_feet.text:SetFontObject(FontFilter)
CB_slot_feet:SetChecked(true)
CB_slot_feet:SetScript(
    'OnClick',
    function()
        if FilterList.slotFeet then
            FilterList.slotFeet = false
        else
            FilterList.slotFeet = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_rings = CreateFrame('CheckButton', 'CB_slot_rings', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_rings:ClearAllPoints()
CB_slot_rings:SetPoint('BOTTOM', CB_slot_feet, 0, -SizeList.checkboxFilterGapY)
CB_slot_rings:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_rings.text:SetText('  Rings')
CB_slot_rings.text:SetFontObject(FontFilter)
CB_slot_rings:SetChecked(true)
CB_slot_rings:SetScript(
    'OnClick',
    function()
        if FilterList.slotRings then
            FilterList.slotRings = false
        else
            FilterList.slotRings = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_trinkets =
    CreateFrame('CheckButton', 'CB_slot_trinkets', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_trinkets:ClearAllPoints()
CB_slot_trinkets:SetPoint('BOTTOM', CB_slot_rings, 0, -SizeList.checkboxFilterGapY)
CB_slot_trinkets:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_trinkets.text:SetText('  Trinkets')
CB_slot_trinkets.text:SetFontObject(FontFilter)
CB_slot_trinkets:SetChecked(true)
CB_slot_trinkets:SetScript(
    'OnClick',
    function()
        if FilterList.slotTrinkets then
            FilterList.slotTrinkets = false
        else
            FilterList.slotTrinkets = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_mainHand =
    CreateFrame('CheckButton', 'CB_slot_mainHand', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_mainHand:ClearAllPoints()
CB_slot_mainHand:SetPoint('BOTTOM', CB_slot_trinkets, 0, -SizeList.checkboxFilterGapY)
CB_slot_mainHand:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_mainHand.text:SetText('  Main Hand')
CB_slot_mainHand.text:SetFontObject(FontFilter)
CB_slot_mainHand:SetChecked(true)
CB_slot_mainHand:SetScript(
    'OnClick',
    function()
        if FilterList.slotMainHand then
            FilterList.slotMainHand = false
        else
            FilterList.slotMainHand = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_offHand =
    CreateFrame('CheckButton', 'CB_slot_offHand', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_slot_offHand:ClearAllPoints()
CB_slot_offHand:SetPoint('BOTTOM', CB_slot_mainHand, 0, -SizeList.checkboxFilterGapY)
CB_slot_offHand:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_offHand.text:SetText('  Off Hand')
CB_slot_offHand.text:SetFontObject(FontFilter)
CB_slot_offHand:SetChecked(true)
CB_slot_offHand:SetScript(
    'OnClick',
    function()
        if FilterList.slotOffHand then
            FilterList.slotOffHand = false
        else
            FilterList.slotOffHand = true
        end
        updateListBasedOnPanel()
    end
)

-- ===========================         item bind          ===========================
local CB_bind_none = CreateFrame('CheckButton', 'CB_bind_none', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_bind_none:ClearAllPoints()
CB_bind_none:SetPoint('BOTTOM', CB_slot_wrists, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_bind_none:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_none.text:SetText('  No Bind')
CB_bind_none.text:SetFontObject(FontFilter)
CB_bind_none:SetChecked(true)
CB_bind_none:SetScript(
    'OnClick',
    function()
        if FilterList.bindingNone then
            FilterList.bindingNone = false
        else
            FilterList.bindingNone = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_bop = CreateFrame('CheckButton', 'CB_bind_bop', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_bind_bop:ClearAllPoints()
CB_bind_bop:SetPoint('BOTTOM', CB_bind_none, 0, -SizeList.checkboxFilterGapY)
CB_bind_bop:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_bop.text:SetText('  Bind on Pickup')
CB_bind_bop.text:SetFontObject(FontFilter)
CB_bind_bop:SetChecked(true)
CB_bind_bop:SetScript(
    'OnClick',
    function()
        if FilterList.bindOnPickup then
            FilterList.bindOnPickup = false
        else
            FilterList.bindOnPickup = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_boe = CreateFrame('CheckButton', 'CB_bind_boe', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_bind_boe:ClearAllPoints()
CB_bind_boe:SetPoint('BOTTOM', CB_slot_offHand, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_bind_boe:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_boe.text:SetText('  Bind on Equip')
CB_bind_boe.text:SetFontObject(FontFilter)
CB_bind_boe:SetChecked(true)
CB_bind_boe:SetScript(
    'OnClick',
    function()
        if FilterList.bindOnEquip then
            FilterList.bindOnEquip = false
        else
            FilterList.bindOnEquip = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_use = CreateFrame('CheckButton', 'CB_bind_use', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_bind_use:ClearAllPoints()
CB_bind_use:SetPoint('BOTTOM', CB_bind_boe, 0, -SizeList.checkboxFilterGapY)
CB_bind_use:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_use.text:SetText('  Bind on Use')
CB_bind_use.text:SetFontObject(FontFilter)
CB_bind_use:SetChecked(true)
CB_bind_use:SetScript(
    'OnClick',
    function()
        if FilterList.bindOnUse then
            FilterList.bindOnUse = false
        else
            FilterList.bindOnUse = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_quest = CreateFrame('CheckButton', 'CB_bind_quest', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_bind_quest:ClearAllPoints()
CB_bind_quest:SetPoint('BOTTOM', CB_bind_use, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_bind_quest:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_quest.text:SetText('  Quest Items')
CB_bind_quest.text:SetFontObject(FontFilter)
CB_bind_quest:SetChecked(true)
CB_bind_quest:SetScript(
    'OnClick',
    function()
        if FilterList.bindOnQuest then
            FilterList.bindOnQuest = false
        else
            FilterList.bindOnQuest = true
        end
        updateListBasedOnPanel()
    end
)

-- ===========================         other items          ===========================
local CB_otherMounts = CreateFrame('CheckButton', 'CB_otherMounts', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_otherMounts:ClearAllPoints()
CB_otherMounts:SetPoint('BOTTOM', CB_bind_bop, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_otherMounts:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_otherMounts.text:SetText('  Mounts')
CB_otherMounts.text:SetFontObject(FontFilter)
CB_otherMounts:SetChecked(true)
CB_otherMounts:SetScript(
    'OnClick',
    function()
        if FilterList.otherMounts then
            FilterList.otherMounts = false
        else
            FilterList.otherMounts = true
        end
        updateListBasedOnPanel()
    end
)

local CB_otherPets = CreateFrame('CheckButton', 'CB_otherPets', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_otherPets:ClearAllPoints()
CB_otherPets:SetPoint('BOTTOM', CB_otherMounts, 0, -SizeList.checkboxFilterGapY)
CB_otherPets:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_otherPets.text:SetText('  Pets')
CB_otherPets.text:SetFontObject(FontFilter)
CB_otherPets:SetChecked(true)
CB_otherPets:SetScript(
    'OnClick',
    function()
        if FilterList.otherPets then
            FilterList.otherPets = false
        else
            FilterList.otherPets = true
        end
        updateListBasedOnPanel()
    end
)

local CB_otherBags = CreateFrame('CheckButton', 'CB_otherBags', AardvarkFilterOptionsPanel, 'UICheckButtonTemplate')
CB_otherBags:ClearAllPoints()
CB_otherBags:SetPoint('BOTTOM', CB_otherPets, 0, -SizeList.checkboxFilterGapY)
CB_otherBags:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_otherBags.text:SetText('  Bags')
CB_otherBags.text:SetFontObject(FontFilter)
CB_otherBags:SetChecked(true)
CB_otherBags:SetScript(
    'OnClick',
    function()
        if FilterList.otherBags then
            FilterList.otherBags = false
        else
            FilterList.otherBags = true
        end
        updateListBasedOnPanel()
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         special add panel          ===========================
-- ===================================================================================================
-- ===================================================================================================

local AardvarkSpecialAddPanel = CreateFrame('Frame', 'AardvarkSpecialAddPanel', AardvarkSideOptionsFrame)
AardvarkSpecialAddPanel:SetSize(SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2, SizeList.mainFrameHeight)
AardvarkSpecialAddPanel:SetPoint('TOP', AardvarkSideOptionsFrame, 'TOP', SizeList.mainFrameMarginGap)
AardvarkSpecialAddPanel:Hide()

-- special add panel title
local AardvarkSpecialAddPanelTitle = CreateFrame('Frame', 'AardvarkSpecialAddPanelTitle', AardvarkSpecialAddPanel)
AardvarkSpecialAddPanelTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSpecialAddPanelTitle:SetPoint('TOP', AardvarkSpecialAddPanel, 0, -SizeList.mainPanelElementGap * 1.5)
AardvarkSpecialAddPanelTitleText = AardvarkSpecialAddPanelTitle:CreateFontString('AardvarkSpecialAddPanelTitleText')
AardvarkSpecialAddPanelTitleText:SetPoint('CENTER', 0, 0)
AardvarkSpecialAddPanelTitleText:SetJustifyH('CENTER')
AardvarkSpecialAddPanelTitleText:SetJustifyV('CENTER')
AardvarkSpecialAddPanelTitleText:SetAllPoints(AardvarkSpecialAddPanelTitle)
AardvarkSpecialAddPanelTitleText:SetFontObject(FontCheckBoxBig)
AardvarkSpecialAddPanelTitleText:SetText(ColourList.textBlue .. 'Special Add Page')

-- special add item by ID title
local AardvarkSpecialAddItemByIDTitle = CreateFrame('Frame', 'AardvarkSpecialAddItemByIDTitle', AardvarkSpecialAddPanel)
AardvarkSpecialAddItemByIDTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSpecialAddItemByIDTitle:SetPoint('TOP', AardvarkSpecialAddPanelTitle, 0, -SizeList.mainPanelElementGap * 4)
AardvarkSpecialAddItemByIDTitleText =
    AardvarkSpecialAddItemByIDTitle:CreateFontString('AardvarkSpecialAddItemByIDTitleText')
AardvarkSpecialAddItemByIDTitleText:SetPoint('CENTER', 0, 0)
AardvarkSpecialAddItemByIDTitleText:SetFontObject(FontFilter)
AardvarkSpecialAddItemByIDTitleText:SetText('Enter Item ID')

-- item ID text outline border
AardvarkSpecialAddOutlineBorderFrame =
    CreateFrame(
    'Frame',
    'AardvarkSpecialAddOutlineBorderFrame',
    AardvarkSpecialAddPanel,
    'TooltipBorderedFrameTemplate'
)
AardvarkSpecialAddOutlineBorderFrame:SetPoint(
    'CENTER',
    AardvarkSpecialAddItemByIDTitle,
    'CENTER',
    0,
    SizeList.scrollTitlePointY * 2
)
AardvarkSpecialAddOutlineBorderFrame:SetSize(135, 30)
AardvarkSpecialAddOutlineBorderFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSpecialAddOutlineBorderFrame:SetBackdropBorderColor(0, 1, 1, 1)

-- item ID text box
AardvarkSpecialAddTextBox =
    CreateFrame('EditBox', 'AardvarkSpecialAddTextBox', AardvarkSpecialAddPanel, 'AutoCompleteEditBoxTemplate')
AardvarkSpecialAddTextBox:SetPoint('CENTER', AardvarkSpecialAddOutlineBorderFrame, 'CENTER', 2, 0)
AardvarkSpecialAddTextBox:SetFontObject(FontContent)
AardvarkSpecialAddTextBox:SetText('')
AardvarkSpecialAddTextBox:SetNumeric(true)
AardvarkSpecialAddTextBox:SetSize(110, 20)
AardvarkSpecialAddTextBox:SetScale(1.1)
AardvarkSpecialAddTextBox:SetAutoFocus(false)
AardvarkSpecialAddTextBox:SetMaxLetters(15)

-- ===================================================================================================
-- special add global destroy button
AardvarkSpecialAddItemDestroyGlobalButton =
    CreateFrame('Button', 'AardvarkSpecialAddItemDestroyGlobalButton', AardvarkSpecialAddPanel)
AardvarkSpecialAddItemDestroyGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemDestroyGlobalButton:SetPoint(
    'BOTTOM',
    AardvarkSpecialAddTextBox,
    0,
    SizeList.scrollTitlePointY * 6
)
AardvarkSpecialAddItemDestroyGlobalButton:SetNormalTexture(ImageList.destroyGlobal)
AardvarkSpecialAddItemDestroyGlobalButton:SetHighlightTexture(ImageList.destroyGlobalHover, 'BLEND')
AardvarkSpecialAddItemDestroyGlobalButton:SetScript('OnReceiveDrag', addItemToGlobalList)
AardvarkSpecialAddItemDestroyGlobalButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
            if checkItemOnGlobalDestroyList(cursorItemID) then
                if AVKGlobalSettings.Destroy.dialfm then
                    print(
                        ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global destroy list.'
                    )
                end
            else
                addItemToList(AVKGlobalDestroyTable, cursorItemID)
                if not AardvarkDestroyPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationDestroyButton)
                else
                    avkUpdateGlobalDestroyList()
                end
                if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textRed .. ' added to your global destroy list.'
                    )
                end
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local itemName, itemLink = GetItemInfo(textItemID)
            print('click itemID', textItemID) -- debug --
            C_Timer.After(
                1,
                function(self)
                    if checkItemOnGlobalDestroyList(textItemID) then
                        if AVKGlobalSettings.Destroy.dialfm then
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ' is already on your global destroy list.'
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    else
                        addItemToList(AVKGlobalDestroyTable, textItemID)
                        if not AardvarkDestroyPanel:IsVisible() then
                            toggleAVKPanels(AardvarkNavigationDestroyButton)
                        else
                            avkUpdateGlobalDestroyList()
                        end
                        if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ColourList.textRed .. ' added to your global destroy list.'
                            )
                        end
                    end
                end
            )
        end
        ClearCursor()
    end
)

-- ===================================================================================================
-- special add character destroy button
AardvarkSpecialAddItemDestroyCharacterButton =
    CreateFrame('Button', 'AardvarkSpecialAddItemDestroyCharacterButton', AardvarkSpecialAddPanel)
AardvarkSpecialAddItemDestroyCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemDestroyCharacterButton:SetPoint(
    'BOTTOM',
    AardvarkSpecialAddItemDestroyGlobalButton,
    0,
    SizeList.scrollTitlePointY * 5
)
AardvarkSpecialAddItemDestroyCharacterButton:SetNormalTexture(ImageList.destroyCharacter)
AardvarkSpecialAddItemDestroyCharacterButton:SetHighlightTexture(ImageList.destroyCharacterHover, 'BLEND')
AardvarkSpecialAddItemDestroyCharacterButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
            if checkItemOnGlobalDestroyList(cursorItemID) then
                if AVKGlobalSettings.Destroy.dialfm then
                    print(
                        ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global destroy list.'
                    )
                end
            elseif checkItemOnCharacterDestroyList(cursorItemID) then
                if AVKGlobalSettings.Destroy.dialfm then
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ' is already on ' .. playerName .. "'s destroy list."
                    )
                end
            else
                addItemToList(AVKCharacterDestroyTable, cursorItemID)
                if not AardvarkDestroyPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationDestroyButton)
                else
                    avkUpdateCharacterDestroyList()
                end
                if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textRed .. ' added to ' .. playerName .. "'s destroy list."
                    )
                end
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local itemName, itemLink = GetItemInfo(textItemID)
            print('click itemID', textItemID) -- debug --
            C_Timer.After(
                1,
                function(self)
                    if checkItemOnGlobalDestroyList(textItemID) then
                        if AVKGlobalSettings.Destroy.dialfm then
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ' is already on your global destroy list.'
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    elseif checkItemOnCharacterDestroyList(textItemID) then
                        if AVKGlobalSettings.Destroy.dialfm then
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ' is already on ' .. playerName .. "'s destroy list."
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    else
                        addItemToList(AVKCharacterDestroyTable, textItemID)
                        if not AardvarkDestroyPanel:IsVisible() then
                            toggleAVKPanels(AardvarkNavigationDestroyButton)
                        else
                            avkUpdateCharacterDestroyList()
                        end
                        if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ColourList.textRed .. ' added to ' .. playerName .. "'s destroy list."
                            )
                        end
                    end
                end
            )
        end
        ClearCursor()
    end
)

-- ===================================================================================================
-- special add global sell button
AardvarkSpecialAddItemSellGlobalButton =
    CreateFrame('Button', 'AardvarkSpecialAddItemSellGlobalButton', AardvarkSpecialAddPanel)
AardvarkSpecialAddItemSellGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemSellGlobalButton:SetPoint(
    'LEFT',
    AardvarkSpecialAddItemDestroyGlobalButton,
    SizeList.scrollTitlePointY * 5,
    0
)
AardvarkSpecialAddItemSellGlobalButton:SetNormalTexture(ImageList.sellGlobal)
AardvarkSpecialAddItemSellGlobalButton:SetHighlightTexture(ImageList.sellGlobalHover, 'BLEND')
AardvarkSpecialAddItemSellGlobalButton:SetScript('OnReceiveDrag', addItemToGlobalList)
AardvarkSpecialAddItemSellGlobalButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
            if checkItemOnGlobalSellList(cursorItemID) then
                if AVKGlobalSettings.Sell.sialfm then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global sell list.')
                end
            else
                addItemToList(AVKGlobalSellTable, cursorItemID)
                if not AardvarkSellPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationSellButton)
                else
                    avkUpdateGlobalSellList()
                end
                if AVKGlobalSettings.Sell.sialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textGreen .. ' added to your global sell list.'
                    )
                end
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local itemName, itemLink = GetItemInfo(textItemID)
            print('click itemID', textItemID) -- debug --
            C_Timer.After(
                1,
                function(self)
                    if checkItemOnGlobalSellList(textItemID) then
                        if AVKGlobalSettings.Sell.sialfm then
                            print(
                                ColourList.textBluePrefixSuffix .. itemLink .. ' is already on your global sell list.'
                            )
                        end
                        AardvarkSpecialAddTextBox:SetText('')
                    else
                        addItemToList(AVKGlobalSellTable, textItemID)
                        if not AardvarkSellPanel:IsVisible() then
                            toggleAVKPanels(AardvarkNavigationSellButton)
                        else
                            avkUpdateGlobalSellList()
                        end
                        if AVKGlobalSettings.Sell.sialsm then -- Print item added to list message
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ColourList.textGreen .. ' added to your global sell list.'
                            )
                        end
                    end
                end
            )
        end
        ClearCursor()
    end
)

-- ===================================================================================================
-- special add character sell button
AardvarkSpecialAddItemSellCharacterButton =
    CreateFrame('Button', 'AardvarkSpecialAddItemSellCharacterButton', AardvarkSpecialAddPanel)
AardvarkSpecialAddItemSellCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemSellCharacterButton:SetPoint(
    'BOTTOM',
    AardvarkSpecialAddItemSellGlobalButton,
    0,
    SizeList.scrollTitlePointY * 5
)
AardvarkSpecialAddItemSellCharacterButton:SetNormalTexture(ImageList.sellCharacter)
AardvarkSpecialAddItemSellCharacterButton:SetHighlightTexture(ImageList.sellCharacterHover, 'BLEND')
AardvarkSpecialAddItemSellCharacterButton:SetScript('OnReceiveDrag', addItemToCharacterList)
AardvarkSpecialAddItemSellCharacterButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
            if checkItemOnGlobalSellList(cursorItemID) then
                if AVKGlobalSettings.Sell.sialfm then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global sell list.')
                end
            elseif checkItemOnCharacterSellList(cursorItemID) then
                if AVKGlobalSettings.Sell.sialfm then
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ' is already on ' .. playerName .. "'s sell list."
                    )
                end
            else
                addItemToList(AVKCharacterSellTable, cursorItemID)
                if not AardvarkSellPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationSellButton)
                else
                    avkUpdateCharacterSellList()
                end
                if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textRed .. ' added to ' .. playerName .. "'s destroy list."
                    )
                end
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local itemName, itemLink = GetItemInfo(textItemID)
            print('click itemID', textItemID) -- debug --
            C_Timer.After(
                1,
                function(self)
                    if checkItemOnGlobalSellList(textItemID) then
                        if AVKGlobalSettings.Sell.sialfm then
                            print(
                                ColourList.textBluePrefixSuffix .. itemLink .. ' is already on your global sell list.'
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    elseif checkItemOnCharacterSellList(textItemID) then
                        if AVKGlobalSettings.Sell.sialfm then
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ' is already on ' .. playerName .. "'s sell list."
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    else
                        addItemToList(AVKCharacterSellTable, textItemID)
                        if not AardvarkSellPanel:IsVisible() then
                            toggleAVKPanels(AardvarkNavigationSellButton)
                        else
                            avkUpdateCharacterSellList()
                        end
                        if AVKGlobalSettings.Destroy.dialsm then -- Print item added to list message
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ColourList.textRed .. ' added to ' .. playerName .. "'s destroy list."
                            )
                        end
                    end
                end
            )
        end
        ClearCursor()
    end
)

-- ===================================================================================================
-- special add global protect button
AardvarkSpecialAddItemProtectGlobalButton =
    CreateFrame('Button', 'AardvarkSpecialAddItemProtectGlobalButton', AardvarkSpecialAddPanel)
AardvarkSpecialAddItemProtectGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemProtectGlobalButton:SetPoint(
    'RIGHT',
    AardvarkSpecialAddItemDestroyGlobalButton,
    -SizeList.scrollTitlePointY * 5,
    0
)
AardvarkSpecialAddItemProtectGlobalButton:SetNormalTexture(ImageList.protectGlobal)
AardvarkSpecialAddItemProtectGlobalButton:SetHighlightTexture(ImageList.protectGlobalHover, 'BLEND')
AardvarkSpecialAddItemProtectGlobalButton:SetScript('OnReceiveDrag', addItemToGlobalList)
AardvarkSpecialAddItemProtectGlobalButton:SetNormalTexture(ImageList.protectGlobal)
AardvarkSpecialAddItemProtectGlobalButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
            if checkItemOnGlobalProtectList(cursorItemID) then
                if AVKGlobalSettings.Protect.pialsm then
                    print(
                        ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global protect list.'
                    )
                end
            else
                addItemToList(AVKGlobalProtectTable, cursorItemID)
                if not AardvarkProtectPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationProtectButton)
                else
                    avkUpdateGlobalProtectList()
                end
                if AVKGlobalSettings.Protect.pialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textOrange .. ' added to your global protect list.'
                    )
                end
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local itemName, itemLink = GetItemInfo(textItemID)
            print('click itemID', textItemID) -- debug --
            C_Timer.After(
                1,
                function(self)
                    if checkItemOnGlobalProtectList(textItemID) then
                        if AVKGlobalSettings.Protect.pialsm then -- Print item added to list message
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ColourList.textOrange .. ' added to your global protect list.'
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    else
                        addItemToList(AVKGlobalProtectTable, textItemID)
                        if not AardvarkProtectPanel:IsVisible() then
                            toggleAVKPanels(AardvarkNavigationProtectButton)
                        else
                            avkUpdateGlobalProtectList()
                        end
                        if AVKGlobalSettings.Sell.sialsm then -- Print item added to list message
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ColourList.textGreen .. ' added to your global sell list.'
                            )
                        end
                    end
                end
            )
        end
        ClearCursor()
    end
)

-- ===================================================================================================
-- special add character protect button
AardvarkSpecialAddItemProtectCharacterButton =
    CreateFrame('Button', 'AardvarkSpecialAddItemProtectCharacterButton', AardvarkSpecialAddPanel)
AardvarkSpecialAddItemProtectCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemProtectCharacterButton:SetPoint(
    'BOTTOM',
    AardvarkSpecialAddItemProtectGlobalButton,
    0,
    SizeList.scrollTitlePointY * 5
)
AardvarkSpecialAddItemProtectCharacterButton:SetNormalTexture(ImageList.protectCharacter)
AardvarkSpecialAddItemProtectCharacterButton:SetHighlightTexture(ImageList.protectCharacterHover, 'BLEND')
AardvarkSpecialAddItemProtectCharacterButton:SetScript('OnReceiveDrag', addItemToCharacterList)
AardvarkSpecialAddItemProtectCharacterButton:SetScript(
    'OnClick',
    function(self, button)
        if GetCursorInfo() then
            cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
            if checkItemOnGlobalProtectList(cursorItemID) then
                if AVKGlobalSettings.Protect.pialsm then
                    print(
                        ColourList.textBluePrefixSuffix .. cursorItemLink .. ' is already on your global protect list.'
                    )
                end
            elseif checkItemOnCharacterProtectList(cursorItemID) then
                if AVKGlobalSettings.Protect.pialsm then
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ' is already on ' .. playerName .. "'s protect list."
                    )
                end
            else
                addItemToList(AVKCharacterProtectTable, cursorItemID)
                if not AardvarkProtectPanel:IsVisible() then
                    toggleAVKPanels(AardvarkNavigationProtectButton)
                else
                    avkUpdateCharacterProtectList()
                end
                if AVKGlobalSettings.Protect.pialsm then -- Print item added to list message
                    print(
                        ColourList.textBluePrefixSuffix ..
                            cursorItemLink .. ColourList.textOrange .. ' added to ' .. playerName .. "'s protect list."
                    )
                end
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local itemName, itemLink = GetItemInfo(textItemID)
            print('click itemID', textItemID) -- debug --
            C_Timer.After(
                1,
                function(self)
                    if checkItemOnGlobalProtectList(textItemID) then
                        if AVKGlobalSettings.Protect.pialsm then
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ' is already on your global protect list.'
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    elseif checkItemOnCharacterProtectList(textItemID) then
                        if AVKGlobalSettings.Protect.pialsm then
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink .. ' is already on ' .. playerName .. "'s protect list."
                            )
                            AardvarkSpecialAddTextBox:SetText('')
                        end
                    else
                        addItemToList(AVKCharacterProtectTable, textItemID)
                        if not AardvarkProtectPanel:IsVisible() then
                            toggleAVKPanels(AardvarkNavigationProtectButton)
                        else
                            avkUpdateCharacterProtectList()
                        end
                        if AVKGlobalSettings.Protect.pialsm then -- Print item added to list message
                            print(
                                ColourList.textBluePrefixSuffix ..
                                    itemLink ..
                                        ColourList.textOrange .. ' added to ' .. playerName .. "'s protect list."
                            )
                        end
                    end
                end
            )
        end
        ClearCursor()
    end
)
